@ECHO OFF

SET VisualStudioVersion="auto"
SET VisualStudioPath=""
SET SolutionConfiguration="auto"

REM ***************************************************************************
REM Check if Microsoft Visual Studio version was specified                    *
REM ***************************************************************************

IF "%1" == "2005" (
	SET VisualStudioVersion="8.0"
)
IF "%1" == "VS2005" (
	SET VisualStudioVersion="8.0"
)
IF "%1" == "8" (
	SET VisualStudioVersion="8.0"
)

IF "%1" == "2008" (
	SET VisualStudioVersion="9.0"
)
IF "%1" == "VS2008" (
	SET VisualStudioVersion="9.0"
)
IF "%1" == "9" (
	SET VisualStudioVersion="9.0"
)

IF %VisualStudioVersion% == "auto" (
	IF NOT "%1" == "" (
		ECHO Invalid Microsoft Visual Studio version.
		EXIT /B
	)
)

IF "%2" == "Release" (
	SET SolutionConfiguration="Release"
)

IF "%2" == "Debug" (
	SET SolutionConfiguration="Debug"
)

IF %SolutionConfiguration% == "auto" (
	IF NOT "%2" == "" (
		ECHO Invalid solution configuration.
		EXIT /B
	)

	SET SolutionConfiguration="Release"
)

IF NOT "%VS80COMNTOOLS%" == "" (
	SET VisualStudioPath80="%VS80COMNTOOLS%..\IDE\devenv.exe"
)

IF NOT "%VS90COMNTOOLS%" == "" (
	SET VisualStudioPath90="%VS90COMNTOOLS%..\IDE\devenv.exe"
)

IF %VisualStudioVersion% == "auto" (
	IF NOT %VisualStudioPath90% == "" (
		SET VisualStudioVersion="9.0"
	)
)

IF %VisualStudioVersion% == "auto" (
	IF NOT %VisualStudioPath80% == "" (
		SET VisualStudioVersion="8.0"
	)
)

IF %VisualStudioVersion% == "8.0" (
	IF %VisualStudioPath80% == "" (
		ECHO Microsoft Visual Studio 2005 was not found.
		EXIT /B
	)

	SET VisualStudioPath=%VisualStudioPath80%
	ECHO Using Microsoft Visual Studio 2005.
)

IF %VisualStudioVersion% == "9.0" (
	IF %VisualStudioPath90% == "" (
		ECHO Microsoft Visual Studio 2008 was not found.
		EXIT /B
	)

	SET VisualStudioPath=%VisualStudioPath90%
	ECHO Using Microsoft Visual Studio 2008.
)

ECHO Building %SolutionConfiguration%.

IF %VisualStudioPath% == "" (
		ECHO Unexpected Misconfiguration.
		EXIT /B
)

PUSHD "..\Source"

IF %VisualStudioVersion% == "8.0" (
	%VisualStudioPath% Nabu.FF.2005.sln /Rebuild Release
)

IF %VisualStudioVersion% == "9.0" (
	%VisualStudioPath% Nabu.FF.2008.sln /Rebuild Release
	%VisualStudioPath% Nabu.CF.WM4.2008.sln /Rebuild Release
)

POPD

PAUSE