﻿using System.Windows.Forms;

using Nabu.Forms.Html;
using System;

namespace HtmlAccessKeysExample
{
	public partial class MainForm : HtmlForm
	{
		public MainForm()
		{
			InitializeComponent();

			base.Html =
@"
<html>
	<head>
		<style>
			widget[type='button']
			{
				font-size: xx-small;
				text-align: center;
			}
			popup:hover
			{
				background-color: red;
			}
		</style>
	</head>
	<body>
		<input type='text'/>
		<input type='date'/>
		<table width='100%%'>
			<tr>
				<td><widget type='button' value='1' accesskey='1'/></td>
				<td><widget type='button' value='Up' accesskey='Up'/></td>
				<td><widget type='button' value='3' accesskey='3'/></td>
			</tr>
			<tr>
				<td><widget type='button' value='Left' accesskey='Left'/></td>
				<td><widget type='button' value='5' accesskey='5'/></td>
				<td><widget type='button' value='Right' accesskey='Right'/></td>
			</tr>
			<tr>
				<td><widget type='button' value='7' accesskey='7'/></td>
				<td><widget type='button' value='Down' accesskey='Down'/></td>
				<td><widget type='button' value='9' accesskey='9'/></td>
			</tr>
		</table>
	</body>
</html>";
		}

		private void Button_BehaviorEvent(
			object sender,
			HtmlBehaviorEventArgs e)
		{
			if (e.Command == HtmlBehaviorEventCommand.ButtonClick)
			{
				using (HtmlTag source = e.Source)
				{
					MessageBox.Show(source.InnerText, "Click");
				}

				e.IsHandled = true;
			}
		}

		EventHandler<HtmlBehaviorEventArgs> handler;

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			handler = new EventHandler<HtmlBehaviorEventArgs>(Button_BehaviorEvent);

			base.Subscribe("widget[type='button']", handler);
		}
	}
}