﻿using System;
using System.Windows.Forms;

using Nabu.Forms.Html;

namespace HtmlAccessKeysExample
{
	public partial class MainForm : HtmlForm
	{
		public MainForm()
		{
			InitializeComponent();
		}

		private void Button_BehaviorEvent(
			object sender,
			HtmlBehaviorEventArgs e)
		{
			if (e.Command == HtmlBehaviorEventCommand.ButtonClick)
			{
				using (HtmlTag source = e.Source)
				{
					MessageBox.Show(this, source.InnerText, "Click");
				}

				e.IsHandled = true;
			}
		}

		private void MainForm_Load(object sender, EventArgs e)
		{
			base.Subscribe("widget[type='button']", Button_BehaviorEvent);
		}
	}
}