﻿using System;
using System.IO;
using System.Windows.Forms;

namespace HtmlBrowseExample
{
	public partial class MainForm : Form
	{
		#region Fields

		private Uri _documentUri;

		#endregion

		#region Methods

		public MainForm()
		{
			InitializeComponent();
		}

		private void MenuItemFileOpen_Click(object sender, EventArgs e)
		{
			if (this._openFileDialog.ShowDialog(this) == DialogResult.OK)
			{
				this._documentUri = new Uri(this._openFileDialog.FileName);
				this._htmlView.BaseUrl = new Uri(Path.GetDirectoryName(this._openFileDialog.FileName) + Path.DirectorySeparatorChar);
				this._htmlView.LoadHtml(this._documentUri);
			}
		}

		private void MenuItemFileExit_Click(object sender, EventArgs e)
		{
			base.Close();
		}

		private void MenuItemViewRefresh_Click(object sender, EventArgs e)
		{
			if (this._documentUri != null)
			{
				this._htmlView.LoadHtml(this._documentUri);
			}
		}

		#endregion
	}
}
