﻿using System.ComponentModel;
using System.Diagnostics;

using Nabu.Forms.Html;

namespace HtmlCustomHyperLinkExample
{
	public sealed class CustomHtmlView : HtmlView
	{
		#region Fields

		private IHtmlHostNotificationHandler _notificationHandler;

		#endregion

		#region Methods

		public CustomHtmlView()
		{
		}

		public CustomHtmlView(IContainer container)
			: base(container)
		{
		}

		#endregion

		#region Properties

		public override IHtmlHostNotificationHandler NotificationHandler
		{
			[DebuggerStepThrough]
			get
			{
				if (this._notificationHandler == null)
				{
					this._notificationHandler = new CustomHtmlWindowNotificationHandler(this);
				}

				return this._notificationHandler;
			}
		}

		#endregion
	}
}
