﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Nabu.Collections;
using Nabu.Forms.Html;

namespace HtmlEmbeddingExample
{
	public partial class MainForm : HtmlForm
	{
		public MainForm()
		{
			InitializeComponent();
		}

		private void MainForm_Shown(object sender, EventArgs e)
		{
			using (HtmlTag tag = base.RootTag.SelectFirst("[id='datetimepicker']"))
			{
				if (tag != null)
				{
					IntPtr hWindow = tag.GetWindow(false);

					if (hWindow != IntPtr.Zero)
					{
						Control control = Control.FromHandle(hWindow);

						if (control != null)
						{
							DateTimePicker dateTimePicker = (DateTimePicker)control;

							dateTimePicker.ValueChanged += new EventHandler(DateTimePicker_ValueChanged);
						}
					}
				}
			}
		}

		private void DateTimePicker_ValueChanged(object sender, EventArgs e)
		{
			MessageBox.Show(((DateTimePicker)sender).Value.ToString());
		}
	}
}
