﻿using System;
using System.Drawing.Printing;
using System.IO;
using System.Windows.Forms;

using Nabu.Forms.Html;

namespace HtmlPrintExample
{
	public partial class MainForm : Form
	{
		private HtmlPrintHelper<HtmlPrinter> _htmlPrinter = new HtmlPrintHelper<HtmlPrinter>();

		public MainForm()
		{
			InitializeComponent();
		}

		private void MenuItemFileOpen_Click(object sender, EventArgs e)
		{
			if (this._openFileDialog.ShowDialog(this) == DialogResult.OK)
			{
				this._htmlPrinter.BaseUrl = new Uri(Path.GetDirectoryName(this._openFileDialog.FileName));
				this._htmlPrinter.LoadHtml(new Uri("file://" + this._openFileDialog.FileName));
				this._printPreview.InvalidatePreview();
			}
		}

		private void MenuItemFilePageSetup_Click(object sender, EventArgs e)
		{
			if (this._pageSetupDialog.ShowDialog(this) == DialogResult.OK)
			{
				this._printPreview.InvalidatePreview();
			}
		}

		private void MenuItemFilePrintPreview_Click(object sender, EventArgs e)
		{
			this._printPreviewDialog.ShowDialog(this);
		}

		private void MenuItemFilePrint_Click(object sender, EventArgs e)
		{
			if (this._printDialog.ShowDialog(this) == DialogResult.OK)
			{
				this._printDocument.Print();
			}
		}

		private void MeniItemFileExit_Click(object sender, EventArgs e)
		{
			base.Close();
		}

		private void PrintDocument_BeginPrint(object sender, PrintEventArgs e)
		{
			this._htmlPrinter.BeginPrint(sender, e);
		}

		private void PrintDocument_EndPrint(object sender, PrintEventArgs e)
		{
			this._htmlPrinter.EndPrint(sender, e);
		}

		private void PrintDocument_PrintPage(object sender, PrintPageEventArgs e)
		{
			this._htmlPrinter.PrintPage(sender, e);
		}
	}
}