﻿using System;
using System.Windows.Forms;

using Nabu.Forms.Html;

namespace HtmlTabExample
{
	public partial class MainForm : Form
	{
		public MainForm()
		{
			InitializeComponent();
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);
			this._htmlView.Subscribe("input[type='button']", HtmlButton_Click);
		}

		private void HtmlButton_Click(object sender, HtmlBehaviorEventArgs e)
		{
			if (e.Command == HtmlBehaviorEventCommand.ButtonClick)
			{
				MessageBox.Show(e.Source.InnerText);
			}
		}

		private void ButtonFirst_Click(object sender, EventArgs e)
		{
			using (HtmlTag root = this._htmlView.RootTag)
			{
				using (HtmlTag tabHeader = root.SelectFirst("[tab-header-id='1']"))
				{
					using (HtmlButton button = new HtmlButton(tabHeader))
					{
						button.PerformClick();
					}
				}
			}
		}

		private void ButtonSecond_Click(object sender, EventArgs e)
		{
			using (HtmlTag root = this._htmlView.RootTag)
			{
				using (HtmlTag tabHeader = root.SelectFirst("[tab-header-id='2']"))
				{
					using (HtmlButton button = new HtmlButton(tabHeader))
					{
						button.PerformClick();
					}
				}
			}
		}

		private void ButtonThird_Click(object sender, EventArgs e)
		{
			using (HtmlTag root = this._htmlView.RootTag)
			{
				using (HtmlTag tabHeader = root.SelectFirst("[tab-header-id='3']"))
				{
					using (HtmlButton button = new HtmlButton(tabHeader))
					{
						button.PerformClick();
					}
				}
			}
		}

		private void ButtonFourth_Click(object sender, EventArgs e)
		{
			using (HtmlTag root = this._htmlView.RootTag)
			{
				using (HtmlTag tabHeader = root.SelectFirst("[tab-header-id='4']"))
				{
					using (HtmlButton button = new HtmlButton(tabHeader))
					{
						button.PerformClick();
					}
				}
			}
		}
	}
}