﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HtmlVirtualTreeListExample
{
	public class FileDescriptor
	{
		private string _name;
		private int _size;
		private DateTime _creationTime;
		private DateTime _modificationTime;
		private DateTime _accessTime;

		public FileDescriptor(
			string name,
			int size,
			DateTime creationTime,
			DateTime modificationTime,
			DateTime accessTime)
		{
			this._name = name;
			this._size = size;
			this._creationTime = creationTime;
			this._modificationTime = modificationTime;
			this._accessTime = accessTime;
		}

		public FileDescriptor(
			string name)
		{
			this._name = name;
			this._size = 0;
			this._creationTime = DateTime.MinValue;
			this._modificationTime = DateTime.MinValue;
			this._accessTime = DateTime.MinValue;
		}

		public string Name
		{
			get { return this._name; }
			set { this._name = value; }
		}

		public int Size
		{
			get { return this._size; }
			set { this._size = value; }
		}

		public DateTime CreationTime
		{
			get { return this._creationTime; }
			set { this._creationTime = value; }
		}

		public DateTime ModificationTime
		{
			get { return this._modificationTime; }
			set { this._modificationTime = value; }
		}

		public DateTime AccessTime
		{
			get { return this._accessTime; }
			set { this._accessTime = value; }
		}
	}
}
