﻿using System;
using System.Net;

using Nabu.Net;

namespace SysLogClientExample
{
	internal sealed class SysLogClientCallback : ISysLogClientCallback<UdpClientSocket>
	{
		#region SysLogClientCallback

		#region Fields

		private bool _isFirstTime = true;

		#endregion

		#region SysLogClientCallback

		public SysLogClientCallback()
		{
		}

		#endregion

		#endregion

		#region ISysLogClientCallback

		#region ISysLogClientCallback

		public bool GetMessage(
			out IPEndPoint endPoint,
			out SysLogFacility facility,
			out SysLogSeverity severity,
			out DateTime timestamp,
			out string hostname,
			out string message)
		{
			endPoint = new IPEndPoint(IPAddress.Loopback, 514);
			facility = SysLogFacility.Local0;
			severity = SysLogSeverity.Debug;
			timestamp = DateTime.Now;
			hostname = "source-host";
			message = "log-message";

			if (this._isFirstTime)
			{
				this._isFirstTime = false;
				return true;
			}
			else
			{
				return false;
			}
		}

		#endregion

		#region IUdpNodeCallback

		public void OnOpenSession(SysLogClientSession<UdpClientSocket> session)
		{
			Console.WriteLine("CONNECTED.");
		}

		public void OnCloseSession(SysLogClientSession<UdpClientSocket> session)
		{
			Console.WriteLine("DISCONNECTED.");
		}

		#endregion

		#endregion
	}

	public sealed class Program
	{
		public static void Main(string[] args)
		{
			SysLogClient sysLogClient = new SysLogClient(new SysLogClientCallback());

			sysLogClient.OpenSession(null);

			Console.WriteLine("Press any key to exit...");
			Console.ReadKey();
		}
	}
}
