﻿using System.Xml.Serialization;

namespace RegExTracer
{
	[XmlRoot(ElementName = "regex_document")]
	public sealed class RegExDocument
	{
		private string _regexValue;
		private string _inputValue;
		private int _inputLineBreak;
		private bool _optionECMAScript;
		private bool _optionSingleLine;
		private bool _optionExplicitCapture;
		private bool _optionIgnoreCase;
		private bool _optionRightToLeft;
		private bool _optionMultiline;
		private bool _optionCultureInvariant;
		private bool _optionIgnoreWhitespace;

		public RegExDocument()
		{
		}

		public RegExDocument(
			string regexValue,
			string inputValue,
			int inputLineBreak,
			bool optionECMAScript,
			bool optionSingleLine,
			bool optionExplicitCapture,
			bool optionIgnoreCase,
			bool optionRightToLeft,
			bool optionMultiline,
			bool optionCultureInvariant,
			bool optionIgnoreWhitespace)
		{
			this._regexValue = regexValue;
			this._inputValue = inputValue;
			this._inputLineBreak = inputLineBreak;
			this._optionECMAScript = optionECMAScript;
			this._optionSingleLine = optionSingleLine;
			this._optionExplicitCapture = optionExplicitCapture;
			this._optionIgnoreCase = optionIgnoreCase;
			this._optionRightToLeft = optionRightToLeft;
			this._optionMultiline = optionMultiline;
			this._optionCultureInvariant = optionCultureInvariant;
			this._optionIgnoreWhitespace = optionIgnoreWhitespace;
		}

		[XmlElement("regex_value")]
		public string RegExValue
		{
			get { return this._regexValue; }
			set { this._regexValue = value; }
		}

		[XmlElement("input_value")]
		public string InputValue
		{
			get { return this._inputValue; }
			set { this._inputValue = value; }
		}

		[XmlElement("input_line_break")]
		public int InputLineBreak
		{
			get { return this._inputLineBreak; }
			set { this._inputLineBreak = value; }
		}

		[XmlElement("option_ecma_script")]
		public bool OptionECMAScript
		{
			get { return this._optionECMAScript; }
			set { this._optionECMAScript = value; }
		}

		[XmlElement("option_single_line")]
		public bool OptionSingleLine
		{
			get { return this._optionSingleLine; }
			set { this._optionSingleLine = value; }
		}

		[XmlElement("option_explicit_capture")]
		public bool OptionExplicitCapture
		{
			get { return this._optionExplicitCapture; }
			set { this._optionExplicitCapture = value; }
		}

		[XmlElement("option_ignore_case")]
		public bool OptionIgnoreCase
		{
			get { return this._optionIgnoreCase; }
			set { this._optionIgnoreCase = value; }
		}

		[XmlElement("option_right_to_left")]
		public bool OptionRightToLeft
		{
			get { return this._optionRightToLeft; }
			set { this._optionRightToLeft = value; }
		}

		[XmlElement("option_multiline")]
		public bool OptionMultiline
		{
			get { return this._optionMultiline; }
			set { this._optionMultiline = value; }
		}

		[XmlElement("option_culture_invariant")]
		public bool OptionCultureInvariant
		{
			get { return this._optionCultureInvariant; }
			set { this._optionCultureInvariant = value; }
		}

		[XmlElement("option_ignore_whitespace")]
		public bool OptionIgnoreWhitespace
		{
			get { return this._optionIgnoreWhitespace; }
			set { this._optionIgnoreWhitespace = value; }
		}
	}
}
