﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Collections Library                      */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.ComponentModel;

namespace Nabu.Collections
{
	public interface IBindingListEx<T> : IListEx<T>
	{
		#region Methods

		void Swap(int index1, int index2);

		#endregion

		#region Properties

		IListEx<T> InnerList { get; }

		#endregion

		#region Events

		event CancelEventHandler Reseting;
		event EventHandler Reseted;
		event EventHandler<BindingListExAddingRemovingEventArgs<T>> Adding;
		event EventHandler<BindingListExAddedRemovedEventArgs<T>> Added;
		event EventHandler<BindingListExAddingRemovingEventArgs<T>> Removing;
		event EventHandler<BindingListExAddedRemovedEventArgs<T>> Removed;
		event EventHandler<BindingListExChangingEventArgs<T>> Changing;
		event EventHandler<BindingListExChangedEventArgs<T>> Changed;
		event EventHandler<BindingListExMovingEventArgs<T>> Moving;
		event EventHandler<BindingListExMovedEventArgs<T>> Moved;

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
