﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Collections Library                      */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Collections
{
	public sealed class BindingTreeDoingEventArgs<T> : EventArgs
	{
		#region Fields

		private ITreeNode<T> _node;
		private bool _cancel;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public BindingTreeDoingEventArgs(ITreeNode<T> node)
		{
			this._node = node;
		}

		#endregion

		#region Properties

		public ITreeNode<T> Node
		{
			[DebuggerStepThrough]
			get { return this._node; }
		}

		public bool Cancel
		{
			[DebuggerStepThrough]
			get { return this._cancel; }
			[DebuggerStepThrough]
			set { this._cancel = value; }
		}

		#endregion
	};

	public sealed class BindingTreeDoneEventArgs<T> : EventArgs
	{
		#region Fields

		private ITreeNode<T> _node;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public BindingTreeDoneEventArgs(ITreeNode<T> node)
		{
			this._node = node;
		}

		#endregion

		#region Properties

		public ITreeNode<T> Node
		{
			[DebuggerStepThrough]
			get { return this._node; }
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
