﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Collections Library                      */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Collections
{
	public interface ITree<T>
	{
		#region Methods

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Preorder();

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Postorder();

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Preorder(bool visibleNodes);

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Postorder(bool visibleNodes);

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Preorder(int offset, int count);

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Postorder(int offset, int count);

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Preorder(int offset, int count, bool visibleNodes);

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<KeyValuePair<ITreeNode<T>, int>> Postorder(int offset, int count, bool visibleNodes);

		int GetCount();

		int GetCount(bool visibleNodes);

		#endregion

		#region Properties

		ITreeNode<T> Root { get; }
		int Count { get; }

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
