﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Collections Library                      */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Collections
{
	public interface ITreeNode<T>
	{
		#region Methods

		ITreeNode<T> AppendChild(T data);
		ITreeNode<T> PrependChild(T data);
		ITreeNode<T> AppendSibling(T data);
		ITreeNode<T> PrependSibling(T data);
		ITreeNode<T> AppendChild(T data, bool collapsed);
		ITreeNode<T> PrependChild(T data, bool collapsed);
		ITreeNode<T> AppendSibling(T data, bool collapsed);
		ITreeNode<T> PrependSibling(T data, bool collapsed);
		void Remove();
		int GetCount(bool visibleNodes);

		#endregion

		#region Properties

		ITreeNode<T> Parent { get; }

		ITreeNode<T> NextSibling { get; }

		ITreeNode<T> PrevSibling { get; }

		ITreeNode<T> FirstChild { get; }

		ITreeNode<T> LastChild { get; }

		[SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures")]
		IEnumerable<ITreeNode<T>> Children { get; }

		T Data { get; set; }

		bool IsCollapsed { get; set; }

		bool IsVisible { get; set; }

		int Count { get; }

		int VisibleCount { get; }

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
