﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Data Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/

namespace Nabu.Data
{
	public sealed class DiffHirschbergBlob : DiffBlobBase
	{
		#region DiffHirschbergBlob

		#region Methods

		public DiffHirschbergBlob(
			byte[] oldContent,
			byte[] newContent)
			: base(oldContent, newContent)
		{
		}

		#endregion

		#endregion

		#region DiffBase<byte>

		protected override void Calculate(
			PatchOperationList<byte> poList,
			int oldContentOffset,
			int oldContentLength,
			int newContentOffset,
			int newContentLength)
		{
			BuildRanges(
				oldContentOffset,
				oldContentLength,
				newContentOffset,
				newContentLength);

			if (base.BlockSize <= 1)
			{
				DiffHirschbergBinary diff =
					new DiffHirschbergBinary(
						base.OldContent,
						base.NewContent);

				diff.BuildPatch(
					poList,
					oldContentOffset,
					oldContentLength,
					newContentOffset,
					newContentLength);
			}
			else
			{
				DiffHirschberg<BinaryRange, BinaryRangeTraits> diff =
					new DiffHirschberg<BinaryRange, BinaryRangeTraits>(
						base.OldRanges,
						base.NewRanges);

				CalculateRanges(
					poList,
					diff,
					oldContentOffset,
					oldContentLength,
					newContentOffset,
					newContentLength);
			}
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
