﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Data Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;
using System.Diagnostics.CodeAnalysis;
using System.Globalization;

namespace Nabu.Data
{
#if !COMPACT_FRAMEWORK
	[System.Diagnostics.DebuggerDisplay("Type: {Type}; Length: {Length};")]
#endif
	public sealed class PatchOperation<T>
	{
		#region PatchOperation

		#region Fields

		private PatchOperationType _type;
		private int _length;
		private T[] _data;

		#endregion

		#region Methods

		public PatchOperation(PatchOperationType type, int length, T[] data)
		{
			this._type = type;
			this._length = length;
			this._data = data;
		}

		#endregion

		#region Properties

		public PatchOperationType Type
		{
			[DebuggerStepThrough]
			get { return this._type; }
		}

		public int Length
		{
			[DebuggerStepThrough]
			get { return this._length; }
		}

		[SuppressMessage("Microsoft.Performance", "CA1819:PropertiesShouldNotReturnArrays")]
		public T[] Data
		{
			[DebuggerStepThrough]
			get { return this._data; }
		}

		#endregion

		#endregion

		#region Object

		public override string ToString()
		{
			return
				string.Format(
					CultureInfo.InvariantCulture,
					"Type: {0}; Length: {1};",
					this._type,
					this._length);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
