﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.DebuggerVisualizers Library              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics;

namespace Nabu.DebuggerVisualizers
{
	[Serializable]
	public sealed class DynamicMethodInfo
	{
		#region Fields

		private byte[] _il;
		private IList<KeyValuePair<int, Type>> _localVariables;
		private object[] _tokens;

		#endregion

		#region Methods

		public DynamicMethodInfo(
			byte[] il,
			IList<KeyValuePair<int, Type>> localVariables,
			object[] tokens)
		{
			this._il = il;
			this._localVariables = localVariables;
			this._tokens = tokens;
		}

		#endregion

		#region Properties

		public byte[] IL
		{
			[DebuggerStepThrough]
			get { return this._il; }
		}

		public IList<KeyValuePair<int, Type>> LocalVariables
		{
			[DebuggerStepThrough]
			get { return this._localVariables; }
		}

		public object[] Tokens
		{
			[DebuggerStepThrough]
			get { return this._tokens; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
