﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.DebuggerVisualizers Library              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics;

using Microsoft.VisualStudio.DebuggerVisualizers;

[assembly:
	DebuggerVisualizer(
		typeof(Nabu.DebuggerVisualizers.DynamicMethodVisualizer),
		typeof(Nabu.DebuggerVisualizers.DynamicMethodObjectSource),
		Target = typeof(System.Reflection.Emit.DynamicMethod),
		Description = "IL Visualizer")]

namespace Nabu.DebuggerVisualizers
{
	public sealed class DynamicMethodVisualizer : DialogDebuggerVisualizer
	{
		protected override void Show(IDialogVisualizerService windowService, IVisualizerObjectProvider objectProvider)
		{
			DynamicMethodInfo dynamicMethodInfo = (DynamicMethodInfo)objectProvider.GetObject();

			ILViewerForm ilViewerForm = new ILViewerForm(
				new DynamicMetadataTokenResolver(dynamicMethodInfo.Tokens),
				new KeyValuePair<int, Type>[0],
				dynamicMethodInfo.IL);

			ilViewerForm.ShowDialog();
		}
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
