﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.DebuggerVisualizers Library              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Reflection;

namespace Nabu.DebuggerVisualizers
{
	[Serializable]
	public sealed class MetadataTokenResolver : IMetadataTokenResolver
	{
		#region MetadataTokenResolver

		#region Fields

		private Module _module;

		#endregion

		#region Methods

		public MetadataTokenResolver(Module module)
		{
			this._module = module;
		}

		#endregion

		#endregion

		#region IMetadataTokenResolver

		public MethodBase ResolveMethod(int metadataToken)
		{
			return this._module.ResolveMethod(metadataToken);
		}

		public FieldInfo ResolveField(int metadataToken)
		{
			return this._module.ResolveField(metadataToken);
		}

		public Type ResolveType(int metadataToken)
		{
			return this._module.ResolveType(metadataToken);
		}

		public String ResolveString(int metadataToken)
		{
			return this._module.ResolveString(metadataToken);
		}

		public MemberInfo ResolveMember(int metadataToken)
		{
			return this._module.ResolveMember(metadataToken);
		}

		public byte[] ResolveSignature(int metadataToken)
		{
			return this._module.ResolveSignature(metadataToken);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
