﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Diagnostics Library                      */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;

namespace Nabu.Diagnostics
{
	public sealed class DeviceManager
	{
		#region Fields

		private List<DeviceClass> _classes;

		#endregion

		#region Methods

		public DeviceManager()
		{
		}

		#endregion

		#region Properties

		public IList<DeviceClass> Classes
		{
			get
			{
				if (this._classes == null)
				{
					int requiredSize;

					NativeMethods.SetupDiBuildClassInfoList(
						0,
						null,
						0,
						out requiredSize);

					Guid[] classGuids = new Guid[requiredSize];

					if (NativeMethods.SetupDiBuildClassInfoList(
						0,
						classGuids,
						classGuids.Length,
						out requiredSize))
					{
						this._classes = new List<DeviceClass>(classGuids.Length);

						foreach (Guid classGuid in classGuids)
						{
							this._classes.Add(new DeviceClass(classGuid));
						}
					}
				}

				return this._classes;
			}
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
