﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu Library                                  */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Diagnostics
{
	[Flags]
	public enum AssemblyDisplayModes
	{
		None /*                  */ = 0x00,
		Version /*               */ = 0x01,
		Culture /*               */ = 0x02,
		PublicKeyToken /*        */ = 0x04,
		PublicKey /*             */ = 0x08,
		Custom /*                */ = 0x10,
		ProcessorArchitecture /* */ = 0x20,
		LanguageID /*            */ = 0x40
	}

	[Flags]
	public enum AssemblyCompareOptions
	{
		None /*           */ = 0x00,
		Name /*           */ = 0x01,
		MajorVersion /*   */ = 0x02,
		MinorVersion /*   */ = 0x04,
		BuildNumber /*    */ = 0x08,
		RevisionNumber /* */ = 0x10,
		PublicKeyToken /* */ = 0x20,
		Culture /*        */ = 0x40,
		Custom /*         */ = 0x80,
		All /*            */ = Name | MajorVersion | MinorVersion | RevisionNumber | BuildNumber | PublicKeyToken | Culture | Custom,
		Default /*        */ = 0x100
	}

	public enum AssemblyNamePart
	{
		PublicKey,
		PublicKeyToken,
		HashValue,
		Name,
		MajorVersion,
		MinorVersion,
		BuildNumber,
		RevisionNumber,
		Culture,
		ProcessorIdArray,
		OSInfoArray,
		HashAlgorithmId,
		Alias,
		CodebaseUrl,
		CodebaseLastMod,
		NullPublicKey,
		NullPublicKeyToken,
		Custom,
		NullCustom,
		MVID,
		MaxParams
	}

	public enum AssemblyCacheUninstallDisposition
	{
		None /*                 */ = 0,
		Uninstalled /*          */ = 1,
		StillInUse /*           */ = 2,
		AlreadyUninstalled /*   */ = 3,
		DeletePending /*        */ = 4,
		HasInstallReferences /* */ = 5,
		ReferenceNotFound /*    */ = 6
	}

	[Flags]
	public enum QueryAssemblyInfoModes
	{
		None /*     */ = 0,
		Validate /* */ = 1,
		GetSize /*  */ = 2
	}

	[Flags]
	public enum AssemblyCacheInstallModes
	{
		None /*         */ = 0,
		Refresh /*      */ = 1,
		ForceRefresh /* */ = 2
	}

	[Flags]
	public enum AssemblyCacheModes
	{
		None /*     */ = 0,
		Zap /*      */ = 1,
		Gac /*      */ = 2,
		Download /* */ = 4
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
