﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Nabu.Forms.Html
{
	[HtmlBehaviorName("gripper")]
	public sealed class HtmlGripperBehavior : HtmlBehaviorBase
	{
		#region HtmlGripperBehavior

		public HtmlGripperBehavior() :
			base(HtmlEventGroup.InitializationAndMouse)
		{
		}

		#endregion

		#region HtmlBehaviorBase

		protected override void OnMouse(HtmlTag sender, HtmlMouseEventArgs e)
		{
			switch (e.Command)
			{
				case HtmlMouseEventCommand.Down:
					if (e.MouseState == HtmlEventMouseState.Left)
					{
						e.DragMode = HtmlEventDragMode.Move;
						e.DragTarget = sender.Parent;
						e.IsHandled = true;
					}

					break;
			}

			base.OnMouse(sender, e);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
