﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;
#if COMPACT_FRAMEWORK
using System.Runtime.InteropServices;
#endif

namespace Nabu.Forms.Html
{
	public abstract class HtmlBehaviorBase : HtmlMethodEventSinkBase
	{
		#region Fields

		private DOM_EventHandler _eventProc;

		#endregion

		#region Methods

		#region Constructor

		protected HtmlBehaviorBase(HtmlEventGroup eventGroup) : base(eventGroup)
		{
#if COMPACT_FRAMEWORK
			this._eventProc = new DOM_EventHandler(OnEventCF);
#else
			this._eventProc = new DOM_EventHandler(OnEvent);
#endif
		}

		#endregion

		#region Event Handler

#if COMPACT_FRAMEWORK
		private int OnEventCF(
			IntPtr handlerID,
			IntPtr hTag,
			HtmlEventGroup eventGroup,
			IntPtr lpParameters)
		{
			return OnEvent(handlerID, hTag, eventGroup, lpParameters) ? 1 : 0;
		}
#endif
		private bool OnEvent(
			IntPtr handlerID,
			IntPtr hTag,
			HtmlEventGroup eventGroup,
			IntPtr lpParameters)
		{
			using (HtmlTag sender = HtmlTag.FromHandle(hTag))
			{
				return DispatchEvent(sender, eventGroup, lpParameters);
			}
		}

		#endregion

		#region Managment

		internal void Attach(ref HtmlNotificationBehaviorAttaching notificationData)
		{
			notificationData.Tag = IntPtr.Zero;
#if COMPACT_FRAMEWORK
			notificationData.lpEventProc = Marshal.GetFunctionPointerForDelegate(this._eventProc);
#else
			notificationData.EventProc = this._eventProc;
#endif
			notificationData.EventGroup = base.EventGroup;
		}

		#endregion

		#endregion

		#region Properties

		private DOM_EventHandler EventHandler
		{
			[DebuggerStepThrough]
			get { return this._eventProc; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
