﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlTemplate
	{
		#region Fields

		private string _name;
		private string[] _value;
		private IDictionary<string, string> _attributes;

		#endregion

		#region Methods

		public HtmlTemplate(
			string name,
			string[] value,
			IDictionary<string, string> attributes)
		{
			this._name = name;
			this._value = value;
			this._attributes = attributes;
		}

		#endregion

		#region Properties

		public string Name
		{
			[DebuggerStepThrough]
			get { return this._name; }
		}

		public string[] Value
		{
			[DebuggerStepThrough]
			get { return this._value; }
		}

		public IDictionary<string, string> Attributes
		{
			[DebuggerStepThrough]
			get { return this._attributes; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
