﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public abstract class HtmlTemplateBehaviorBase : HtmlBehaviorBase
	{
		#region HtmlTemplateBehaviorBase

		#region Fields

		private IDictionary<string, HtmlTemplate> _templates;

		#endregion

		#region Methods

		protected HtmlTemplateBehaviorBase(HtmlEventGroup eventGroup)
			: base(eventGroup)
		{
		}

		#endregion

		#region Properties

		protected IDictionary<string, HtmlTemplate> Templates
		{
			[DebuggerStepThrough]
			get { return this._templates; }
		}

		#endregion

		#endregion

		#region HtmlBehaviorBase

		protected override void OnInitialization(HtmlTag sender, HtmlInitializationEventArgs e)
		{
			base.OnInitialization(sender, e);

			using (HtmlTag script = sender.SelectFirst("script[type='text/template']"))
			{
				if (script != null)
				{
					HtmlTemplateParser parser = new HtmlTemplateParser();

					parser.Parse(script.InnerText);

					this._templates = parser.Templates;
				}
			}
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
