﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Forms.Html
{
	[HtmlBehaviorName("shell-icon")]
	public sealed class HtmlShellIconBehavior : HtmlBehaviorBase
	{
		#region HtmlShellIconBehavior

		#region Methods

		public HtmlShellIconBehavior() :
			base(HtmlEventGroup.InitializationAndDraw)
		{
		}

		#endregion

		#endregion

		#region HtmlBehaviorBase

		protected override void OnDraw(HtmlTag sender, HtmlDrawEventArgs e)
		{
			if (e.Command == HtmlDrawEventCommand.Content)
			{
				string filename = sender.Attributes["filename"];
				string size = sender.Attributes["size"];

				if (filename != null)
				{
					ShellFileInfo fileInfo = new ShellFileInfo();

					try
					{
						UnsafeNativeMethods.Shell_GetFileInfo(
							filename,
							0,
							out fileInfo,
							Marshal.SizeOf(typeof(ShellFileInfo)),
							ShellFileInfoFlags.UseFileAttributes | ShellFileInfoFlags.Icon | (size == "large" ? ShellFileInfoFlags.LargeIcon : ShellFileInfoFlags.SmallIcon));

						UnsafeNativeMethods.Icon_DrawEx(
							e.Parameters.HDC,
							e.Parameters.Area.Left,
							e.Parameters.Area.Top,
							fileInfo.hIcon,
							0,
							0,
							0,
							IntPtr.Zero,
							3);
					}
					finally
					{
						if (fileInfo.hIcon != IntPtr.Zero)
						{
							UnsafeNativeMethods.Icon_Destroy(fileInfo.hIcon);
						}
					}
				}
			}

			//base.OnDraw(sender, e);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
