﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Forms.Html
{
	public sealed class HtmlButton : IDisposable
	{
		#region HtmlButton

		#region Fields

		private HtmlTag _tag;

		#endregion

		#region Methods

		public HtmlButton(HtmlTag tag)
		{
			this._tag = tag;
		}

		public void PerformClick()
		{
			HtmlMethodEventParameters parameters = new HtmlMethodEventParameters();

			parameters.MethodID = HtmlTagMethodID.Click;

			int result = this._tag.TryCallMethod(parameters);

			if (result == (int)HtmlResult.DOM_Success_NotHandled)
			{
				if (!this._tag.SendEvent(
					(int)HtmlBehaviorEventCommand.CustomActivateChild,
					this._tag,
					IntPtr.Zero))
				{
					HtmlDomException.ThrowOnError((int)HtmlResult.DOM_Success_NotHandled);
				}
			}
			else
			{
				HtmlDomException.ThrowOnError(result);
			}
		}

		#endregion

		#endregion

		#region IDisposable

		public void Dispose()
		{
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
