﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Forms.Html
{
	public sealed class HtmlControl : IDisposable
	{
		#region HtmlControl

		#region Fields

		private HtmlTag _tag;

		#endregion

		#region Methods

		public HtmlControl(HtmlTag tag)
		{
			this._tag = tag;
		}

		#endregion

		#region Properties

		public object Value
		{
			get
			{
				JsonValueData untypedValue = new JsonValueData();

				try
				{
					HtmlValueException.ThrowOnError(
						HtmlDynamicInterop.Dom.GetControlValue(
							this._tag.Handle,
							out untypedValue));

					return JsonValue.GetObjectFromValue(untypedValue);
				}
				finally
				{
					HtmlValueException.ThrowOnError(
						HtmlDynamicInterop.Json.Clear(
							ref untypedValue));
				}
			}

			set
			{
				JsonValueData untypedValue = new JsonValueData();

				try
				{
					untypedValue = JsonValue.GetValueFromObject(value);

					HtmlValueException.ThrowOnError(
						HtmlDynamicInterop.Dom.SetControlValue(
							this._tag.Handle,
							ref untypedValue));
				}
				finally
				{
					HtmlValueException.ThrowOnError(
						HtmlDynamicInterop.Json.Clear(
							ref untypedValue));
				}
			}
		}

		#endregion

		#endregion

		#region IDisposable

		public void Dispose()
		{
		}

		#endregion
	}
}

/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
