﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

using Nabu.Collections;

namespace Nabu.Forms.Html
{
	public sealed class HtmlSelect : IDisposable
	{
		#region HtmlSelect

		#region Fields

		private HtmlTag _tag;

		#endregion

		#region Methods

		public HtmlSelect(HtmlTag tag)
		{
			this._tag = tag;
		}

		#endregion

		#region Properties

		public HtmlTag SelectedOption
		{
			get
			{
				return this._tag.SelectFirst("option:checked");
			}
		}

		public DisposableList<HtmlTag> SelectedOptions
		{
			get
			{
				return this._tag.Select("option:checked");
			}
		}

		public HtmlTagCollection Options
		{
			get
			{
				return this._tag.SelectFirst("popup[type='select']").Children;
			}
		}

		#endregion

		#endregion

		#region IDisposable

		public void Dispose()
		{
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
