﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Text;

namespace Nabu.Forms.Html
{
	public sealed class HtmlTagScrollInfo
	{
		#region Fields

		private Point _position;
		private Rectangle _view;
		private Size _size;

		#endregion

		#region Methods

		public HtmlTagScrollInfo(
			Point position,
			Rectangle view,
			Size size)
		{
			this._position = position;
			this._view = view;
			this._size = size;
		}

		#endregion

		#region Properties

		public Point Position
		{
			[DebuggerStepThrough]
			get { return this._position; }
		}

		public Rectangle View
		{
			[DebuggerStepThrough]
			get { return this._view; }
		}

		public Size Size
		{
			[DebuggerStepThrough]
			get { return this._size; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
