﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;
using System.Drawing;

namespace Nabu.Forms.Html
{
	public sealed class HtmlTagSymbol
	{
		#region Fields

		private Rectangle _box;
		private int _position;
		private char _code;

		#endregion

		#region Methods

		internal HtmlTagSymbol(Rectangle box, int position, char code)
		{
			this._box = box;
			this._position = position;
			this._code = code;
		}

		#endregion

		#region Properties

		public Rectangle Box
		{
			[DebuggerStepThrough]
			get { return this._box; }
		}

		public int Position
		{
			[DebuggerStepThrough]
			get { return this._position; }
		}

		public char Code
		{
			[DebuggerStepThrough]
			get { return this._code; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
