﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics.CodeAnalysis;
using System.Windows.Forms;

namespace Nabu.Forms.Html
{
	public interface IHtmlHostNotificationHandler
	{
		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "2#")]
		bool OnControlCreating(
			IntPtr hTag,
			IntPtr hWindowHtml,
			ref IntPtr hWndChild);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		bool OnResourceLoading(
			Uri resourceUrl,
			HtmlResourceType resourceUriType,
			out byte[] resourceData);

		void OnControlCreated(
			IntPtr hTag,
			IntPtr hWindowHtml,
			IntPtr hWindowChild);

		void OnResourceLoaded(
			Uri resourceUrl,
			HtmlResourceType resourceUriType,
			int status);

		void OnDocumentLoaded();

		void OnUpdateUI();

		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "1#")]
		bool OnControlDestroyed(
			IntPtr hTag,
			ref IntPtr hWindowChild);

		void OnBehaviorChanged(
			string[] oldNames,
			string[] newNames);

		void OnDialogCreated(
			IntPtr hWindowHtml);

		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "1#")]
		bool OnDialogDestroying(
			IntPtr hWindowHtml,
			ref bool cancel);

		void OnDocumentParsed();

		[SuppressMessage("Microsoft.Design", "CA1054:UriParametersShouldNotBeStrings", MessageId = "1#")]
		bool OnHyperLink(
			HtmlTag htmlTag,
			string uri,
			string target,
			Keys keys);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
