﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlBehaviorEventArgs : HtmlEventArgsBase
	{
		#region Fields

		private HtmlBehaviorEventParameters _parameters;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlBehaviorEventArgs(HtmlBehaviorEventParameters parameters)
			: base(parameters.HTarget)
		{
			this._parameters = parameters;
		}

		#endregion

		#region Properties

		internal HtmlBehaviorEventParameters Parameters
		{
			[DebuggerStepThrough]
			get { return this._parameters; }
		}

		public HtmlBehaviorEventCommand Command
		{
			[DebuggerStepThrough]
			get { return this._parameters.Command; }
		}

		public HtmlEventReason Reason
		{
			[DebuggerStepThrough]
			get { return this._parameters.Reason; }
		}

		public HtmlTag Source
		{
			[DebuggerStepThrough]
			get { return HtmlTag.FromHandle(this._parameters.HSource); }
		}

		public object Value
		{
			[DebuggerStepThrough]
			get { return JsonValue.GetObjectFromValue(this._parameters.Value); }
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
