﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlDataEventArgs : HtmlEventArgsBase
	{
		#region Fields

		private HtmlDataEventParameters _parameters;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlDataEventArgs(HtmlDataEventParameters parameters)
			: base(IntPtr.Zero)
		{
			this._parameters = parameters;
		}

		#endregion

		#region Properties

		internal HtmlDataEventParameters Parameters
		{
			[DebuggerStepThrough]
			get { return this._parameters; }
		}

		public IntPtr DataPointer
		{
			[DebuggerStepThrough]
			get { return this._parameters.DataPointer; }
		}

		public int DataSize
		{
			[DebuggerStepThrough]
			get { return this._parameters.DataSize; }
		}

		public int DataType
		{
			[DebuggerStepThrough]
			get { return this._parameters.DataType; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
