﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public abstract class HtmlEventArgsBase : EventArgs
	{
		#region Fields

		private bool _isHandled;
		private readonly IntPtr _hTarget;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		protected HtmlEventArgsBase(IntPtr hTarget)
		{
			this._hTarget = hTarget;
		}

		#endregion

		#region Properties

		public bool IsHandled
		{
			[DebuggerStepThrough]
			get { return this._isHandled; }
			[DebuggerStepThrough]
			set { this._isHandled = value; }
		}

		public HtmlTag Target
		{
			[DebuggerStepThrough]
			get
			{
				if (this._hTarget == IntPtr.Zero)
				{
					return null;
				}
				else
				{
					return HtmlTag.FromHandle(this._hTarget);
				}
			}
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
