﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlFocusEventArgs : HtmlEventArgsBase
	{
		#region Fields

		private HtmlFocusEventParameters _parameters;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlFocusEventArgs(HtmlFocusEventParameters parameters)
			: base(parameters.HTarget)
		{
			this._parameters = parameters;
		}

		#endregion

		#region Properties

		internal HtmlFocusEventParameters Parameters
		{
			[DebuggerStepThrough]
			get { return this._parameters; }
		}

		public HtmlFocusEventCommand Command
		{
			[DebuggerStepThrough]
			get { return this._parameters.Command; }
		}

		public bool Mouse
		{
			[DebuggerStepThrough]
			get { return this._parameters.Mouse; }
		}

		public bool Cancel
		{
			[DebuggerStepThrough]
			get { return this._parameters.Cancel; }
			[DebuggerStepThrough]
			set { this._parameters.Cancel = value; }
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
