﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlKeyboardEventArgs : HtmlEventArgsBase
	{
		#region Fields

		private HtmlKeyboardEventParameters _parameters;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlKeyboardEventArgs(HtmlKeyboardEventParameters parameters)
			: base(parameters.HTarget)
		{
			this._parameters = parameters;
		}

		#endregion

		#region Properties

		internal HtmlKeyboardEventParameters Parameters
		{
			[DebuggerStepThrough]
			get { return this._parameters; }
		}

		public HtmlKeyboardEventCommand Command
		{
			[DebuggerStepThrough]
			get { return this._parameters.Command; }
		}

		public int KeyCode
		{
			[DebuggerStepThrough]
			get { return this._parameters.KeyCode; }
		}

		public HtmlEventKeyboardState KeyboardState
		{
			[DebuggerStepThrough]
			get { return this._parameters.KeyboardState; }
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
