﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlMethodEventArgs : HtmlEventArgsBase
	{
		#region Fields

		private HtmlTagMethodID _methodID;
		private IntPtr _parameters;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlMethodEventArgs(
			HtmlTagMethodID methodID,
			IntPtr parameters)
			: base(IntPtr.Zero)
		{
			this._methodID = methodID;
			this._parameters = parameters;
		}

		#endregion

		#region Properties

		public HtmlTagMethodID MethodID
		{
			[DebuggerStepThrough]
			get { return this._methodID; }
		}

		public IntPtr Parameters
		{
			[DebuggerStepThrough]
			get { return this._parameters; }
			[DebuggerStepThrough]
			set { this._parameters = value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
