﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlScrollEventArgs : HtmlEventArgsBase
	{
		#region Fields

		private HtmlScrollEventParameters _parameters;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlScrollEventArgs(HtmlScrollEventParameters parameters)
			: base(parameters.HTarget)
		{
			this._parameters = parameters;
		}

		#endregion

		#region Properties

		internal HtmlScrollEventParameters Parameters
		{
			[DebuggerStepThrough]
			get { return this._parameters; }
		}

		public HtmlScrollEventCommand Command
		{
			[DebuggerStepThrough]
			get { return this._parameters.Command; }
		}

		public int Position
		{
			[DebuggerStepThrough]
			get { return this._parameters.Position; }
		}

		public bool IsVertical
		{
			[DebuggerStepThrough]
			get { return this._parameters.IsVertical; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
