﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Forms.Html
{
	public sealed class HtmlMethodCallEventArgs : EventArgs
	{
		#region Fields

		private string _methodName;
		private object _returnValue;
		private object[] _arguments;
		private bool _isHandled;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlMethodCallEventArgs(
			string methodName,
			object[] arguments)
		{
			this._methodName = methodName;
			this._arguments = arguments;
		}

		#endregion

		#region Properties

		public string MethodName
		{
			[DebuggerStepThrough]
			get { return this._methodName; }
		}

		public object ReturnValue
		{
			[DebuggerStepThrough]
			get { return this._returnValue; }
			[DebuggerStepThrough]
			set { this._returnValue = value; }
		}

		[SuppressMessage("Microsoft.Performance", "CA1819:PropertiesShouldNotReturnArrays")]
		public object[] Arguments
		{
			[DebuggerStepThrough]
			get { return this._arguments; }
		}

		public bool IsHandled
		{
			[DebuggerStepThrough]
			get { return this._isHandled; }
			[DebuggerStepThrough]
			set { this._isHandled = value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
