﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Forms.Html
{
	public sealed class HtmlMethodScrollEventArgs : EventArgs
	{
		#region Fields

		private readonly int _value;
		private readonly int _minValue;
		private readonly int _maxValue;
		private readonly int _pageValue;
		private readonly int _stepValue;
		private bool _isHandled;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal HtmlMethodScrollEventArgs(
			int value,
			int minValue,
			int maxValue,
			int pageValue,
			int stepValue)
		{
			this._value = value;
			this._minValue = minValue;
			this._maxValue = maxValue;
			this._pageValue = pageValue;
			this._stepValue = stepValue;
		}

		#endregion

		#region Properties

		public int Value
		{
			[DebuggerStepThrough]
			get { return this._value; }
		}

		public int MinValue
		{
			[DebuggerStepThrough]
			get { return this._minValue; }
		}

		public int MaxValue
		{
			[DebuggerStepThrough]
			get { return this._maxValue; }
		}

		public int PageValue
		{
			[DebuggerStepThrough]
			get { return this._pageValue; }
		}

		public int StepValue
		{
			[DebuggerStepThrough]
			get { return this._stepValue; }
		}

		public bool IsHandled
		{
			[DebuggerStepThrough]
			get { return this._isHandled; }
			[DebuggerStepThrough]
			set { this._isHandled = value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
