﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;
using System.IO;

namespace Nabu.Forms.Html
{
	public sealed class HtmlProtocolFile : HtmlProtocolBase
	{
		#region HtmlProtocolFile

		#region Constants

		private readonly string[] _names = new string[] { "file" };

		#endregion

		#endregion

		#region IHtmlProtocol

		#region Methods

		public override byte[] LoadResource(
			Uri resourceUri,
			HtmlResourceType resourceUriType)
		{
			using (Stream stream = new FileStream(
				resourceUri.LocalPath,
				FileMode.Open,
				FileAccess.Read,
				FileShare.Read))
			{
				byte[] resourceData = new byte[stream.Length];
				stream.Read(resourceData, 0, resourceData.Length);

				return resourceData;
			}
		}

		#endregion

		#region Properties

		public override string[] Names
		{
			[DebuggerStepThrough]
			get { return this._names; }
		}

		#endregion

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
