﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Net;
#if !COMPACT_FRAMEWORK
using System.Net.Cache;
#endif

namespace Nabu.Forms.Html
{
	public sealed class HtmlProtocolFtp : HtmlProtocolBase
	{
		#region HtmlProtocolFtp

		#region Constants

		private readonly string[] _names = new string[] { "ftp", "ftps" };

		#endregion

		#endregion

		#region IHtmlProtocol

		#region Methods

		public override byte[] LoadResource(
			Uri resourceUri,
			HtmlResourceType resourceUriType)
		{
			FtpWebRequest webRequest = (FtpWebRequest)FtpWebRequest.Create(resourceUri);

			webRequest.CachePolicy = new RequestCachePolicy(RequestCacheLevel.Revalidate);
			webRequest.UsePassive = true;
			webRequest.UseBinary = true;

			using (FtpWebResponse webResponse = (FtpWebResponse)webRequest.GetResponse())
			{
				List<byte> responseBuffer = new List<byte>(64 * 1024);

				using (Stream reponseStream = webResponse.GetResponseStream())
				{
					for (
						int value = reponseStream.ReadByte();
						value != -1;
						value = reponseStream.ReadByte())
					{
						responseBuffer.Add((byte)value);
					}
				}

				return responseBuffer.ToArray();
			}
		}

		#endregion

		#region Properties

		public override string[] Names
		{
			[DebuggerStepThrough]
			get { return this._names; }
		}

		#endregion

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
