﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Forms.Html
{
	// VALUE_TYPE
	public enum JsonValueType
	{
		Undefined,
		Null,
		Boolean,
		Integer,
		Floating,
		String,
		FileTime,
		Currency,
		Length,
		Array,
		Map,
		// Sciter specific
		Function,
		Binary,
		// Sciter specific
		Object
	};

	// VALUE_UNIT_TYPE
	internal enum JsonValueUnit
	{
		Undefined /*      */ = 0,
		FontHeight /*     */ = 1, // EM
		FontHeightX /*    */ = 2, // EX
		StrongPersents /* */ = 3, // %
		FlexPersents   /* */ = 4, // %%
		Pixels /*         */ = 7, // PX
		Inches /*         */ = 8, // IN
		Centimeters /*    */ = 9, // CM
		Millimeters /*    */ = 10, // MM
		Points /*         */ = 11, // PT
		Picas /*          */ = 12, // PC
		Color /*          */ = 14, // 32-bit ARGB
		Url /*            */ = 15,
		Identifier /*     */ = 0xFFFF
	};

	// VALUE_UNIT_TYPE_DATE
	[Flags]
	internal enum JsonValueDateFlags
	{
		HasDate = 0x01,
		HasTime = 0x02,
		HasSeconds = 0x04,
		IsUTC = 0x10,
	};

	// VALUE
	[StructLayout(LayoutKind.Sequential)]
	internal struct JsonValueData
	{
		public int t;
		public int u;
		public long d;
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
