﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Drawing;
using System.Runtime.InteropServices;

namespace Nabu.Forms.Html
{
#if COMPACT_FRAMEWORK
	internal delegate bool HtmlPrintLoadDataHandler(
		[In] IntPtr hPrint,
		[In] IntPtr hTag,
		[In] IntPtr lpResourceUrl);
#else
	internal delegate bool HtmlPrintLoadDataHandler(
		[In] IntPtr hPrint,
		[In] IntPtr hTag,
		[In][MarshalAs(UnmanagedType.LPStr)] string resourceUrl);
#endif

#if COMPACT_FRAMEWORK
	internal delegate void HtmlPrintHyperlinkAreaHandler(
		[In] IntPtr hPrint,
		[In] IntPtr hTag,
		[In][Out] ref Rectangle area,
		[In] IntPtr lpLinkUri);
#else
	internal delegate void HtmlPrintHyperlinkAreaHandler(
		[In] IntPtr hPrint,
		[In] IntPtr hTag,
		[In][Out] ref Rectangle area,
		[In][MarshalAs(UnmanagedType.LPStr)] string linkUri);
#endif

	internal delegate void HtmlPrintNextPageHandler(
		[In] IntPtr hPrint,
		[In] IntPtr tag,
		[In] int page,
		[In][Out] ref int viewportHeight,
		[Out][MarshalAs(UnmanagedType.Bool)] out bool isNotLast);
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
