﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms.Html Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.IO;
using System.Runtime.InteropServices;

namespace Nabu.Forms.Html
{
	internal static class UnsafeNativeMethods
	{
		#region Libraries

#if COMPACT_FRAMEWORK
		private const string Kernel32 = "coredll.dll";
		private const string User32 = "coredll.dll";
		private const string Gdi32 = "coredll.dll";
		private const string Shell32 = "coredll.dll";
#else
		private const string Kernel32 = "kernel32.dll";
		private const string User32 = "user32.dll";
		private const string Gdi32 = "gdi32.dll";
		private const string Shell32 = "shell32.dll";
#endif

		#endregion

		#region Methods

#if COMPACT_FRAMEWORK
		public static string PtrToStringAnsi(IntPtr ptr)
		{
			char[] buffer = new char[64];

			for (int index = 0; index < buffer.Length; index++)
			{
				byte value = Marshal.ReadByte(ptr, index);

				if (value == 0)
				{
					return new string(buffer, 0, index);
				}

				buffer[index] = (char)value;
			}

			return new string(buffer, 0, buffer.Length);
		}

		public static int String_LengthA(IntPtr ptr)
		{
			int length = 0;

			for (; Marshal.ReadByte(ptr, length) != 0; length++)
			{
			}

			return length;
		}
#else
		[DllImport(Kernel32, EntryPoint = "lstrlenA", CharSet = CharSet.Ansi)]
		public static extern int String_LengthA(
			[In] IntPtr ptr);
#endif

		[DllImport(Shell32, EntryPoint = "SHGetFileInfoW", CharSet = CharSet.Unicode)]
		public static extern IntPtr Shell_GetFileInfo(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In][MarshalAs(UnmanagedType.U4)] FileAttributes fileAttributes,
			[Out] out ShellFileInfo fileInfo,
			[In] int fileInfoSize,
			[In][MarshalAs(UnmanagedType.U4)] ShellFileInfoFlags flags);

		[DllImport(User32, EntryPoint = "ReleaseCapture")]
		public static extern int Window_ReleaseCapture();

		[DllImport(User32, EntryPoint = "DrawIconEx", CharSet = CharSet.Unicode)]
		[return: MarshalAs(UnmanagedType.Bool)]
		public static extern bool Icon_DrawEx(
			[In] IntPtr hDC,
			[In] int x,
			[In] int y,
			[In] IntPtr hIcon,
			[In] int width,
			[In] int height,
			[In] int step,
			[In] IntPtr hBrushFlickerFreeDraw,
			[In] int flags);

		[DllImport(User32, EntryPoint = "DestroyIcon", CharSet = CharSet.Unicode)]
		[return: MarshalAs(UnmanagedType.Bool)]
		public static extern bool Icon_Destroy(
			[In] IntPtr hIcon);

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
