﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics.CodeAnalysis;
using System.Windows.Forms;

namespace Nabu.Forms
{
	/// <summary>
	/// ListBox with support of <see cref="IBindingList"/> as DataSource
	/// </summary>
	public sealed class BindingListBox : ListBox
	{
		#region Fields

		private IBindingList _dataSource;

		#endregion

		#region Methods

		private void OnListChanged(object sender, ListChangedEventArgs e)
		{
		}

		public BindingListBox()
		{
		}

		#endregion

		#region Properties

		[SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
		public new IBindingList DataSource
		{
			get
			{
				return this._dataSource;
			}

			set
			{
				if (this._dataSource != null)
				{
					this._dataSource.ListChanged -= new ListChangedEventHandler(OnListChanged);
				}

				base.SelectedIndex = -1;
				this._dataSource = value;
				((ListControl)this).DataSource = value;

				if (this._dataSource != null)
				{
					this._dataSource.ListChanged += new ListChangedEventHandler(OnListChanged);
					RefreshItems();
				}
			}
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
