﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;
using System.Windows.Forms;

namespace Nabu.Forms
{
	public sealed class BindingListViewBindEventArgs : EventArgs
	{
		#region Fields

		private int _index;
		private object _value;
		private ListViewItem _item;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public BindingListViewBindEventArgs(int index, object value)
		{
			this._index = index;
			this._value = value;
		}

		#endregion

		#region Properties

		public int Index
		{
			[DebuggerStepThrough]
			get { return this._index; }
		}

		public object Value
		{
			[DebuggerStepThrough]
			get { return this._value; }
		}

		public ListViewItem Item
		{
			[DebuggerStepThrough]
			get { return this._item; }
			[DebuggerStepThrough]
			set { this._item = value; }
		}

		#endregion
	};
}
