﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics.CodeAnalysis;
using System.Runtime.InteropServices;

namespace Nabu.Forms.TextObjectModel
{
	[StructLayout(LayoutKind.Sequential)]
	public struct CharRange
	{
		#region CharRange

		#region Fields

		[SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
		public int Start;
		[SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
		public int End;

		#endregion

		#region Methods

		public CharRange(int from, int to)
		{
			this.Start = from;
			this.End = to;
		}

		#endregion

		#endregion

		#region Object

		public override bool Equals(object obj)
		{
			CharRange range = (CharRange)obj;

			return
				(this.Start == range.Start) &&
				(this.End == range.End);
		}

		public override int GetHashCode()
		{
			return this.Start ^ (((this.End & 0xFFFF) << 16) | (this.End >> 16));
		}

		public static bool operator ==(CharRange left, CharRange right)
		{
			return left.Equals(right);
		}

		public static bool operator !=(CharRange left, CharRange right)
		{
			return !left.Equals(right);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
