﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics.CodeAnalysis;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace Nabu.Forms.TextObjectModel
{
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("00020D00-0000-0000-c000-000000000046")]
	[BestFitMapping(false, ThrowOnUnmappableChar = true)]
	public interface IRichEditOle
	{
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetClientSite(
			[Out][MarshalAs(UnmanagedType.Interface)] out IOleClientSite oleClientSite);

		[SuppressMessage("Microsoft.Design", "CA1024:UsePropertiesWhereAppropriate")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetObjectCount();

		[SuppressMessage("Microsoft.Design", "CA1024:UsePropertiesWhereAppropriate")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetLinkCount();

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetObject(
			[In] int index,
			[Out] out REOBJECT reObject,
			[In] int flags);

		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "0#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult InsertObject(
			[In] ref REOBJECT reObject);

		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "1#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult ConvertObject(
			[In] int index,
			[In] ref Guid clsidNew,
			[In][MarshalAs(UnmanagedType.LPStr)] string userTypeNew);

		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "0#")]
		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "1#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult ActivateAs(
			[In] ref Guid clsid,
			[In] ref Guid clsidAs);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult SetHostNames(
			[In][MarshalAs(UnmanagedType.LPStr)] string lpstrContainerApp,
			[In][MarshalAs(UnmanagedType.LPStr)] string lpstrContainerObj);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult SetLinkAvailable(
			[In] int index,
			[In][MarshalAs(UnmanagedType.Bool)] bool available);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult SetDvaspect(
			[In] int index,
			[In] int dvaspect);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult HandsOffStorage(
			[In] int index);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult SaveCompleted(
			[In] int index,
			[In][MarshalAs(UnmanagedType.Interface)] IStorage lpStorage);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult InPlaceDeactivate();

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult ContextSensitiveHelp(
			[In][MarshalAs(UnmanagedType.Bool)] bool enterMode);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "0#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetClipboardData(
			[In] ref CharRange charRange,
			[In] int reco,
			[Out][MarshalAs(UnmanagedType.Interface)] out IDataObject dataObject);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult ImportDataObject(
			[In][MarshalAs(UnmanagedType.Interface)] IDataObject dataObject,
			[In] short clipboardFormat,
			[In] IntPtr hMetaPict);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
