﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics.CodeAnalysis;
using System.Runtime.InteropServices;

namespace Nabu.Forms.TextObjectModel
{
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[Guid("8CC497C0-A1DF-11CE-8098-00AA0047BE5D")]
	public interface IRichTextDocument
	{
		[DispId(0)]
		string Name
		{
			[return: MarshalAs(UnmanagedType.BStr)]
			[DispId(0)]
			get;
		}

		[DispId(1)]
		IRichTextSelection Selection
		{
			[return: MarshalAs(UnmanagedType.Interface)]
			[DispId(1)]
			get;
		}

		[DispId(2)]
		int StoryCount
		{
			[DispId(2)]
			get;
		}

		[DispId(3)]
		IRichTextStoryRanges StoryRanges
		{
			[return: MarshalAs(UnmanagedType.Interface)]
			[DispId(3)]
			get;
		}

		[DispId(4)]
		int Saved
		{
			[DispId(4)]
			get;

			[param: In]
			[DispId(4)]
			set;
		}

		[DispId(5)]
		float DefaultTabStop
		{
			[DispId(5)]
			get;

			[param: In]
			[DispId(5)]
			set;
		}

		[DispId(6)]
		void New();

		[SuppressMessage("Microsoft.Design", "CA1007:UseGenericsWhereAppropriate")]
		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "0#")]
		[DispId(7)]
		void Open(
			[In][MarshalAs(UnmanagedType.Struct)] ref object source,
			[In][MarshalAs(UnmanagedType.U4)] DocumentOpenSaveFlags flags,
			[In] int codePage);

		[SuppressMessage("Microsoft.Design", "CA1007:UseGenericsWhereAppropriate")]
		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "0#")]
		[DispId(8)]
		void Save(
			[In][MarshalAs(UnmanagedType.Struct)] ref object destination,
			[In][MarshalAs(UnmanagedType.U4)] DocumentOpenSaveFlags flags,
			[In] int codePage);

		[DispId(9)]
		int Freeze();

		[DispId(10)]
		int Unfreeze();

		[DispId(11)]
		void BeginEditCollection();

		[DispId(12)]
		void EndEditCollection();

		[DispId(13)]
		int Undo(
			[In] int count);

		[DispId(14)]
		int Redo(
			[In] int count);

		[return: MarshalAs(UnmanagedType.Interface)]
		[DispId(15)]
		IRichTextRange Range(
			[In] int charFrom,
			[In] int charTo);

		[return: MarshalAs(UnmanagedType.Interface)]
		[DispId(0x10)]
		IRichTextRange RangeFromPoint(
			[In] int x,
			[In] int y);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
