﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Forms.TextObjectModel
{
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[Guid("8CC497C1-A1DF-11CE-8098-00AA0047BE5D")]
	public interface IRichTextSelection : IRichTextRange
	{
		[DispId(0x101)]
		SelectionFlags Flags
		{
			[return: MarshalAs(UnmanagedType.U4)]
			[DispId(0x101)]
			get;

			[param: In]
			[param: MarshalAs(UnmanagedType.U4)]
			[DispId(0x101)]
			set;
		}

		[DispId(0x102)]
		SelectionType Type
		{
			[return: MarshalAs(UnmanagedType.U4)]
			[DispId(0x102)]
			get;
		}

		[DispId(0x103)]
		int MoveLeft(
			[In][MarshalAs(UnmanagedType.U4)] UnitType unit,
			[In] int count,
			[In] int extend);

		[DispId(260)]
		int MoveRight(
			[In][MarshalAs(UnmanagedType.U4)] UnitType unit,
			[In] int count,
			[In] int extend);

		[DispId(0x105)]
		int MoveUp(
			[In][MarshalAs(UnmanagedType.U4)] UnitType unit,
			[In] int count,
			[In] int extend);

		[DispId(0x106)]
		int MoveDown(
			[In][MarshalAs(UnmanagedType.U4)] UnitType unit,
			[In] int count,
			[In] int extend);

		[DispId(0x107)]
		int HomeKey(
			[In][MarshalAs(UnmanagedType.U4)] UnitType unit,
			[In] int extend);

		[DispId(0x108)]
		int EndKey(
			[In][MarshalAs(UnmanagedType.U4)] UnitType unit,
			[In] int extend);

		[DispId(0x109)]
		void TypeText(
			[In][MarshalAs(UnmanagedType.BStr)] string text);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
