﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Nabu.Forms
{
	internal static class ControlDelegate
	{
		#region Types

		public delegate AccessibleObject GetAccessibleObjectHandler();

		public delegate AccessibleRole GetAccessibleRoleHandler();
		public delegate void SetAccessibleRoleHandler(AccessibleRole value);

		public delegate AnchorStyles GetAnchorStylesHandler();
		public delegate void SetAnchorStylesHandler(AnchorStyles value);

		public delegate void AppendTextHandler(string text);

		public delegate BindingContext GetBindingContextHandler();
		public delegate void SetBindingContextHandler(BindingContext value);

		public delegate bool GetBooleanHandler();
		public delegate void SetBooleanHandler(bool value);

		public delegate CheckState GetCheckStateHandler();
		public delegate void SetCheckStateHandler(CheckState value);

		public delegate ContextMenu GetContextMenuHandler();
		public delegate void SetContextMenuHandler(ContextMenu value);

		public delegate ContextMenuStrip GetContextMenuStripHandler();
		public delegate void SetContextMenuStripHandler(ContextMenuStrip value);

		public delegate Control GetControlHandler();
		public delegate void SetControlHandler(Control value);

		public delegate Control.ControlCollection GetControlCollectionHandler();

		public delegate ControlBindingsCollection GetControlBindingsCollectionHandler();

		public delegate Color GetColorHandler();
		public delegate void SetColorHandler(Color value);

		public delegate Cursor GetCursorHandler();
		public delegate void SetCursorHandler(Cursor value);

		public delegate DockStyle GetDockStyleHandler();
		public delegate void SetDockStyleHandler(DockStyle value);

		public delegate Font GetFontHandler();
		public delegate void SetFontHandler(Font value);

		public delegate IContainer GetIContainerHandler();

		public delegate ImeMode GetImeModeHandler();
		public delegate void SetImeModeHandler(ImeMode value);

		public delegate ISite GetISiteHandler();
		public delegate void SetISiteHandler(ISite value);

		public delegate IWindowTarget GetIWindowTargetHandler();
		public delegate void SetIWindowTargetHandler(IWindowTarget value);

		public delegate int GetInt32Handler();
		public delegate void SetInt32Handler(int value);

		public delegate Image GetImageHandler();
		public delegate void SetImageHandler(Image value);

		public delegate ImageLayout GetImageLayoutHandler();
		public delegate void SetImageLayoutHandler(ImageLayout value);

		public delegate IntPtr GetIntPtrHandler();

		public delegate object GetObjectHandler();
		public delegate void SetObjectHandler(object value);

		public delegate Padding GetPaddingHandler();
		public delegate void SetPaddingHandler(Padding value);

		public delegate Point GetPointHandler();
		public delegate void SetPointHandler(Point value);

		public delegate Rectangle GetRectangleHandler();
		public delegate void SetRectangleHandler(Rectangle value);

		public delegate Region GetRegionHandler();
		public delegate void SetRegionHandler(Region value);

		public delegate RightToLeft GetRightToLeftHandler();
		public delegate void SetRightToLeftHandler(RightToLeft value);

		public delegate Size GetSizeHandler();
		public delegate void SetSizeHandler(Size value);

		public delegate string GetStringHandler();
		public delegate void SetStringHandler(string value);

		public delegate DialogResult GetDialogResultHandler();
		public delegate void SetDialogResultHandler(DialogResult value);

		#endregion

		#region Methods

		#region Control

		#region Properties

		#region ReadOnly

		#region AccessibilityObject

		public static GetAccessibleObjectHandler GetAccessibilityObject(Control control)
		{
			return (GetAccessibleObjectHandler)Delegate.CreateDelegate(typeof(GetAccessibleObjectHandler), control, "get_AccessibilityObject");
		}

		#endregion

		#region Bottom

		public static GetInt32Handler GetBottom(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Bottom");
		}

		#endregion

		#region CanFocus

		public static GetBooleanHandler GetCanFocus(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_CanFocus");
		}

		#endregion

		#region CanSelect

		public static GetBooleanHandler GetCanSelect(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_CanSelect");
		}

		#endregion

		#region ClientRectangle

		public static GetRectangleHandler GetClientRectangle(Control control)
		{
			return (GetRectangleHandler)Delegate.CreateDelegate(typeof(GetRectangleHandler), control, "get_ClientRectangle");
		}

		#endregion

		#region CompanyName

		public static GetStringHandler GetCompanyName(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_CompanyName");
		}

		#endregion

		#region Container

		public static GetIContainerHandler GetContainer(Control control)
		{
			return (GetIContainerHandler)Delegate.CreateDelegate(typeof(GetIContainerHandler), control, "get_Container");
		}

		#endregion

		#region ContainsFocus

		public static GetBooleanHandler GetContainsFocus(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_ContainsFocus");
		}

		#endregion

		#region Controls

		public static GetControlCollectionHandler GetControls(Control control)
		{
			return (GetControlCollectionHandler)Delegate.CreateDelegate(typeof(GetControlCollectionHandler), control, "get_Controls");
		}

		#endregion

		#region Created

		public static GetBooleanHandler GetCreated(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Created");
		}

		#endregion

		#region DataBindings

		public static GetControlBindingsCollectionHandler GetDataBindings(Control control)
		{
			return (GetControlBindingsCollectionHandler)Delegate.CreateDelegate(typeof(GetControlBindingsCollectionHandler), control, "get_DataBindings");
		}

		#endregion

		#region DisplayRectangle

		public static GetRectangleHandler GetDisplayRectangle(Control control)
		{
			return (GetRectangleHandler)Delegate.CreateDelegate(typeof(GetRectangleHandler), control, "get_DisplayRectangle");
		}

		#endregion

		#region Disposing

		public static GetBooleanHandler GetDisposing(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Disposing");
		}

		#endregion

		#region Focused

		public static GetBooleanHandler GetFocused(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Focused");
		}

		#endregion

		#region Handle

		public static GetIntPtrHandler GetHandle(Control control)
		{
			return (GetIntPtrHandler)Delegate.CreateDelegate(typeof(GetIntPtrHandler), control, "get_Handle");
		}

		#endregion

		#region HasChildren

		public static GetBooleanHandler GetHasChildren(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_HasChildren");
		}

		#endregion

		#region InvokeRequired

		public static GetBooleanHandler GetInvokeRequired(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_InvokeRequired");
		}

		#endregion

		#region IsDisposed

		public static GetBooleanHandler GetIsDisposed(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_IsDisposed");
		}

		#endregion

		#region IsHandleCreated

		public static GetBooleanHandler GetIsHandleCreated(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_IsHandleCreated");
		}

		#endregion

		#region IsMirrored

		public static GetBooleanHandler GetIsMirrored(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_IsMirrored");
		}

		#endregion

		#region PreferredSize

		public static GetSizeHandler GetPreferredSize(Control control)
		{
			return (GetSizeHandler)Delegate.CreateDelegate(typeof(GetSizeHandler), control, "get_PreferredSize");
		}

		#endregion

		#region ProductName

		public static GetStringHandler GetProductName(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_ProductName");
		}

		#endregion

		#region ProductVersion

		public static GetStringHandler GetProductVersion(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_ProductVersion");
		}

		#endregion

		#region RecreatingHandle

		public static GetBooleanHandler GetRecreatingHandle(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_RecreatingHandle");
		}

		#endregion

		#region Right

		public static GetInt32Handler GetRight(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Right");
		}

		#endregion

		#region TopLevelControl

		public static GetControlHandler GetTopLevelControl(Control control)
		{
			return (GetControlHandler)Delegate.CreateDelegate(typeof(GetControlHandler), control, "get_TopLevelControl");
		}

		#endregion

		#endregion

		#region ReadWrite

		#region AccessibleDefaultActionDescription

		public static GetStringHandler GetAccessibleDefaultActionDescription(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_AccessibleDefaultActionDescription");
		}

		public static SetStringHandler SetAccessibleDefaultActionDescription(Control control)
		{
			return (SetStringHandler)Delegate.CreateDelegate(typeof(SetStringHandler), control, "set_AccessibleDefaultActionDescription");
		}

		#endregion

		#region AccessibleDescription

		public static GetStringHandler GetAccessibleDescription(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_AccessibleDescription");
		}

		public static SetStringHandler SetAccessibleDescription(Control control)
		{
			return (SetStringHandler)Delegate.CreateDelegate(typeof(SetStringHandler), control, "set_AccessibleDescription");
		}

		#endregion

		#region AccessibleName

		public static GetStringHandler GetAccessibleName(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_AccessibleName");
		}

		public static SetStringHandler SetAccessibleName(Control control)
		{
			return (SetStringHandler)Delegate.CreateDelegate(typeof(SetStringHandler), control, "set_AccessibleName");
		}

		#endregion

		#region AccessibleRole

		public static GetAccessibleRoleHandler GetAccessibleRole(Control control)
		{
			return (GetAccessibleRoleHandler)Delegate.CreateDelegate(typeof(GetAccessibleRoleHandler), control, "get_AccessibleRole");
		}

		public static SetAccessibleRoleHandler SetAccessibleRole(Control control)
		{
			return (SetAccessibleRoleHandler)Delegate.CreateDelegate(typeof(SetAccessibleRoleHandler), control, "set_AccessibleRole");
		}

		#endregion

		#region AllowDrop

		public static GetBooleanHandler GetAllowDrop(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_AllowDrop");
		}

		public static SetBooleanHandler SetAllowDrop(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_AllowDrop");
		}

		#endregion

		#region Anchor

		public static GetAnchorStylesHandler GetAnchor(Control control)
		{
			return (GetAnchorStylesHandler)Delegate.CreateDelegate(typeof(GetAnchorStylesHandler), control, "get_Anchor");
		}

		public static SetAnchorStylesHandler SetAnchor(Control control)
		{
			return (SetAnchorStylesHandler)Delegate.CreateDelegate(typeof(SetAnchorStylesHandler), control, "set_Anchor");
		}

		#endregion

		#region AutoScrollOffset

		public static GetPointHandler GetAutoScrollOffset(Control control)
		{
			return (GetPointHandler)Delegate.CreateDelegate(typeof(GetPointHandler), control, "get_AutoScrollOffset");
		}

		public static SetPointHandler SetAutoScrollOffset(Control control)
		{
			return (SetPointHandler)Delegate.CreateDelegate(typeof(SetPointHandler), control, "set_AutoScrollOffset");
		}

		#endregion

		#region AutoSize

		public static GetBooleanHandler GetAutoSize(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_AutoSize");
		}

		public static SetBooleanHandler SetAutoSize(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_AutoSize");
		}

		#endregion

		#region BackColor

		public static GetColorHandler GetBackColor(Control control)
		{
			return (GetColorHandler)Delegate.CreateDelegate(typeof(GetColorHandler), control, "get_BackColor");
		}

		public static SetColorHandler SetBackColor(Control control)
		{
			return (SetColorHandler)Delegate.CreateDelegate(typeof(SetColorHandler), control, "set_BackColor");
		}

		#endregion

		#region BackgroundImage

		public static GetImageHandler GetBackgroundImage(Control control)
		{
			return (GetImageHandler)Delegate.CreateDelegate(typeof(GetImageHandler), control, "get_BackgroundImage");
		}

		public static SetImageHandler SetBackgroundImage(Control control)
		{
			return (SetImageHandler)Delegate.CreateDelegate(typeof(SetImageHandler), control, "set_BackgroundImage");
		}

		#endregion

		#region BackgroundImageLayout

		public static GetImageLayoutHandler GetBackgroundImageLayout(Control control)
		{
			return (GetImageLayoutHandler)Delegate.CreateDelegate(typeof(GetImageLayoutHandler), control, "get_BackgroundImageLayout");
		}

		public static SetImageLayoutHandler SetBackgroundImageLayout(Control control)
		{
			return (SetImageLayoutHandler)Delegate.CreateDelegate(typeof(SetImageLayoutHandler), control, "set_BackgroundImageLayout");
		}

		#endregion

		#region BindingContext

		public static GetBindingContextHandler GetBindingContext(Control control)
		{
			return (GetBindingContextHandler)Delegate.CreateDelegate(typeof(GetBindingContextHandler), control, "get_BindingContext");
		}

		public static SetBindingContextHandler SetBindingContext(Control control)
		{
			return (SetBindingContextHandler)Delegate.CreateDelegate(typeof(SetBindingContextHandler), control, "set_BindingContext");
		}

		#endregion

		#region Bounds

		public static GetRectangleHandler GetBounds(Control control)
		{
			return (GetRectangleHandler)Delegate.CreateDelegate(typeof(GetRectangleHandler), control, "get_Bounds");
		}

		public static SetRectangleHandler SetBounds(Control control)
		{
			return (SetRectangleHandler)Delegate.CreateDelegate(typeof(SetRectangleHandler), control, "set_Bounds");
		}

		#endregion

		#region Capture

		public static GetBooleanHandler GetCapture(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Capture");
		}

		public static SetBooleanHandler SetCapture(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_Capture");
		}

		#endregion

		#region CausesValidation

		public static GetBooleanHandler GetCausesValidation(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_CausesValidation");
		}

		public static SetBooleanHandler SetCausesValidation(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_CausesValidation");
		}

		#endregion

		#region ClientSize

		public static GetSizeHandler GetClientSize(Control control)
		{
			return (GetSizeHandler)Delegate.CreateDelegate(typeof(GetSizeHandler), control, "get_ClientSize");
		}

		public static SetSizeHandler SetClientSize(Control control)
		{
			return (SetSizeHandler)Delegate.CreateDelegate(typeof(SetSizeHandler), control, "set_ClientSize");
		}

		#endregion

		#region ContextMenu

		public static GetContextMenuHandler GetContextMenu(Control control)
		{
			return (GetContextMenuHandler)Delegate.CreateDelegate(typeof(GetContextMenuHandler), control, "get_ContextMenu");
		}

		public static SetContextMenuHandler SetContextMenu(Control control)
		{
			return (SetContextMenuHandler)Delegate.CreateDelegate(typeof(SetContextMenuHandler), control, "set_ContextMenu");
		}

		#endregion

		#region ContextMenuStrip

		public static GetContextMenuStripHandler GetContextMenuStrip(Control control)
		{
			return (GetContextMenuStripHandler)Delegate.CreateDelegate(typeof(GetContextMenuStripHandler), control, "get_ContextMenuStrip");
		}

		public static SetContextMenuStripHandler SetContextMenuStrip(Control control)
		{
			return (SetContextMenuStripHandler)Delegate.CreateDelegate(typeof(SetContextMenuStripHandler), control, "set_ContextMenuStrip");
		}

		#endregion

		#region Cursor

		public static GetCursorHandler GetCursor(Control control)
		{
			return (GetCursorHandler)Delegate.CreateDelegate(typeof(GetCursorHandler), control, "get_Cursor");
		}

		public static SetCursorHandler SetCursor(Control control)
		{
			return (SetCursorHandler)Delegate.CreateDelegate(typeof(SetCursorHandler), control, "set_Cursor");
		}

		#endregion

		#region Dock

		public static GetDockStyleHandler GetDock(Control control)
		{
			return (GetDockStyleHandler)Delegate.CreateDelegate(typeof(GetDockStyleHandler), control, "get_Dock");
		}

		public static SetDockStyleHandler SetDock(Control control)
		{
			return (SetDockStyleHandler)Delegate.CreateDelegate(typeof(SetDockStyleHandler), control, "set_Dock");
		}

		#endregion

		#region Enabled

		public static GetBooleanHandler GetEnabled(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Enabled");
		}

		public static SetBooleanHandler SetEnabled(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_Enabled");
		}

		#endregion

		#region Font

		public static GetFontHandler GetFont(Control control)
		{
			return (GetFontHandler)Delegate.CreateDelegate(typeof(GetFontHandler), control, "get_Font");
		}

		public static SetFontHandler SetFont(Control control)
		{
			return (SetFontHandler)Delegate.CreateDelegate(typeof(SetFontHandler), control, "set_Font");
		}

		#endregion

		#region ForeColor

		public static GetColorHandler GetForeColor(Control control)
		{
			return (GetColorHandler)Delegate.CreateDelegate(typeof(GetColorHandler), control, "get_ForeColor");
		}

		public static SetColorHandler SetForeColor(Control control)
		{
			return (SetColorHandler)Delegate.CreateDelegate(typeof(SetColorHandler), control, "set_ForeColor");
		}

		#endregion

		#region Height

		public static GetInt32Handler GetHeight(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Height");
		}

		public static SetInt32Handler SetHeight(Control control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_Height");
		}

		#endregion

		#region ImeMode

		public static GetImeModeHandler GetImeMode(Control control)
		{
			return (GetImeModeHandler)Delegate.CreateDelegate(typeof(GetImeModeHandler), control, "get_ImeMode");
		}

		public static SetImeModeHandler SetImeMode(Control control)
		{
			return (SetImeModeHandler)Delegate.CreateDelegate(typeof(SetImeModeHandler), control, "set_ImeMode");
		}

		#endregion

		#region IsAccessible

		public static GetBooleanHandler GetIsAccessible(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_IsAccessible");
		}

		public static SetBooleanHandler SetIsAccessible(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_IsAccessible");
		}

		#endregion

		#region Left

		public static GetInt32Handler GetLeft(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Left");
		}

		public static SetInt32Handler SetLeft(Control control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_Left");
		}

		#endregion

		#region Location

		public static GetPointHandler GetLocation(Control control)
		{
			return (GetPointHandler)Delegate.CreateDelegate(typeof(GetPointHandler), control, "get_Location");
		}

		public static SetPointHandler SetLocation(Control control)
		{
			return (SetPointHandler)Delegate.CreateDelegate(typeof(SetPointHandler), control, "set_Location");
		}

		#endregion

		#region Margin

		public static GetPaddingHandler GetMargin(Control control)
		{
			return (GetPaddingHandler)Delegate.CreateDelegate(typeof(GetPaddingHandler), control, "get_Margin");
		}

		public static SetPaddingHandler SetMargin(Control control)
		{
			return (SetPaddingHandler)Delegate.CreateDelegate(typeof(SetPaddingHandler), control, "set_Margin");
		}

		#endregion

		#region MaximumSize

		public static GetSizeHandler GetMaximumSize(Control control)
		{
			return (GetSizeHandler)Delegate.CreateDelegate(typeof(GetSizeHandler), control, "get_MaximumSize");
		}

		public static SetSizeHandler SetMaximumSize(Control control)
		{
			return (SetSizeHandler)Delegate.CreateDelegate(typeof(SetSizeHandler), control, "set_MaximumSize");
		}

		#endregion

		#region MinimumSize

		public static GetSizeHandler GetMinimumSize(Control control)
		{
			return (GetSizeHandler)Delegate.CreateDelegate(typeof(GetSizeHandler), control, "get_MinimumSize");
		}

		public static SetSizeHandler SetMinimumSize(Control control)
		{
			return (SetSizeHandler)Delegate.CreateDelegate(typeof(SetSizeHandler), control, "set_MinimumSize");
		}

		#endregion

		#region Name

		public static GetStringHandler GetName(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_Name");
		}

		public static SetStringHandler SetName(Control control)
		{
			return (SetStringHandler)Delegate.CreateDelegate(typeof(SetStringHandler), control, "set_Name");
		}

		#endregion

		#region Padding

		public static GetPaddingHandler GetPadding(Control control)
		{
			return (GetPaddingHandler)Delegate.CreateDelegate(typeof(GetPaddingHandler), control, "get_Padding");
		}

		public static SetPaddingHandler SetPadding(Control control)
		{
			return (SetPaddingHandler)Delegate.CreateDelegate(typeof(SetPaddingHandler), control, "set_Padding");
		}

		#endregion

		#region Parent

		public static GetControlHandler GetParent(Control control)
		{
			return (GetControlHandler)Delegate.CreateDelegate(typeof(GetControlHandler), control, "get_Parent");
		}

		public static SetControlHandler SetParent(Control control)
		{
			return (SetControlHandler)Delegate.CreateDelegate(typeof(SetControlHandler), control, "set_Parent");
		}

		#endregion

		#region Region

		public static GetRegionHandler GetRegion(Control control)
		{
			return (GetRegionHandler)Delegate.CreateDelegate(typeof(GetRegionHandler), control, "get_Region");
		}

		public static SetRegionHandler SetRegion(Control control)
		{
			return (SetRegionHandler)Delegate.CreateDelegate(typeof(SetRegionHandler), control, "set_Region");
		}

		#endregion

		#region RightToLeft

		public static GetRightToLeftHandler GetRightToLeft(Control control)
		{
			return (GetRightToLeftHandler)Delegate.CreateDelegate(typeof(GetRightToLeftHandler), control, "get_RightToLeft");
		}

		public static SetRightToLeftHandler SetRightToLeft(Control control)
		{
			return (SetRightToLeftHandler)Delegate.CreateDelegate(typeof(SetRightToLeftHandler), control, "set_RightToLeft");
		}

		#endregion

		#region Site

		public static GetISiteHandler GetSite(Control control)
		{
			return (GetISiteHandler)Delegate.CreateDelegate(typeof(GetISiteHandler), control, "get_Site");
		}

		public static SetISiteHandler SetSite(Control control)
		{
			return (SetISiteHandler)Delegate.CreateDelegate(typeof(SetISiteHandler), control, "set_Site");
		}

		#endregion

		#region Size

		public static GetSizeHandler GetSize(Control control)
		{
			return (GetSizeHandler)Delegate.CreateDelegate(typeof(GetSizeHandler), control, "get_Size");
		}

		public static SetSizeHandler SetSize(Control control)
		{
			return (SetSizeHandler)Delegate.CreateDelegate(typeof(SetSizeHandler), control, "set_Size");
		}

		#endregion

		#region TabIndex

		public static GetInt32Handler GetTabIndex(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_TabIndex");
		}

		public static SetInt32Handler SetTabIndex(Control control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_TabIndex");
		}

		#endregion

		#region TabStop

		public static GetBooleanHandler GetTabStop(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_TabStop");
		}

		public static SetBooleanHandler SetTabStop(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_TabStop");
		}

		#endregion

		#region Tag

		public static GetObjectHandler GetTag(Control control)
		{
			return (GetObjectHandler)Delegate.CreateDelegate(typeof(GetObjectHandler), control, "get_Tag");
		}

		public static SetObjectHandler SetTag(Control control)
		{
			return (SetObjectHandler)Delegate.CreateDelegate(typeof(SetObjectHandler), control, "set_Tag");
		}

		#endregion

		#region Text

		public static GetStringHandler GetText(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_Text");
		}

		public static SetStringHandler SetText(Control control)
		{
			return (SetStringHandler)Delegate.CreateDelegate(typeof(SetStringHandler), control, "set_Text");
		}

		#endregion

		#region Top

		public static GetInt32Handler GetTop(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Top");
		}

		public static SetInt32Handler SetTop(Control control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_Top");
		}

		#endregion

		#region UseWaitCursor

		public static GetBooleanHandler GetUseWaitCursor(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_UseWaitCursor");
		}

		public static SetBooleanHandler SetUseWaitCursor(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_UseWaitCursor");
		}

		#endregion

		#region Visible

		public static GetBooleanHandler GetVisible(Control control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Visible");
		}

		public static SetBooleanHandler SetVisible(Control control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_Visible");
		}

		#endregion

		#region Width

		public static GetInt32Handler GetWidth(Control control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Width");
		}

		public static SetInt32Handler SetWidth(Control control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_Width");
		}

		#endregion

		#region WindowTarget

		public static GetIWindowTargetHandler GetWindowTarget(Control control)
		{
			return (GetIWindowTargetHandler)Delegate.CreateDelegate(typeof(GetIWindowTargetHandler), control, "get_WindowTarget");
		}

		public static SetIWindowTargetHandler SetWindowTarget(Control control)
		{
			return (SetIWindowTargetHandler)Delegate.CreateDelegate(typeof(SetIWindowTargetHandler), control, "set_WindowTarget");
		}

		#endregion

		#endregion

		#endregion

		#endregion

		#region TextBoxBase

		#region Methods

		#region AppendText

		public static AppendTextHandler AppendText(TextBoxBase control)
		{
			return (AppendTextHandler)Delegate.CreateDelegate(typeof(AppendTextHandler), control, "AppendText");
		}

		#endregion

		#region Clear

		public static MethodInvoker Clear(TextBoxBase control)
		{
			return (MethodInvoker)Delegate.CreateDelegate(typeof(MethodInvoker), control, "Clear");
		}

		#endregion

		#region Cut

		public static MethodInvoker Cut(TextBoxBase control)
		{
			return (MethodInvoker)Delegate.CreateDelegate(typeof(MethodInvoker), control, "Cut");
		}

		#endregion

		#region Copy

		public static MethodInvoker Copy(TextBoxBase control)
		{
			return (MethodInvoker)Delegate.CreateDelegate(typeof(MethodInvoker), control, "Copy");
		}

		#endregion

		#region Paste

		public static MethodInvoker Paste(TextBoxBase control)
		{
			return (MethodInvoker)Delegate.CreateDelegate(typeof(MethodInvoker), control, "Paste");
		}

		#endregion

		#endregion

		#region Properties

		#region TextLength

		public static GetInt32Handler GetTextLength(TextBoxBase control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_TextLength");
		}

		public static SetInt32Handler SetTextLength(TextBoxBase control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_TextLength");
		}

		#endregion

		#endregion

		#endregion

		#region ListControl

		#region Properties

		#region SelectedIndex

		public static GetInt32Handler GetSelectedIndex(ListControl control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_SelectedIndex");
		}

		public static SetInt32Handler SetSelectedIndex(ListControl control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_SelectedIndex");
		}

		#endregion

		#region SelectedItem

		public static GetObjectHandler GetSelectedItem(ListControl control)
		{
			return (GetObjectHandler)Delegate.CreateDelegate(typeof(GetObjectHandler), control, "get_SelectedItem");
		}

		public static SetObjectHandler SetSelectedItem(ListControl control)
		{
			return (SetObjectHandler)Delegate.CreateDelegate(typeof(SetObjectHandler), control, "set_SelectedItem");
		}

		#endregion

		#endregion

		#endregion

		#region CheckBox

		#region Properties

		#region Checked

		public static GetBooleanHandler GetChecked(CheckBox control)
		{
			return (GetBooleanHandler)Delegate.CreateDelegate(typeof(GetBooleanHandler), control, "get_Checked");
		}

		public static SetBooleanHandler SetChecked(CheckBox control)
		{
			return (SetBooleanHandler)Delegate.CreateDelegate(typeof(SetBooleanHandler), control, "set_Checked");
		}

		#endregion

		#region CheckState

		public static GetCheckStateHandler GetCheckState(CheckBox control)
		{
			return (GetCheckStateHandler)Delegate.CreateDelegate(typeof(GetCheckStateHandler), control, "get_CheckState");
		}

		public static SetCheckStateHandler SetCheckState(CheckBox control)
		{
			return (SetCheckStateHandler)Delegate.CreateDelegate(typeof(SetCheckStateHandler), control, "set_CheckState");
		}

		#endregion

		#endregion

		#endregion

		#region Form

		#region Methods

		public static MethodInvoker Close(Form control)
		{
			return (MethodInvoker)Delegate.CreateDelegate(typeof(MethodInvoker), control, "Close");
		}

		#endregion

		#region Properties

		public static GetDialogResultHandler GetDialogResult(Form control)
		{
			return (GetDialogResultHandler)Delegate.CreateDelegate(typeof(GetDialogResultHandler), control, "get_DialogResult");
		}

		public static SetDialogResultHandler SetDialogResult(Form control)
		{
			return (SetDialogResultHandler)Delegate.CreateDelegate(typeof(SetDialogResultHandler), control, "set_DialogResult");
		}

		#endregion

		#endregion

		#region ProgressBar

		#region Properties

		#region Value

		public static GetInt32Handler GetValue(ProgressBar control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_Value");
		}

		public static SetInt32Handler SetValue(ProgressBar control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_Valuee");
		}

		#endregion

		#endregion

		#endregion

		#region ProgressDisk

		#region Properties

		#region CurrentPiece

		public static GetInt32Handler GetCurrentPiece(ProgressDisk control)
		{
			return (GetInt32Handler)Delegate.CreateDelegate(typeof(GetInt32Handler), control, "get_CurrentPiece");
		}

		public static SetInt32Handler SetCurrentPiece(ProgressDisk control)
		{
			return (SetInt32Handler)Delegate.CreateDelegate(typeof(SetInt32Handler), control, "set_CurrentPiece");
		}

		#endregion

		#region ColorFrom

		public static GetColorHandler GetColorFrom(ProgressDisk control)
		{
			return (GetColorHandler)Delegate.CreateDelegate(typeof(GetColorHandler), control, "get_ColorFrom");
		}

		public static SetColorHandler SetColorFrom(ProgressDisk control)
		{
			return (SetColorHandler)Delegate.CreateDelegate(typeof(SetColorHandler), control, "set_ColorFrom");
		}

		#endregion

		#region ColorTo

		public static GetColorHandler GetColorTo(ProgressDisk control)
		{
			return (GetColorHandler)Delegate.CreateDelegate(typeof(GetColorHandler), control, "get_ColorTo");
		}

		public static SetColorHandler SetColorTo(ProgressDisk control)
		{
			return (SetColorHandler)Delegate.CreateDelegate(typeof(SetColorHandler), control, "set_ColorTo");
		}

		#endregion

		#endregion

		#endregion

		#region HtmlView/HtmlForm

		#region Properties

		#region Html

		public static GetStringHandler GetHtml(Control control)
		{
			return (GetStringHandler)Delegate.CreateDelegate(typeof(GetStringHandler), control, "get_Html");
		}

		public static SetStringHandler SetHtml(Control control)
		{
			return (SetStringHandler)Delegate.CreateDelegate(typeof(SetStringHandler), control, "set_Html");
		}

		#endregion

		#endregion

		#endregion

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
