﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Forms Library                            */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;
using System.Windows.Forms;

namespace Nabu.Forms
{
	public sealed class NonClientMouseEventArgs : MouseEventArgs
	{
		#region Fields

		private HitTestCode _ncHitTest = 0;

		#endregion

		#region Methods

		public NonClientMouseEventArgs(
			MouseButtons button,
			int clicks,
			int x,
			int y,
			int delta,
			HitTestCode ncHitTest
			)
			: base(button, clicks, x, y, delta)
		{
			this._ncHitTest = ncHitTest;
		}

		#endregion

		#region Properties

		public HitTestCode HitTestCode
		{
			[DebuggerStepThrough]
			get { return this._ncHitTest; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
