﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.IO Library                               */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;

namespace Nabu.IO
{
	public sealed class FileEnumerator : IEnumerable<FileFindInfo>
	{
		#region FileEnumerator

		#region Fields

		private string _mask;

		#endregion

		#region Methods

		public FileEnumerator(string mask)
		{
			this._mask = mask;
		}

		#endregion

		#endregion

		#region IEnumerable<FileFindInfo>

		public IEnumerator<FileFindInfo> GetEnumerator()
		{
			FileFindData filefindData;
			IntPtr hSearch =
				NativeMethods.FindFirstFileW(
					this._mask,
					out filefindData);

			if ((hSearch != IntPtr.Zero) && (hSearch != ((IntPtr)(-1))))
			{
				try
				{
					yield return new FileFindInfo(filefindData);

					while (NativeMethods.FindNextFileW(hSearch, out filefindData))
					{
						yield return new FileFindInfo(filefindData);
					}
				}
				finally
				{
					NativeMethods.FindClose(hSearch);
				}
			}

			yield break;
		}

		#endregion

		#region IEnumerable

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
		{
			return ((IEnumerable<FileFindInfo>)this).GetEnumerator();
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
