﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.IO Library                               */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.IO
{
	internal static class NativeMethods
	{
		#region Libraries

#if COMPACT_FRAMEWORK
		private const string Kernel32 = "coredll.dll";
#else
		private const string Kernel32 = "kernel32.dll";
#endif

		#endregion

		#region FindFile

		[DllImport(Kernel32)]
		public static extern IntPtr FindFirstFileW(
			[In][MarshalAs(UnmanagedType.LPWStr)] string mask,
			[Out] out FileFindData filefindData);

		[DllImport(Kernel32)]
		[return: MarshalAs(UnmanagedType.Bool)]
		public static extern bool FindNextFileW(
			[In] IntPtr hSearch,
			[Out] out FileFindData filefindData);

		[DllImport(Kernel32)]
		[return: MarshalAs(UnmanagedType.Bool)]
		public static extern bool FindClose(
			[In] IntPtr hSearch);

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
