﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.IO Library                               */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.IO;
using System.Runtime.InteropServices;

namespace Nabu.IO
{
#if COMPACT_FRAMEWORK
	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
#else
	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode, Pack = 1)]
#endif
	internal struct FileFindData
	{
		[MarshalAs(UnmanagedType.U4)]
		public FileAttributes Attributes;
		public uint CreationTimeLow;
		public uint CreationTimeHigh;
		public uint LastAccessTimeLow;
		public uint LastAccessTimeHigh;
		public uint LastWriteTimeLow;
		public uint LastWriteTimeHigh;
		public uint SizeHigh;
		public uint SizeLow;
		public int Reserved0;
		public int Reserved1;
		[MarshalAs(UnmanagedType.ByValArray, SizeConst = 260)]
		public char[] Name;
		[MarshalAs(UnmanagedType.ByValArray, SizeConst = 14)]
		public char[] AlternateName;
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
