﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.IO Library                               */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.IO
{
	internal sealed class MSCabFolder
	{
		#region Fields

		private int _dataOffset;
		// private ushort _dataCount;
		private MSCabCompressionType _compressionType;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public MSCabFolder(StreamHelper streamHelper)
		{
			this._dataOffset = streamHelper.ReadI4();
			/* this._dataCount = */
			streamHelper.ReadU2();
			this._compressionType = (MSCabCompressionType)streamHelper.ReadU2();
		}

		#endregion

		#region Properties

		public int DataOffset
		{
			[DebuggerStepThrough]
			get { return this._dataOffset; }
		}

		public MSCabCompressionType CompressionType
		{
			[DebuggerStepThrough]
			get { return this._compressionType; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
