﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/

namespace Nabu.Logging
{
	/// <summary>
	/// Object to it's text representation conversion provider.
	/// </summary>
	public interface ILogFormatter
	{
		/// <summary>
		/// Get text representation for a given object.
		/// </summary>
		/// <param name="value">Object to get text representation for.</param>
		/// <param name="lineString">Character sequence representing line break.</param>
		/// <param name="indentString">Character sequence representing indent.</param>
		/// <param name="indentValue">Number of indents to insert at the start of line.</param>
		/// <returns>Text representation for a given object</returns>
		string GetLogString(object value, string lineString, string indentString, int indentValue);
		/// <summary>
		/// Initialize ILogFormatter with given formatting templates list.
		/// </summary>
		/// <param name="templateList">Formatting templates list.</param>
		void Initialize(string[] templateList);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
