﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/

namespace Nabu.Logging
{
	/// <summary>
	/// Logging helper.
	/// <example> Using Log class.
	/// <code>
	/// new Log(LogLevel.Debug, LogSource.Database, "text", 0x12345678);
	/// </code>
	/// </example>
	/// </summary>
	public struct Log
	{
		public Log(params object[] data)
		{
			LogManager.Log(LogLevel.Unknown, LogSource.Unknown, data);
		}

		public Log(LogLevel level, params object[] data)
		{
			LogManager.Log(level, LogSource.Unknown, data);
		}

		public Log(LogSource source, params object[] data)
		{
			LogManager.Log(LogLevel.Unknown, source, data);
		}

		public Log(LogLevel level, LogSource source, params object[] data)
		{
			LogManager.Log(level, source, data);
		}
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
