﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;

namespace Nabu.Logging
{
	internal sealed class LogAsyncRequest
	{
		#region  Variables

		private ILogWriter _writer;
		private LogLevel _level;
		private LogSource _source;
		private DateTime _dateTime;
		private int _threadID;
		private object[] _data;
		private IList<string[]> _stackFrameList;

		#endregion

		#region Methods

		public LogAsyncRequest(ILogWriter writer, LogLevel level, LogSource source, DateTime dateTime, int threadID, object[] data, IList<string[]> stackFrameList)
		{
			this._writer = writer;
			this._level = level;
			this._source = source;
			this._dateTime = dateTime;
			this._threadID = threadID;
			this._data = data;
			this._stackFrameList = stackFrameList;
		}

		#endregion

		#region Properties

		public ILogWriter Writer
		{
			get { return this._writer; }
		}

		public LogLevel Level
		{
			get { return this._level; }
		}

		public LogSource Source
		{
			get { return this._source; }
		}

		public DateTime DateTime
		{
			get { return this._dateTime; }
		}

		public int ThreadID
		{
			get { return this._threadID; }
		}

		public object[] Data
		{
			get { return this._data; }
		}

		public IList<string[]> StackFrames
		{
			get { return this._stackFrameList; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
