﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/

namespace Nabu.Logging
{
	/// <summary>
	/// <see cref="ILogFormatter"/> implementation for <see cref="System.Char"/> type.
	/// </summary>
	public class LogFormatterChar : ILogFormatter
	{
		#region LogFormatterChar

		#region Fields

		private string[] _templateList;

		#endregion

		#region Methods

		public LogFormatterChar()
		{
		}

		#endregion

		#endregion

		#region ILogFormatter

		public void Initialize(string[] templateList)
		{
			this._templateList = templateList;
		}

		public string GetLogString(object value, string lineString, string indentString, int indentValue)
		{
			string symbol;

			switch ((char)value)
			{
				case '\0': symbol = "\\0"; break;
				case '\x01': symbol = "\\x01"; break;
				case '\x02': symbol = "\\x02"; break;
				case '\x03': symbol = "\\x03"; break;
				case '\x04': symbol = "\\x04"; break;
				case '\x05': symbol = "\\x05"; break;
				case '\x06': symbol = "\\x06"; break;
				case '\a': symbol = "\\a"; break;
				case '\b': symbol = "\\b"; break;
				case '\t': symbol = "\\t"; break;
				case '\n': symbol = "\\n"; break;
				case '\x0B': symbol = "\\x0B"; break;
				case '\f': symbol = "\\f"; break;
				case '\r': symbol = "\\r"; break;
				case '\x0E': symbol = "\\x0E"; break;
				case '\x0F': symbol = "\\x0F"; break;
				case '\x10': symbol = "\\x10"; break;
				case '\x11': symbol = "\\x11"; break;
				case '\x12': symbol = "\\x12"; break;
				case '\x13': symbol = "\\x13"; break;
				case '\x14': symbol = "\\x14"; break;
				case '\x15': symbol = "\\x15"; break;
				case '\x16': symbol = "\\x16"; break;
				case '\x17': symbol = "\\x17"; break;
				case '\x18': symbol = "\\x18"; break;
				case '\x19': symbol = "\\x19"; break;
				case '\x1A': symbol = "\\x1A"; break;
				case '\x1B': symbol = "\\x1B"; break;
				case '\x1C': symbol = "\\x1C"; break;
				case '\x1D': symbol = "\\x1D"; break;
				case '\x1E': symbol = "\\x1E"; break;
				case '\x1F': symbol = "\\x1F"; break;
				default: symbol = new string(new char[] { (char)value }); break;
			}

			return string.Format("{1}'{2}'", lineString, LogFormatterIndent.GetIndent(indentString, indentValue), symbol);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
