﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Logging
{
	/// <summary>
	/// <see cref="ILogFormatter"/> implementation for <see cref="System.DateTime"/> type.
	/// </summary>
	public class LogFormatterDateTime : ILogFormatter
	{
		#region LogFormatterDateTime

		#region Fields

		private string[] _templateList;

		#endregion

		#region Methods

		public LogFormatterDateTime()
		{
		}

		#endregion

		#endregion

		#region ILogFormatter

		public void Initialize(string[] templateList)
		{
			this._templateList = templateList;
		}

		public string GetLogString(object value, string lineString, string indentString, int indentValue)
		{
			return LogFormatterIndent.GetIndent(indentString, indentValue) + ((DateTime)value).ToString("yyyy-MM-dd HH:mm:ss");
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
