﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Logging
{
	/// <summary>
	/// <see cref="ILogFormatter"/> implementation for <see cref="System.Exception"/> type.
	/// </summary>
	public class LogFormatterException : ILogFormatter
	{
		#region LogFormatterException

		#region Constants

		private const string Indent = "   ";
		private const string Line = "\r\n";

		#endregion

		#region Fields

		private string[] _templateList;

		#endregion

		#region Methods

		public LogFormatterException()
		{
		}

		#endregion

		#endregion

		#region ILogFormatter

		public void Initialize(string[] templateList)
		{
			this._templateList = templateList;
		}

		public string GetLogString(object value, string lineString, string indentString, int indentValue)
		{
			Exception exception = (Exception)value;

			return string.Format(
				"{1}Exception{0}{1}Message:{0}{2}{3}{0}{1}StackTrace:{0}{4}",
				lineString,
				LogFormatterIndent.GetIndent(indentString, indentValue),
				LogFormatterIndent.GetIndent(indentString, indentValue + 1),
				exception.Message,
				exception.StackTrace
					.Replace(Indent, LogFormatterIndent.GetIndent(indentString, indentValue + 1))
					.Replace(Line, lineString));
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
