﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/

namespace Nabu.Logging
{
	/// <summary>
	/// <see cref="ILogFormatter"/> implementation for <see cref="System.String"/> type.
	/// </summary>
	public class LogFormatterString : ILogFormatter
	{
		#region LogFormatterString

		#region Fields

		private string[] _templateList;

		#endregion

		#region Methods

		public LogFormatterString()
		{
		}

		#endregion

		#endregion

		#region ILogFormatter

		public void Initialize(string[] templateList)
		{
			this._templateList = templateList;
		}

		public string GetLogString(object value, string lineString, string indentString, int indentValue)
		{
			return string.Format(
				"{1}\"{2}\"",
				lineString,
				LogFormatterIndent.GetIndent(indentString, indentValue),
				((string)value)
				.Replace("\0", "'\\0'")
				.Replace("\x01", "'\\x01'")
				.Replace("\x02", "'\\x02'")
				.Replace("\x03", "'\\x03'")
				.Replace("\x04", "'\\x04'")
				.Replace("\x05", "'\\x05'")
				.Replace("\x06", "'\\x06'")
				.Replace("\a", "'\\a'")
				.Replace("\b", "'\\b'")
				.Replace("\t", "'\\t'")
				.Replace("\n", "'\\n'")
				.Replace("\x0B", "'\\x0B'")
				.Replace("\f", "'\\f'")
				.Replace("\r", "'\\r'")
				.Replace("\x0E", "'\\x0E'")
				.Replace("\x0F", "'\\x0F'")
				.Replace("\x10", "'\\x10'")
				.Replace("\x11", "'\\x11'")
				.Replace("\x12", "'\\x12'")
				.Replace("\x13", "'\\x13'")
				.Replace("\x14", "'\\x14'")
				.Replace("\x15", "'\\x15'")
				.Replace("\x16", "'\\x16'")
				.Replace("\x17", "'\\x17'")
				.Replace("\x18", "'\\x18'")
				.Replace("\x19", "'\\x19'")
				.Replace("\x1A", "'\\x1A'")
				.Replace("\x1B", "'\\x1B'")
				.Replace("\x1C", "'\\x1C'")
				.Replace("\x1D", "'\\x1D'")
				.Replace("\x1E", "'\\x1E'")
				.Replace("\x1F", "'\\x1F'"));
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
