﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/

namespace Nabu.Logging
{
	/// <summary>
	/// Default formatting templates for <see cref="ILogFormatter"/> implementations.
	/// </summary>
	public struct LogFormatterTemplate
	{
		public static readonly string[] DefaultTemplateList =
		{
			"{1}{2}",
			"{1}{2}", "{1}{2}", "{1}{2}",
			"{1}{2}", "{1}True", "{1}False",
			"{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}", "{1}{2}",
			"{1}{2}"
		};

		public const int Default = 0;

		public const int Struct = 1;
		public const int Class = 2;
		public const int Interface = 3;

		public const int Boolean = 4;
		public const int BooleanTrue = 5;
		public const int BooleanFalse = 6;

		public const int Int8 = 7;
		public const int UInt8 = 8;
		public const int Int16 = 9;
		public const int UInt16 = 10;
		public const int Int32 = 11;
		public const int UInt32 = 12;
		public const int Int64 = 13;
		public const int UInt64 = 14;
		public const int Single = 15;
		public const int Double = 16;

		public const int Enum = 17;

		public const int TotalCount = 18;
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
