﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Logging Library                          */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.IO;

namespace Nabu.Logging
{
#if TRACE

	/// <summary>
	/// Nabu.Logging internal log writer.
	/// </summary>
	public sealed class LogWriterInternal
	{
		#region Constants

		private const string Path = "\\nabu-log-internal.txt";

		#endregion

		#region Methods

		private LogWriterInternal()
		{
		}

		public static void LogMessage(string message)
		{
			try
			{
				if (message != null)
				{
					System.Diagnostics.Debug.WriteLine(message);

					using (TextWriter textWriter = File.AppendText(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) + Path))
					{
						textWriter.WriteLine(message);
						textWriter.Close();
					}
				}
			}
			catch
			{
			}
		}

		public static void LogException(Exception exception)
		{
			try
			{
				if (exception != null)
				{
					System.Diagnostics.Debug.WriteLine(exception.Message);
					System.Diagnostics.Debug.WriteLine(exception.Source);
					System.Diagnostics.Debug.WriteLine(exception.StackTrace);

					using (TextWriter textWriter = File.AppendText(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) + Path))
					{
						textWriter.WriteLine(exception.Message);
						textWriter.WriteLine(exception.Source);
						textWriter.WriteLine(exception.StackTrace);
						textWriter.Close();
					}
				}
			}
			catch
			{
			}
		}

		#endregion
	}
#endif
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
