﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public sealed class OutlookApplication
	{
		#region Fields

		private IOutlookApplication _application;

		#endregion

		#region Methods

		public OutlookApplication(IntPtr hWindow)
		{
			this._application = (new OutlookApplicationClass()) as IOutlookApplication;
			this._application.Logon(hWindow);
		}

		public void ReceiveFromInfrared()
		{
			this._application.ReceiveFromInfrared();
		}

		#endregion

		#region Properties

		#region Version

		public string Version
		{
			get
			{
				string value;

				this._application.get_Version(out value);

				return value;
			}
		}

		#endregion

		#region Appointments

		public OutlookFolder<OutlookAppointment> Appointments
		{
			get
			{
				IOutlookFolder folder;

				this._application.GetDefaultFolder(OutlookFolderTypes.Calendar, out folder);

				return new OutlookFolder<OutlookAppointment>(folder);
			}
		}

		#endregion

		#region Contacts

		public OutlookFolder<OutlookContact> Contacts
		{
			get
			{
				IOutlookFolder folder;

				this._application.GetDefaultFolder(OutlookFolderTypes.Contacts, out folder);

				return new OutlookFolder<OutlookContact>(folder);
			}
		}

		#endregion

		#region Tasks

		public OutlookFolder<OutlookTask> Tasks
		{
			get
			{
				IOutlookFolder folder;

				this._application.GetDefaultFolder(OutlookFolderTypes.Tasks, out folder);

				return new OutlookFolder<OutlookTask>(folder);
			}
		}

		#endregion

		#region Cities

		public OutlookFolder<OutlookCity> Cities
		{
			get
			{
				IOutlookFolder folder;

				this._application.GetDefaultFolder(OutlookFolderTypes.Cities, out folder);

				return new OutlookFolder<OutlookCity>(folder);
			}
		}

		#endregion

		#region HomeCity

		public OutlookCity HomeCity
		{
			get
			{
				IOutlookCity city;

				this._application.get_HomeCity(out city);

				return new OutlookCity(city);
			}

			set
			{
				this._application.put_HomeCity((IOutlookCity)value.ComObject);
			}
		}

		#endregion

		#region VisitingCity

		public OutlookCity VisitingCity
		{
			get
			{
				IOutlookCity city;

				this._application.get_VisitingCity(out city);

				return new OutlookCity(city);
			}

			set
			{
				this._application.put_VisitingCity((IOutlookCity)value.ComObject);
			}
		}

		#endregion

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
