﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public class OutlookCity : IComObjectWrapper
	{
		#region OutlookCity

		#region Fields

		private IOutlookCity _city;

		#endregion

		#region Methods

		public OutlookCity()
		{
		}

		internal OutlookCity(IOutlookCity city)
		{
			this._city = city;
		}

		public void Save()
		{
			this._city.Save();
		}

		public void Delete()
		{
			this._city.Delete();
		}

		public OutlookCity Copy()
		{
			IOutlookCity city;

			this._city.Copy(out city);

			return new OutlookCity(city);
		}

		#endregion

		#region Properties

		#region Longitude

		public int Longitude
		{
			get
			{
				int value;

				this._city.get_Longitude(out value);

				return value;
			}

			set
			{
				this._city.put_Longitude(value);
			}
		}

		#endregion

		#region Latitude

		public int Latitude
		{
			get
			{
				int value;

				this._city.get_Latitude(out value);

				return value;
			}

			set
			{
				this._city.put_Latitude(value);
			}
		}

		#endregion

		#region TimezoneIndex

		public int TimezoneIndex
		{
			get
			{
				int value;

				this._city.get_TimezoneIndex(out value);

				return value;
			}

			set
			{
				this._city.put_TimezoneIndex(value);
			}
		}

		#endregion

		#region AirportCode

		public string AirportCode
		{
			get
			{
				string value;

				this._city.get_AirportCode(out value);

				return value;
			}

			set
			{
				this._city.put_AirportCode(value);
			}
		}

		#endregion

		#region CountryPhoneCode

		public string CountryPhoneCode
		{
			get
			{
				string value;

				this._city.get_CountryPhoneCode(out value);

				return value;
			}

			set
			{
				this._city.put_CountryPhoneCode(value);
			}
		}

		#endregion

		#region AreaCode

		public string AreaCode
		{
			get
			{
				string value;

				this._city.get_AreaCode(out value);

				return value;
			}

			set
			{
				this._city.put_AreaCode(value);
			}
		}

		#endregion

		#region Name

		public string Name
		{
			get
			{
				string value;

				this._city.get_Name(out value);

				return value;
			}

			set
			{
				this._city.put_Name(value);
			}
		}

		#endregion

		#region Country

		public string Country
		{
			get
			{
				string value;

				this._city.get_Country(out value);

				return value;
			}

			set
			{
				this._city.put_Country(value);
			}
		}

		#endregion

		#region IsBuildIn

		public bool IsBuildIn
		{
			get
			{
				bool value;

				this._city.get_InROM(out value);

				return value;
			}
		}

		#endregion

		#endregion

		#endregion

		#region IComObjectWrapper

		public object ComObject
		{
			get { return this._city; }
			set { this._city = (IOutlookCity)value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
