﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public class OutlookContact : IComObjectWrapper
	{
		#region OutlookContact

		#region Fields

		private IOutlookContact _contact;

		#endregion

		#region Methods

		public OutlookContact()
		{
		}

		internal OutlookContact(IOutlookContact contact)
		{
			this._contact = contact;
		}

		public void Save()
		{
			this._contact.Save();
		}

		public void Delete()
		{
			this._contact.Delete();
		}

		public OutlookContact Copy()
		{
			IOutlookContact city;

			this._contact.Copy(out city);

			return new OutlookContact(city);
		}

		public void Display()
		{
			this._contact.Display();
		}

		#endregion

		#region Properties

		#region Birthday

		public DateTime Birthday
		{
			get
			{
				double oleTime;

				this._contact.get_Birthday(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day);
			}

			set
			{
				SystemTime systemTime = new SystemTime();

				systemTime.Year = (short)value.Year;
				systemTime.Month = (short)value.Month;
				systemTime.Day = (short)value.Day;

				double oleTime;

				NativeMethods.SystemTimeToVariantTime(ref systemTime, out oleTime);

				this._contact.put_Birthday(oleTime);
			}
		}

		#endregion

		#region Anniversary

		public DateTime Anniversary
		{
			get
			{
				double oleTime;

				this._contact.get_Anniversary(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day);
			}

			set
			{
				SystemTime systemTime = new SystemTime();

				systemTime.Year = (short)value.Year;
				systemTime.Month = (short)value.Month;
				systemTime.Day = (short)value.Day;

				double oleTime;

				NativeMethods.SystemTimeToVariantTime(ref systemTime, out oleTime);

				this._contact.put_Anniversary(oleTime);
			}
		}

		#endregion

		#region BusinessFaxNumber

		public string BusinessFaxNumber
		{
			get
			{
				string value;

				this._contact.get_BusinessFaxNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessFaxNumber(value);
			}
		}

		#endregion

		#region CompanyName

		public string CompanyName
		{
			get
			{
				string value;

				this._contact.get_CompanyName(out value);

				return value;
			}

			set
			{
				this._contact.put_CompanyName(value);
			}
		}

		#endregion

		#region Department

		public string Department
		{
			get
			{
				string value;

				this._contact.get_Department(out value);

				return value;
			}

			set
			{
				this._contact.put_Department(value);
			}
		}

		#endregion

		#region Email1Address

		public string Email1Address
		{
			get
			{
				string value;

				this._contact.get_Email1Address(out value);

				return value;
			}

			set
			{
				this._contact.put_Email1Address(value);
			}
		}

		#endregion

		#region MobileTelephoneNumber

		public string MobileTelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_MobileTelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_MobileTelephoneNumber(value);
			}
		}

		#endregion

		#region OfficeLocation

		public string OfficeLocation
		{
			get
			{
				string value;

				this._contact.get_OfficeLocation(out value);

				return value;
			}

			set
			{
				this._contact.put_OfficeLocation(value);
			}
		}

		#endregion

		#region PagerNumber

		public string PagerNumber
		{
			get
			{
				string value;

				this._contact.get_PagerNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_PagerNumber(value);
			}
		}

		#endregion

		#region BusinessTelephoneNumber

		public string BusinessTelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_BusinessTelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessTelephoneNumber(value);
			}
		}

		#endregion

		#region JobTitle

		public string JobTitle
		{
			get
			{
				string value;

				this._contact.get_JobTitle(out value);

				return value;
			}

			set
			{
				this._contact.put_JobTitle(value);
			}
		}

		#endregion

		#region HomeTelephoneNumber

		public string HomeTelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_HomeTelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeTelephoneNumber(value);
			}
		}

		#endregion

		#region Email2Address

		public string Email2Address
		{
			get
			{
				string value;

				this._contact.get_Email2Address(out value);

				return value;
			}

			set
			{
				this._contact.put_Email2Address(value);
			}
		}

		#endregion

		#region Spouse

		public string Spouse
		{
			get
			{
				string value;

				this._contact.get_Spouse(out value);

				return value;
			}

			set
			{
				this._contact.put_Spouse(value);
			}
		}

		#endregion

		#region Email3Address

		public string Email3Address
		{
			get
			{
				string value;

				this._contact.get_Email3Address(out value);

				return value;
			}

			set
			{
				this._contact.put_Email3Address(value);
			}
		}

		#endregion

		#region Home2TelephoneNumber

		public string Home2TelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_Home2TelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_Home2TelephoneNumber(value);
			}
		}

		#endregion

		#region HomeFaxNumber

		public string HomeFaxNumber
		{
			get
			{
				string value;

				this._contact.get_HomeFaxNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeFaxNumber(value);
			}
		}

		#endregion

		#region CarTelephoneNumber

		public string CarTelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_CarTelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_CarTelephoneNumber(value);
			}
		}

		#endregion

		#region AssistantName

		public string AssistantName
		{
			get
			{
				string value;

				this._contact.get_AssistantName(out value);

				return value;
			}

			set
			{
				this._contact.put_AssistantName(value);
			}
		}

		#endregion

		#region AssistantTelephoneNumber

		public string AssistantTelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_AssistantTelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_AssistantTelephoneNumber(value);
			}
		}

		#endregion

		#region Children

		public string Children
		{
			get
			{
				string value;

				this._contact.get_Children(out value);

				return value;
			}

			set
			{
				this._contact.put_Children(value);
			}
		}

		#endregion

		#region Categories

		public string Categories
		{
			get
			{
				string value;

				this._contact.get_Categories(out value);

				return value;
			}

			set
			{
				this._contact.put_Categories(value);
			}
		}

		#endregion

		#region WebPage

		public string WebPage
		{
			get
			{
				string value;

				this._contact.get_WebPage(out value);

				return value;
			}

			set
			{
				this._contact.put_WebPage(value);
			}
		}

		#endregion

		#region Business2TelephoneNumber

		public string Business2TelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_Business2TelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_Business2TelephoneNumber(value);
			}
		}

		#endregion

		#region Title

		public string Title
		{
			get
			{
				string value;

				this._contact.get_Title(out value);

				return value;
			}

			set
			{
				this._contact.put_Title(value);
			}
		}

		#endregion

		#region FirstName

		public string FirstName
		{
			get
			{
				string value;

				this._contact.get_FirstName(out value);

				return value;
			}

			set
			{
				this._contact.put_FirstName(value);
			}
		}

		#endregion

		#region MiddleName

		public string MiddleName
		{
			get
			{
				string value;

				this._contact.get_MiddleName(out value);

				return value;
			}

			set
			{
				this._contact.put_MiddleName(value);
			}
		}

		#endregion

		#region LastName

		public string LastName
		{
			get
			{
				string value;

				this._contact.get_LastName(out value);

				return value;
			}

			set
			{
				this._contact.put_LastName(value);
			}
		}

		#endregion

		#region Suffix

		public string Suffix
		{
			get
			{
				string value;

				this._contact.get_Suffix(out value);

				return value;
			}

			set
			{
				this._contact.put_Suffix(value);
			}
		}

		#endregion

		#region HomeAddressStreet

		public string HomeAddressStreet
		{
			get
			{
				string value;

				this._contact.get_HomeAddressStreet(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeAddressStreet(value);
			}
		}

		#endregion

		#region HomeAddressCity

		public string HomeAddressCity
		{
			get
			{
				string value;

				this._contact.get_HomeAddressCity(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeAddressCity(value);
			}
		}

		#endregion

		#region HomeAddressState

		public string HomeAddressState
		{
			get
			{
				string value;

				this._contact.get_HomeAddressState(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeAddressState(value);
			}
		}

		#endregion

		#region HomeAddressPostalCode

		public string HomeAddressPostalCode
		{
			get
			{
				string value;

				this._contact.get_HomeAddressPostalCode(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeAddressPostalCode(value);
			}
		}

		#endregion

		#region HomeAddressCountry

		public string HomeAddressCountry
		{
			get
			{
				string value;

				this._contact.get_HomeAddressCountry(out value);

				return value;
			}

			set
			{
				this._contact.put_HomeAddressCountry(value);
			}
		}

		#endregion

		#region OtherAddressStreet

		public string OtherAddressStreet
		{
			get
			{
				string value;

				this._contact.get_OtherAddressStreet(out value);

				return value;
			}

			set
			{
				this._contact.put_OtherAddressStreet(value);
			}
		}

		#endregion

		#region OtherAddressCity

		public string OtherAddressCity
		{
			get
			{
				string value;

				this._contact.get_OtherAddressCity(out value);

				return value;
			}

			set
			{
				this._contact.put_OtherAddressCity(value);
			}
		}

		#endregion

		#region OtherAddressState

		public string OtherAddressState
		{
			get
			{
				string value;

				this._contact.get_OtherAddressState(out value);

				return value;
			}

			set
			{
				this._contact.put_OtherAddressState(value);
			}
		}

		#endregion

		#region OtherAddressPostalCode

		public string OtherAddressPostalCode
		{
			get
			{
				string value;

				this._contact.get_OtherAddressPostalCode(out value);

				return value;
			}

			set
			{
				this._contact.put_OtherAddressPostalCode(value);
			}
		}

		#endregion

		#region OtherAddressCountry

		public string OtherAddressCountry
		{
			get
			{
				string value;

				this._contact.get_OtherAddressCountry(out value);

				return value;
			}

			set
			{
				this._contact.put_OtherAddressCountry(value);
			}
		}

		#endregion

		#region BusinessAddressStreet

		public string BusinessAddressStreet
		{
			get
			{
				string value;

				this._contact.get_BusinessAddressStreet(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessAddressStreet(value);
			}
		}

		#endregion

		#region BusinessAddressCity

		public string BusinessAddressCity
		{
			get
			{
				string value;

				this._contact.get_BusinessAddressCity(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessAddressCity(value);
			}
		}

		#endregion

		#region BusinessAddressState

		public string BusinessAddressState
		{
			get
			{
				string value;

				this._contact.get_BusinessAddressState(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessAddressState(value);
			}
		}

		#endregion

		#region BusinessAddressPostalCode

		public string BusinessAddressPostalCode
		{
			get
			{
				string value;

				this._contact.get_BusinessAddressPostalCode(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessAddressPostalCode(value);
			}
		}

		#endregion

		#region BusinessAddressCountry

		public string BusinessAddressCountry
		{
			get
			{
				string value;

				this._contact.get_BusinessAddressCountry(out value);

				return value;
			}

			set
			{
				this._contact.put_BusinessAddressCountry(value);
			}
		}

		#endregion

		#region RadioTelephoneNumber

		public string RadioTelephoneNumber
		{
			get
			{
				string value;

				this._contact.get_RadioTelephoneNumber(out value);

				return value;
			}

			set
			{
				this._contact.put_RadioTelephoneNumber(value);
			}
		}

		#endregion

		#region FileAs

		public string FileAs
		{
			get
			{
				string value;

				this._contact.get_FileAs(out value);

				return value;
			}

			set
			{
				this._contact.put_FileAs(value);
			}
		}

		#endregion

		#region Body

		public string Body
		{
			get
			{
				string value;

				this._contact.get_Body(out value);

				return value;
			}

			set
			{
				this._contact.put_Body(value);
			}
		}

		#endregion

		#region YomiCompanyName

		public string YomiCompanyName
		{
			get
			{
				string value;

				this._contact.get_YomiCompanyName(out value);

				return value;
			}

			set
			{
				this._contact.put_YomiCompanyName(value);
			}
		}

		#endregion

		#region YomiFirstName

		public string YomiFirstName
		{
			get
			{
				string value;

				this._contact.get_YomiFirstName(out value);

				return value;
			}

			set
			{
				this._contact.put_YomiFirstName(value);
			}
		}

		#endregion

		#region YomiLastName

		public string YomiLastName
		{
			get
			{
				string value;

				this._contact.get_YomiLastName(out value);

				return value;
			}

			set
			{
				this._contact.put_YomiLastName(value);
			}
		}

		#endregion

		#endregion

		#endregion

		#region IComObjectWrapper

		public object ComObject
		{
			get { return this._contact; }
			set { this._contact = (IOutlookContact)value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
