﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public class OutlookException
	{
		#region OutlookException

		#region Fields

		private IOutlookException _exception;

		#endregion

		#region Methods

		internal OutlookException(IOutlookException exception)
		{
			this._exception = exception;
		}

		#endregion

		#region Properties

		#region Appointment

		public OutlookAppointment Appointment
		{
			get
			{
				IOutlookAppointment appointment;

				this._exception.get_AppointmentItem(out appointment);

				return new OutlookAppointment(appointment);
			}
		}

		#endregion

		#region OriginalDate

		public DateTime OriginalDate
		{
			get
			{
				double oleTime;

				this._exception.get_OriginalDate(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day,
						systemTime.Hour,
						systemTime.Minute,
						systemTime.Second,
						systemTime.Millisecond);
			}
		}

		#endregion

		#region IsDeleted

		public bool IsDeleted
		{
			get
			{
				bool value;

				this._exception.get_Deleted(out value);

				return value;
			}
		}

		#endregion

		#endregion

		#endregion

		#region IComObjectWrapper

		public object ComObject
		{
			get { return this._exception; }
			set { this._exception = (IOutlookException)value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
