﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;

namespace Nabu.Messaging
{
	public class OutlookExceptionCollection : IEnumerable<OutlookException>
	{
		#region OutlookExceptionCollection

		#region Fields

		private IOutlookExceptions _collection;

		#endregion

		#region Methods

		internal OutlookExceptionCollection(IOutlookExceptions collection)
		{
			this._collection = collection;
		}

		#endregion

		#region Properties

		public OutlookException this[int index]
		{
			get
			{
				IOutlookException item;

				this._collection.Item(index, out item);

				return new OutlookException(item);
			}
		}

		public int Count
		{
			get
			{
				int value;

				this._collection.get_Count(out value);

				return value;
			}
		}

		#endregion

		#endregion

		#region IEnumerable

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
		{
			return ((IEnumerable<OutlookException>)this).GetEnumerator();
		}

		#endregion

		#region IEnumerable<OutlookRecipient>

		public IEnumerator<OutlookException> GetEnumerator()
		{
			IEnumVariant enumVariant = null;

			this._collection.get__NewEnum(out enumVariant);

			object value;
			int fetched;

			while (
				(enumVariant.Next(1, out value, out fetched) == ComResult.S_OK) &&
				(fetched == 1))
			{
				yield return new OutlookException(value as IOutlookException);
			}

			yield break;
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
