﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public sealed class OutlookFolder<T> where T : new()
	{
		#region Fields

		private IOutlookFolder _folder;

		#endregion

		#region Methods

		internal OutlookFolder(IOutlookFolder folder)
		{
			this._folder = folder;
		}

		public void SendToInfrared()
		{
			this._folder.SendToInfrared();
		}

		#endregion

		#region Properties

		public OutlookItemCollection<T> Items
		{
			get
			{
				IOutlookItemCollection items;

				this._folder.get_Items(out items);

				return new OutlookItemCollection<T>(items);
			}
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
