﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
namespace Nabu.Messaging
{
	public class OutlookRecipient : IComObjectWrapper
	{
		#region OutlookRecipient

		#region Fields

		private IOutlookRecipient _recipient;

		#endregion

		#region Methods

		internal OutlookRecipient(IOutlookRecipient recipient)
		{
			this._recipient = recipient;
		}

		public bool Resolve(bool showDialog)
		{
			bool isResolved;

			this._recipient.Resolve(showDialog, out isResolved);

			return isResolved;
		}

		#endregion

		#region Properties

		#region Address

		public string Address
		{
			get
			{
				string value;

				this._recipient.get_Address(out value);

				return value;
			}

			set
			{
				this._recipient.put_Address(value);
			}
		}

		#endregion

		#region Name

		public string Name
		{
			get
			{
				string value;

				this._recipient.get_Name(out value);

				return value;
			}
		}

		#endregion

		#endregion

		#endregion

		#region IComObjectWrapper

		public object ComObject
		{
			get { return this._recipient; }
			set { this._recipient = (IOutlookRecipient)value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
