﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;

namespace Nabu.Messaging
{
	public class OutlookRecipientCollection : IEnumerable<OutlookRecipient>
	{
		#region OutlookRecipientCollection

		#region Fields

		private IOutlookRecipients _collection;

		#endregion

		#region Methods

		internal OutlookRecipientCollection(IOutlookRecipients collection)
		{
			this._collection = collection;
		}

		public OutlookRecipient Add(string name)
		{
			IOutlookRecipient item;

			this._collection.Add(name, out item);

			return new OutlookRecipient(item);
		}

		public void RemoveAt(int index)
		{
			this._collection.Remove(index);
		}

		#endregion

		#region Properties

		public OutlookRecipient this[int index]
		{
			get
			{
				IOutlookRecipient item;

				this._collection.Item(index, out item);

				return new OutlookRecipient(item);
			}
		}

		public int Count
		{
			get
			{
				int value;

				this._collection.get_Count(out value);

				return value;
			}
		}

		#endregion

		#endregion

		#region IEnumerable

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
		{
			return ((IEnumerable<OutlookRecipient>)this).GetEnumerator();
		}

		#endregion

		#region IEnumerable<OutlookRecipient>

		public IEnumerator<OutlookRecipient> GetEnumerator()
		{
			IEnumVariant enumVariant = null;

			this._collection.get__NewEnum(out enumVariant);

			object value;
			int fetched;

			while (
				(enumVariant.Next(1, out value, out fetched) == ComResult.S_OK) &&
				(fetched == 1))
			{
				yield return new OutlookRecipient(value as IOutlookRecipient);
			}

			yield break;
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
