﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public class OutlookTask
	{
		#region OutlookTask

		#region Fields

		private IOutlookTask _task;

		#endregion

		#region Methods

		public OutlookTask()
		{
		}

		internal OutlookTask(IOutlookTask task)
		{
			this._task = task;
		}

		public void Save()
		{
			this._task.Save();
		}

		public void Delete()
		{
			this._task.Delete();
		}

		public void SkipRecurrence()
		{
			this._task.SkipRecurrence();
		}

		public OutlookTask Copy()
		{
			IOutlookTask task;

			this._task.Copy(out task);

			return new OutlookTask(task);
		}

		public void Display()
		{
			this._task.Display();
		}

		#endregion

		#region Properties

		#region RecurrencePattern

		public OutlookRecurrencePattern RecurrencePattern
		{
			get
			{
				IOutlookRecurrencePattern value;

				this._task.GetRecurrencePattern(out value);

				return new OutlookRecurrencePattern(value);
			}

			set
			{
				if (value == null)
				{
					this._task.ClearRecurrencePattern();
				}
			}
		}

		#endregion

		#region IsRecurring

		public bool IsRecurring
		{
			get
			{
				bool value;

				this._task.get_IsRecurring(out value);

				return value;
			}
		}

		#endregion

		#region Subject

		public string Subject
		{
			get
			{
				string value;

				this._task.get_Subject(out value);

				return value;
			}

			set
			{
				this._task.put_Subject(value);
			}
		}

		#endregion

		#region Categories

		public string Categories
		{
			get
			{
				string value;

				this._task.get_Categories(out value);

				return value;
			}

			set
			{
				this._task.put_Categories(value);
			}
		}

		#endregion

		#region StartDate

		public DateTime StartDate
		{
			get
			{
				double oleTime;

				this._task.get_StartDate(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day);
			}

			set
			{
				SystemTime systemTime = new SystemTime();

				systemTime.Year = (short)value.Year;
				systemTime.Month = (short)value.Month;
				systemTime.Day = (short)value.Day;

				double oleTime;

				NativeMethods.SystemTimeToVariantTime(ref systemTime, out oleTime);

				this._task.put_StartDate(oleTime);
			}
		}

		#endregion

		#region DueDate

		public DateTime DueDate
		{
			get
			{
				double oleTime;

				this._task.get_DueDate(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day);
			}

			set
			{
				SystemTime systemTime = new SystemTime();

				systemTime.Year = (short)value.Year;
				systemTime.Month = (short)value.Month;
				systemTime.Day = (short)value.Day;

				double oleTime;

				NativeMethods.SystemTimeToVariantTime(ref systemTime, out oleTime);

				this._task.put_DueDate(oleTime);
			}
		}

		#endregion

		#region DateCompleted

		public DateTime DateCompleted
		{
			get
			{
				double oleTime;

				this._task.get_DateCompleted(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day);
			}
		}

		#endregion

		#region Importance

		public OutlookPriority Importance
		{
			get
			{
				OutlookPriority value;

				this._task.get_Importance(out value);

				return value;
			}

			set
			{
				this._task.put_Importance(value);
			}
		}

		#endregion

		#region IsComplete

		public bool IsComplete
		{
			get
			{
				bool value;

				this._task.get_Complete(out value);

				return value;
			}

			set
			{
				this._task.put_Complete(value);
			}
		}

		#endregion

		#region Sensitivity

		public OutlookSensitivity Sensitivity
		{
			get
			{
				OutlookSensitivity value;

				this._task.get_Sensitivity(out value);

				return value;
			}

			set
			{
				this._task.put_Sensitivity(value);
			}
		}

		#endregion

		#region IsTeamTask

		public bool IsTeamTask
		{
			get
			{
				bool value;

				this._task.get_TeamTask(out value);

				return value;
			}

			set
			{
				this._task.put_TeamTask(value);
			}
		}

		#endregion

		#region Body

		public string Body
		{
			get
			{
				string value;

				this._task.get_Body(out value);

				return value;
			}

			set
			{
				this._task.put_Body(value);
			}
		}

		#endregion

		#region IsReminderSet

		public bool IsReminderSet
		{
			get
			{
				bool value;

				this._task.get_ReminderSet(out value);

				return value;
			}

			set
			{
				this._task.put_ReminderSet(value);
			}
		}

		#endregion

		#region ReminderSoundFile

		public string ReminderSoundFile
		{
			get
			{
				string value;

				this._task.get_ReminderSoundFile(out value);

				return value;
			}

			set
			{
				this._task.put_ReminderSoundFile(value);
			}
		}

		#endregion

		#region ReminderTime

		public DateTime ReminderTime
		{
			get
			{
				double oleTime;

				this._task.get_ReminderTime(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day,
						systemTime.Hour,
						systemTime.Minute,
						systemTime.Second,
						systemTime.Millisecond);
			}

			set
			{
				SystemTime systemTime = new SystemTime();

				systemTime.Year = (short)value.Year;
				systemTime.Month = (short)value.Month;
				systemTime.Day = (short)value.Day;
				systemTime.Hour = (short)value.Hour;
				systemTime.Minute = (short)value.Minute;
				systemTime.Second = (short)value.Second;
				systemTime.Millisecond = (short)value.Millisecond;

				double oleTime;

				NativeMethods.SystemTimeToVariantTime(ref systemTime, out oleTime);

				this._task.put_ReminderTime(oleTime);
			}
		}

		#endregion

		#region ReminderOptions

		public OutlookReminderOptions ReminderOptions
		{
			get
			{
				OutlookReminderOptions value;

				this._task.get_ReminderOptions(out value);

				return value;
			}

			set
			{
				this._task.put_ReminderOptions(value);
			}
		}

		#endregion

		#endregion

		#endregion

		#region IComObjectWrapper

		public object ComObject
		{
			get { return this._task; }
			set { this._task = (IOutlookTask)value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
