﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Messaging
{
	public class OutlookTimezone
	{
		#region Fields

		private IOutlookTimezone _timezone;

		#endregion

		#region Methods

		internal OutlookTimezone(IOutlookTimezone timezone)
		{
			this._timezone = timezone;
		}

		#endregion

		#region Properties

		#region Bias

		public int Bias
		{
			get
			{
				int value;

				this._timezone.get_Bias(out value);

				return value;
			}
		}

		#endregion

		#region IsDstSupported

		public bool IsDstSupported
		{
			get
			{
				bool value;

				this._timezone.get_SupportsDST(out value);

				return value;
			}
		}

		#endregion

		#region IsStandardAbsoluteDate

		public bool IsStandardAbsoluteDate
		{
			get
			{
				bool value;

				this._timezone.get_IsStandardAbsoluteDate(out value);

				return value;
			}
		}

		#endregion

		#region IsDaylightAbsoluteDate

		public bool IsDaylightAbsoluteDate
		{
			get
			{
				bool value;

				this._timezone.get_IsDaylightAbsoluteDate(out value);

				return value;
			}
		}

		#endregion

		#region StandardBias

		public int StandardBias
		{
			get
			{
				int value;

				this._timezone.get_StandardBias(out value);

				return value;
			}
		}

		#endregion

		#region StandardName

		public string StandardName
		{
			get
			{
				string value;

				this._timezone.get_StandardName(out value);

				return value;
			}
		}

		#endregion

		#region StandardDate

		public DateTime StandardDate
		{
			get
			{
				double oleTime;

				this._timezone.get_StandardDate(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day,
						systemTime.Hour,
						systemTime.Minute,
						systemTime.Second,
						systemTime.Millisecond);
			}
		}

		#endregion

		#region StandardDayOfWeekMask

		public OutlookDaysOfWeek StandardDayOfWeekMask
		{
			get
			{
				OutlookDaysOfWeek value;

				this._timezone.get_StandardDayOfWeekMask(out value);

				return value;
			}
		}

		#endregion

		#region StandardInstance

		public int StandardInstance
		{
			get
			{
				int value;

				this._timezone.get_StandardInstance(out value);

				return value;
			}
		}

		#endregion

		#region StandardMonthOfYear

		public int StandardMonthOfYear
		{
			get
			{
				int value;

				this._timezone.get_StandardMonthOfYear(out value);

				return value;
			}
		}

		#endregion

		#region DaylightBias

		public int DaylightBias
		{
			get
			{
				int value;

				this._timezone.get_DaylightBias(out value);

				return value;
			}
		}

		#endregion

		#region DaylightName

		public string DaylightName
		{
			get
			{
				string value;

				this._timezone.get_DaylightName(out value);

				return value;
			}
		}

		#endregion

		#region DaylightDate

		public DateTime DaylightDate
		{
			get
			{
				double oleTime;

				this._timezone.get_DaylightDate(out oleTime);

				SystemTime systemTime;

				NativeMethods.VariantTimeToSystemTime(oleTime, out systemTime);

				return
					new DateTime(
						systemTime.Year,
						systemTime.Month,
						systemTime.Day,
						systemTime.Hour,
						systemTime.Minute,
						systemTime.Second,
						systemTime.Millisecond);
			}
		}

		#endregion

		#region DaylightDayOfWeekMask

		public OutlookDaysOfWeek DaylightDayOfWeekMask
		{
			get
			{
				OutlookDaysOfWeek value;

				this._timezone.get_DaylightDayOfWeekMask(out value);

				return value;
			}
		}

		#endregion

		#region DaylightInstance

		public int DaylightInstance
		{
			get
			{
				int value;

				this._timezone.get_DaylightInstance(out value);

				return value;
			}
		}

		#endregion

		#region DaylightMonthOfYear

		public int DaylightMonthOfYear
		{
			get
			{
				int value;

				this._timezone.get_DaylightMonthOfYear(out value);

				return value;
			}
		}

		#endregion

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
