﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("05058F22-20BE-11d2-8F18-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookApplication
	{
		void Logon(IntPtr hWnd);
		void Logoff();
		void get_Version(
			[Out][MarshalAs(UnmanagedType.BStr)] out string version);
		void GetDefaultFolder(
			[In][MarshalAs(UnmanagedType.U4)] OutlookFolderTypes folderKind,
			[Out] out IOutlookFolder folder);
		void CreateItem(
			[In][MarshalAs(UnmanagedType.U4)] OutlookItemTypes itemType,
			[Out][MarshalAs(UnmanagedType.IDispatch)] object item);
		void GetItemFromOid(
			[In] int oid,
			[Out][MarshalAs(UnmanagedType.IDispatch)] object item);
		void get_HomeCity(
			[Out] out IOutlookCity value);
		void put_HomeCity(
			[In] IOutlookCity value);
		void get_VisitingCity(
			[Out] out IOutlookCity value);
		void put_VisitingCity(
			[In] IOutlookCity value);
		void get_CurrentCityIndex(
			[Out] out int value);
		void get_CurrentCityIndex(
			[In] int value);
		void ReceiveFromInfrared();
		void get_OutlookCompatible(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void GetTimeZoneFromIndex(
			[In] int timeZoneIndex,
			[Out] out IOutlookTimezone timeZone);
		void GetTimeZoneInformationFromIndex(
			[In] int timeZoneIndex,
			[Out] out TimeZoneInfo tzInfo);
		void get_Application(
			[Out] out IOutlookApplication application);
		void SysFreeString(
			[In] IntPtr bstr);
		void VariantTimeToSystemTime(
			[In] double date,
			[Out] out SystemTime st);
		void SystemTimeToVariantTime(
			[In] ref SystemTime st,
			[Out] out double date);
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
