﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("5B43F691-202C-11d2-8F18-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookAppointment
	{
		void ClearRecurrencePattern();
		void GetRecurrencePattern(
			[Out] out IOutlookRecurrencePattern recurrencePattern);
		void get_IsRecurring(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_Subject(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Location(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Categories(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Start(
			[Out] out double value);
		void get_Duration(
			[Out] out int value);
		void get_End(
			[Out] out double value);
		void get_AllDayEvent(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_BusyStatus(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookBusyStatus value);
		void get_Sensitivity(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookSensitivity value);
		void get_Body(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Recipients(
			[Out] out IOutlookRecipients recipients);
		void get_MeetingStatus(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookMeetingStatus value);
		void get_ReminderSet(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_ReminderSoundFile(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_ReminderMinutesBeforeStart(
			[Out] out int value);
		void get_ReminderOptions(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookReminderOptions value);
		void put_Subject(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Location(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Categories(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Start(
			[In] double value);
		void put_Duration(
			[In] int value);
		void put_End(
			[In] double value);
		void put_AllDayEvent(
			[In][MarshalAs(UnmanagedType.VariantBool)] bool value);
		void put_BusyStatus(
			[In][MarshalAs(UnmanagedType.U4)] OutlookBusyStatus value);
		void put_Sensitivity(
			[In][MarshalAs(UnmanagedType.U4)] OutlookSensitivity value);
		void put_Body(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_ReminderSet(
			[In][MarshalAs(UnmanagedType.VariantBool)] bool value);
		void put_ReminderSoundFile(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_ReminderMinutesBeforeStart(
			[In] int value);
		void put_ReminderOptions(
			[In][MarshalAs(UnmanagedType.U4)] OutlookReminderOptions value);
		void Save();
		void Send();
		void Delete();
		void Cancel();
		void Copy(
			[Out] out IOutlookAppointment appointment);
		void Display();
		void get_Oid(
			[Out] out int oid);
		void put_BodyInk(
			[In] ref Blob value);
		void get_BodyInk(
			[Out] out Blob value);
		void get_Application(
			[Out] out IOutlookApplication application);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
