﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("C83C5E90-3D1B-11d2-8F1B-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookCity
	{
		void get_Longitude(
			[Out] out int value);
		void get_Latitude(
			[Out] out int value);
		void get_TimezoneIndex(
			[Out] out int value);
		void get_AirportCode(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_CountryPhoneCode(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_AreaCode(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Name(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Country(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_InROM(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void put_Longitude(
			[In] int value);
		void put_Latitude(
			[In] int value);
		void put_TimezoneIndex(
			[In] int value);
		void put_AirportCode(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_CountryPhoneCode(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_AreaCode(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Name(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Country(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void Save();
		void Delete();
		void Copy(
			[Out] out IOutlookCity city);
		void get_Application(
			[Out] out IOutlookApplication application);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
