﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("7F804E40-2010-11d2-8F18-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookContact
	{
		void get_Birthday(
			[Out] out double value);
		void get_Anniversary(
			[Out] out double value);
		void get_BusinessFaxNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_CompanyName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Department(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Email1Address(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_MobileTelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_OfficeLocation(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_PagerNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_BusinessTelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_JobTitle(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeTelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Email2Address(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Spouse(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Email3Address(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Home2TelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeFaxNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_CarTelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_AssistantName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_AssistantTelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Children(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Categories(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_WebPage(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Business2TelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Title(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_FirstName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_MiddleName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_LastName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Suffix(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeAddressStreet(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeAddressCity(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeAddressState(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeAddressPostalCode(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_HomeAddressCountry(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_OtherAddressStreet(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_OtherAddressCity(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_OtherAddressState(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_OtherAddressPostalCode(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_OtherAddressCountry(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_BusinessAddressStreet(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_BusinessAddressCity(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_BusinessAddressState(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_BusinessAddressPostalCode(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_BusinessAddressCountry(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_RadioTelephoneNumber(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_FileAs(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Body(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_YomiCompanyName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_YomiFirstName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_YomiLastName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void put_Birthday(
			[In] double value);
		void put_Anniversary(
			[In] double value);
		void put_BusinessFaxNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_CompanyName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Department(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Email1Address(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_MobileTelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_OfficeLocation(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_PagerNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_BusinessTelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_JobTitle(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeTelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Email2Address(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Spouse(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Email3Address(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Home2TelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeFaxNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_CarTelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_AssistantName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_AssistantTelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Children(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Categories(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_WebPage(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Business2TelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Title(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_FirstName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_MiddleName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_LastName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Suffix(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeAddressStreet(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeAddressCity(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeAddressState(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeAddressPostalCode(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_HomeAddressCountry(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_OtherAddressStreet(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_OtherAddressCity(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_OtherAddressState(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_OtherAddressPostalCode(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_OtherAddressCountry(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_BusinessAddressStreet(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_BusinessAddressCity(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_BusinessAddressState(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_BusinessAddressPostalCode(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_BusinessAddressCountry(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_RadioTelephoneNumber(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_FileAs(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Body(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_YomiCompanyName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_YomiFirstName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_YomiLastName(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void Save();
		void Delete();
		void Copy(
			[Out] out IOutlookContact contact);
		void Display();
		void get_Oid(
			[Out] out int oid);
		void put_BodyInk(
			[In] ref Blob value);
		void get_BodyInk(
			[Out] out Blob value);
		void get_Application(
			[Out] out IOutlookApplication application);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
