﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("38F47300-270F-11d2-8F18-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookRecurrencePattern
	{
		void get_RecurrenceType(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookRecurrenceType value);
		void get_PatternStartDate(
			[Out] out double value);
		void get_StartTime(
			[Out] out double value);
		void get_EndTime(
			[Out] out double value);
		void get_PatternEndDate(
			[Out] out double value);
		void get_NoEndDate(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_Occurrences(
			[Out] out int value);
		void get_Interval(
			[Out] out int value);
		void get_DayOfWeekMask(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookDaysOfWeek value);
		void get_DayOfMonth(
			[Out] out int value);
		void get_Instance(
			[Out] out int value);
		void get_Duration(
			[Out] out int value);
		void get_MonthOfYear(
			[Out] out int value);
		void put_RecurrenceType(
			[In][MarshalAs(UnmanagedType.U4)] OutlookRecurrenceType value);
		void put_PatternStartDate(
			[In] double value);
		void put_StartTime(
			[In] double value);
		void put_EndTime(
			[In] double value);
		void put_PatternEndDate(
			[In] double value);
		void put_NoEndDate(
			[In][MarshalAs(UnmanagedType.VariantBool)] bool value);
		void put_Occurrences(
			[In] int value);
		void put_Interval(
			[In] int value);
		void put_DayOfWeekMask(
			[In][MarshalAs(UnmanagedType.U4)] OutlookDaysOfWeek value);
		void put_DayOfMonth(
			[In] int value);
		void put_Instance(
			[In] int value);
		void put_Duration(
			[In] int value);
		void put_MonthOfYear(
			[In] int value);
		void get_Exceptions(
			[Out] out IOutlookExceptions exceptions);
		void get_Application(
			[Out] out IOutlookApplication application);
		void GetOccurrence(
			[In] double date,
			[Out] out IOutlookAppointment appointment);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
