﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("37C78CE0-202C-11d2-8F18-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookTask
	{
		void ClearRecurrencePattern();
		void GetRecurrencePattern(
			[Out] out IOutlookRecurrencePattern recurrencePattern);
		void get_IsRecurring(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_Subject(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_Categories(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_StartDate(
			[Out] out double value);
		void get_DueDate(
			[Out] out double value);
		void get_DateCompleted(
			[Out] out double value);
		void get_Importance(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookPriority value);
		void get_Complete(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_Sensitivity(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookSensitivity value);
		void get_TeamTask(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_Body(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_ReminderSet(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_ReminderSoundFile(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_ReminderTime(
			[Out] out double value);
		void get_ReminderOptions(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookReminderOptions value);
		void put_Subject(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_Categories(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_StartDate(
			[In] double value);
		void put_DueDate(
			[In] double value);
		void put_Importance(
			[In][MarshalAs(UnmanagedType.U4)] OutlookPriority value);
		void put_Complete(
			[In][MarshalAs(UnmanagedType.VariantBool)] bool value);
		void put_Sensitivity(
			[In][MarshalAs(UnmanagedType.U4)] OutlookSensitivity value);
		void put_TeamTask(
			[In][MarshalAs(UnmanagedType.VariantBool)] bool value);
		void put_Body(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_ReminderSet(
			[In][MarshalAs(UnmanagedType.VariantBool)] bool value);
		void put_ReminderSoundFile(
			[In][MarshalAs(UnmanagedType.BStr)] string value);
		void put_ReminderTime(
			[In] double value);
		void put_ReminderOptions(
			[In][MarshalAs(UnmanagedType.U4)] OutlookReminderOptions value);
		void Save();
		void Delete();
		void SkipRecurrence();
		void Copy(
			[Out] out IOutlookTask task);
		void Display();
		void get_Oid(
			[Out] out int oid);
		void put_BodyInk(
			[In] ref Blob value);
		void get_BodyInk(
			[Out] out Blob value);
		void get_Application(
			[Out] out IOutlookApplication application);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
