﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	[ComImport]
	[Guid("78B27290-5256-11d2-8F1B-0000F87A4335")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	internal interface IOutlookTimezone
	{
		void get_Bias(
			[Out] out int value);
		void get_SupportsDST(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_IsStandardAbsoluteDate(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_IsDaylightAbsoluteDate(
			[Out][MarshalAs(UnmanagedType.VariantBool)] out bool value);
		void get_StandardBias(
			[Out] out int value);
		void get_StandardName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_StandardDate(
			[Out] out double value);
		void get_StandardDayOfWeekMask(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookDaysOfWeek value);
		void get_StandardInstance(
			[Out] out int value);
		void get_StandardMonthOfYear(
			[Out] out int value);
		void get_DaylightBias(
			[Out] out int value);
		void get_DaylightName(
			[Out][MarshalAs(UnmanagedType.BStr)] out string value);
		void get_DaylightDate(
			[Out] out double value);
		void get_DaylightDayOfWeekMask(
			[Out][MarshalAs(UnmanagedType.U4)] out OutlookDaysOfWeek value);
		void get_DaylightInstance(
			[Out] out int value);
		void get_DaylightMonthOfYear(
			[Out] out int value);
		void get_Application(
			[Out] out IOutlookApplication application);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
