﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu.Messaging
{
	internal enum OutlookFolderTypes : int
	{
		Calendar = 9,
		Contacts = 10,
		Tasks = 13,
		Cities = 101,
		Infrared = 102
	}

	internal enum OutlookItemTypes : int
	{
		Appointment = 1,
		Contact = 2,
		Task = 3,
		City = 102
	}

	public enum OutlookBusyStatus : int
	{
		Free = 0,
		Tentative = 1,
		Busy = 2,
		OutOfOffice = 3
	};

	public enum OutlookSensitivity : int
	{
		Normal = 0,
		Personal = 1,
		Private = 2,
		Confidential = 3
	};

	public enum OutlookMeetingStatus : int
	{
		NonMeeting = 0,
		Meeting = 1,
		MeetingAccepted = 3,
		MeetingCanceled = 7,
	};

	public enum OutlookRecurrenceType : int
	{
		Once = -1,
		Daily = 0,
		Weekly = 1,
		Monthly = 2,
		MonthNth = 3,
		Yearly = 5,
		YearNth = 6,
	};

	public enum OutlookPriority : int
	{
		Low = 0,
		Normal = 1,
		High = 2
	};

	[Flags]
	public enum OutlookDaysOfWeek
	{
		Sunday = 1,
		Monday = 2,
		Tuesday = 4,
		Wednesday = 8,
		Thursday = 16,
		Friday = 32,
		Saturday = 64,
	};

	[Flags]
	public enum OutlookReminderOptions : int
	{
		LED = 1,
		Vibrate = 2,
		Dialog = 4,
		Sound = 8,
		Repeat = 16,
	};

#pragma warning disable 649

	internal struct Blob
	{
		public int Size;
		public IntPtr Pointer;
	}

	internal struct SystemTime
	{
		public short Year;
		public short Month;
		public short DayOfWeek;
		public short Day;
		public short Hour;
		public short Minute;
		public short Second;
		public short Millisecond;
	}

	internal struct TimeZoneInfo
	{
		public int Bias;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
		public string StandardName;
		public SystemTime StandardDate;
		public int StandardBias;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
		public string DaylightName;
		public SystemTime DaylightDate;
		public int DaylightBias;
	}

#pragma warning restore 649

	[ComImport]
	[Guid("05058F23-20BE-11d2-8F18-0000F87A4335")]
	public class OutlookApplicationClass
	{
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
