﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Messaging Library                        */
/*       {_.-``-'         {_/   Copyright © 2005-2008, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Text;

namespace Nabu.Messaging
{
	public sealed class SmsSession : DisposableBase
	{
		#region SmsSession

		#region Fields

		private IntPtr _hSms;

		#endregion

		#region Methods

		public SmsSession()
		{
			NativeMethods.SmsOpen(
				"Microsoft Text SMS Protocol",
				SmsMode.Send,
				out this._hSms,
				IntPtr.Zero);
		}

		public void Send(string address, string text)
		{
			GsmAddress gsmAddress = new GsmAddress();

			gsmAddress.Type = GsmAddressType.Unknown;
			gsmAddress.Value = address;

			byte[] data = Encoding.Unicode.GetBytes(text);
			byte[] providerData = new byte[12];
			int messageID;

			NativeMethods.SmsSendMessage(
				this._hSms,
				IntPtr.Zero,
				ref gsmAddress,
				IntPtr.Zero,
				data,
				data.Length,
				providerData,
				providerData.Length,
				SmsEncoding.Optimal,
				0,
				out messageID);
		}

		#endregion

		#endregion

		#region DisposableBase

		protected override void Dispose(bool disposing)
		{
			NativeMethods.SmsClose(this._hSms);

			base.Dispose(disposing);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
