﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Mobile Library                           */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Mobile
{
	public sealed class MobileFileTimes
	{
		#region Fields

		private DateTime _creation;
		private DateTime _lastAccess;
		private DateTime _lastWrite;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal MobileFileTimes(
			DateTime creation,
			DateTime lastAccess,
			DateTime lastWrite)
		{
			this._creation = creation;
			this._lastAccess = lastAccess;
			this._lastWrite = lastWrite;
		}

		#endregion

		#region Properties

		public DateTime Creation
		{
			[DebuggerStepThrough]
			get { return this._creation; }
			[DebuggerStepThrough]
			set { this._creation = value; }
		}

		public DateTime LastAccess
		{
			[DebuggerStepThrough]
			get { return this._lastAccess; }
			[DebuggerStepThrough]
			set { this._lastAccess = value; }
		}

		public DateTime LastWrite
		{
			[DebuggerStepThrough]
			get { return this._lastWrite; }
			[DebuggerStepThrough]
			set { this._lastWrite = value; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
