﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Mobile Library                           */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Mobile
{
	public sealed class MobileSystemInfo
	{
		#region Fields

		private MobileProcessorArchitecture _processorArchitecture;
		private MobileProcessorType _processorType;
		private short _processorLevel;
		private short _processorRevision;
		private int _processorNumber;
		private int _processorMask;
		private int _minimumMemoryAddress;
		private int _maximumMemoryAddress;
		private int _memoryPage;
		private int _memoryGranularity;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public MobileSystemInfo(
			MobileProcessorArchitecture processorArchitecture,
			MobileProcessorType processorType,
			short processorLevel,
			short processorRevision,
			int processorNumber,
			int processorMask,
			int minimumMemoryAddress,
			int maximumMemoryAddress,
			int memoryPage,
			int memoryGranularity)
		{
			this._processorArchitecture = processorArchitecture;
			this._processorType = processorType;
			this._processorLevel = processorLevel;
			this._processorRevision = processorRevision;
			this._processorNumber = processorNumber;
			this._processorMask = processorMask;
			this._minimumMemoryAddress = minimumMemoryAddress;
			this._maximumMemoryAddress = maximumMemoryAddress;
			this._memoryPage = memoryPage;
			this._memoryGranularity = memoryGranularity;
		}

		#endregion

		#region Properties

		public MobileProcessorArchitecture ProcessorArchitecture
		{
			[DebuggerStepThrough]
			get { return this._processorArchitecture; }
		}

		public MobileProcessorType ProcessorType
		{
			[DebuggerStepThrough]
			get { return this._processorType; }
		}

		public short ProcessorLevel
		{
			[DebuggerStepThrough]
			get { return this._processorLevel; }
		}

		public short ProcessorRevision
		{
			[DebuggerStepThrough]
			get { return this._processorRevision; }
		}

		public int ProcessorNumber
		{
			[DebuggerStepThrough]
			get { return this._processorNumber; }
		}

		public int ProcessorMask
		{
			[DebuggerStepThrough]
			get { return this._processorMask; }
		}

		public int MinimumMemoryAddress
		{
			[DebuggerStepThrough]
			get { return this._minimumMemoryAddress; }
		}

		public int MaximumMemoryAddress
		{
			[DebuggerStepThrough]
			get { return this._maximumMemoryAddress; }
		}

		public int MemoryPage
		{
			[DebuggerStepThrough]
			get { return this._memoryPage; }
		}

		public int MemoryGranularity
		{
			[DebuggerStepThrough]
			get { return this._memoryGranularity; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
