﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Mobile Library                           */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Text;
using Microsoft.Win32;

namespace Nabu.Mobile
{
	[ComImport]
	[Guid("76a78b7d-8e54-4c06-ac38-459e6a1ab5e3")]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	unsafe internal interface IRapiSession
	{
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.U4)]
		ComResult CeRapiInit();

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.U4)]
		ComResult CeRapiUninit();

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.U4)]
		ComResult CeGetLastError();

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.U4)]
		ComResult CeRapiGetError();

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.U4)]
		ComResult CeRapiFreeBuffer(
			[In] IntPtr pointer);

		[PreserveSig]
		IntPtr CeFindFirstFile(
			[In][MarshalAs(UnmanagedType.LPWStr)] string mask,
			[Out] out FileFindData data);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeFindNextFile(
			[In] IntPtr hSearch,
			[Out] out FileFindData data);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeFindClose(
			[In] IntPtr hSearch);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.U4)]
		FileAttributes CeGetFileAttributes(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeSetFileAttributes(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In][MarshalAs(UnmanagedType.U4)] FileAttributes attributes);

		[PreserveSig]
		IntPtr CeCreateFile(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] uint access,
			[In][MarshalAs(UnmanagedType.U4)] FileShare shareMode,
			[In] IntPtr lpSecurityAttributes,
			[In][MarshalAs(UnmanagedType.U4)] FileMode mode,
			[In][MarshalAs(UnmanagedType.U4)] FileAttributes attributes,
			[In] IntPtr hTemplateFile);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeReadFile(
			[In] IntPtr hFile,
			[In] byte* lpDataBuffer,
			[In] int dataLength,
			[Out] out int bytesRead,
			[In] IntPtr lpOverlapped);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeWriteFile(
			[In] IntPtr hFile,
			[In] byte* lpDataBuffer,
			[In] int dataLength,
			[Out] out int bytesWritten,
			[In] IntPtr lpOverlapped);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeCloseHandle(
			[In] IntPtr hObject);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeFindAllFiles(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In][MarshalAs(UnmanagedType.U4)] FindAllFilesFlags flags,
			[Out] out int fileCount,
			[Out] out FileFindData[] lpFileBuffer);

		// STUB
		[PreserveSig]
		IntPtr CeFindFirstDatabase(
			[In] int databaseID);

		// STUB
		[PreserveSig]
		int CeFindNextDatabase(
			[In] IntPtr hSearch);

		// STUB
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeOidGetInfo(
			[In] int objectID,
			[In] IntPtr lpObjectInfo);

		// STUB
		[PreserveSig]
		int CeCreateDatabase(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] int databaseType,
			[In] int sortSpecificationNumber,
			[In][MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] SortSpecification[] sortSpecifications);

		// STUB
		[PreserveSig]
		IntPtr CeOpenDatabase(
			[Out] out int objectID,
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] int propertyID,
			[In] int flags,
			[In] IntPtr hWindowNotify);

		// STUB
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeDeleteDatabase(
			[In] int objectID);

		// STUB
		[PreserveSig]
		int CeReadRecordProps(
			[In] IntPtr hDatabase,
			[In] int flags,
			[In][Out] ref short propertyIDCount,
			[In][Out][MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] int[] propertyIDs,
			[In][Out] ref IntPtr lplpBuffer,
			[In][Out] ref int bufferSize);

		// STUB
		[PreserveSig]
		int CeWriteRecordProps(
			[In] IntPtr hDatabase,
			[In] int objectID,
			[In] short propertyValueCount,
			[In] IntPtr lpPropertyValues);

		// STUB
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeDeleteRecord(
			[In] IntPtr hDatabase,
			[In] int recordID);

		// STUB
		[PreserveSig]
		int CeSeekDatabase(
			[In] IntPtr hDatabase,
			[In] int seekType,
			[In] int value,
			[Out] out int index);

		// STUB
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeSetDatabaseInfo(
			[In] int objectID,
			[In] IntPtr lpInfo);

		[PreserveSig]
		int CeSetFilePointer(
			[In] IntPtr hFile,
			[In] int offset,
			[In][Out] ref int high32,
			[In][MarshalAs(UnmanagedType.U4)] SeekOrigin origin);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeSetEndOfFile(
			[In] IntPtr hFile);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeCreateDirectory(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] IntPtr lpSecurityAttributes);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeRemoveDirectory(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeCreateProcess(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In][MarshalAs(UnmanagedType.LPWStr)] string commandLine,
			[In] IntPtr lpProcessSecurityAttributes,
			[In] IntPtr lpThreadSecurityAttributes,
			[In] bool inheritHandles,
			[In] int flags,
			[In] IntPtr lpEnvironment,
			[In] IntPtr lpCurentDirectory,
			[In] IntPtr lpStartInfo,
			[Out] out ProcessInformation processInformation);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeMoveFile(
			[In][MarshalAs(UnmanagedType.LPWStr)] string sourcePath,
			[In][MarshalAs(UnmanagedType.LPWStr)] string destinationPath);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeCopyFile(
			[In][MarshalAs(UnmanagedType.LPWStr)] string sourcePath,
			[In][MarshalAs(UnmanagedType.LPWStr)] string destinationPath,
			bool failIfExists);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeDeleteFile(
		[In][MarshalAs(UnmanagedType.LPWStr)] string path);

		[PreserveSig]
		int CeGetFileSize(
			[In]IntPtr hFile,
			[Out]out int high32);

		[PreserveSig]
		SystemResult CeRegOpenKeyEx(
			[In] IntPtr hParentKey,
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] int reserved,
			[In][MarshalAs(UnmanagedType.U4)] MobileRegistryRights sam,
			[Out] out IntPtr hKey);

		[PreserveSig]
		SystemResult CeRegEnumKeyEx(
			[In] IntPtr hParentKey,
			[In] int index,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder name,
			[In][Out] ref int nameLength,
			[In] IntPtr reserved,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder class_,
			[In][Out] ref int classLength,
			[In] IntPtr lastWriteTime);

		[PreserveSig]
		SystemResult CeRegCreateKeyEx(
			[In] IntPtr hParentKey,
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In] int reserved,
			[In][MarshalAs(UnmanagedType.LPWStr)] string class_,
			[In] int options,
			[In][MarshalAs(UnmanagedType.U4)] MobileRegistryRights sam,
			[In] IntPtr lpSecurityAttributes,
			[Out] out IntPtr hKey,
			[Out] out int disposition);

		[PreserveSig]
		SystemResult CeRegCloseKey(
			[In] IntPtr hKey);

		[PreserveSig]
		SystemResult CeRegDeleteKey(
			[In] IntPtr hKey,
			[In][MarshalAs(UnmanagedType.LPWStr)] string name);

		[PreserveSig]
		SystemResult CeRegEnumValue(
			[In] IntPtr hKey,
			[In] int index,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder name,
			[In][Out] ref int nameLength,
			[In] IntPtr reserved,
			[Out][MarshalAs(UnmanagedType.U4)] out RegistryValueKind type,
			[Out][MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 7)] byte[] data,
			[In][Out] ref int dataLength);

		[PreserveSig]
		SystemResult CeRegDeleteValue(
			[In] IntPtr hKey,
			[In][MarshalAs(UnmanagedType.LPWStr)] string name);

		[PreserveSig]
		SystemResult CeRegQueryInfoKey(
			[In] IntPtr hKey,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder class_,
			[In][Out] ref int classLength,
			[In] IntPtr reserved,
			[Out] out int subKeyCount,
			[Out] out int subKeyMaxNameLength,
			[Out] out int subKeyMaxClassLength,
			[Out] out int valueCount,
			[Out] out int valueMaxNameLength,
			[Out] out int valueMaxDataLength,
			[In] IntPtr securityDescriptor,
			[In] IntPtr lastWriteTime);

		[PreserveSig]
		SystemResult CeRegQueryValueEx(
			[In] IntPtr hKey,
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In] IntPtr reserved,
			[Out][MarshalAs(UnmanagedType.U4)] out RegistryValueKind type,
			[In][Out][MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 5)] byte[] dataBuffer,
			[In][Out] ref int dataLength);

		[PreserveSig]
		SystemResult CeRegSetValueEx(
			[In] IntPtr hKey,
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In] IntPtr reserved,
			[In][MarshalAs(UnmanagedType.U4)] RegistryValueKind type,
			[In][MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 5)] byte[] dataBuffer,
			[In] int dataLength);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeGetStoreInformation(
			[Out] out StoreInformation storeInformation);

		[PreserveSig]
		int CeGetSystemMetrics(
			[In][MarshalAs(UnmanagedType.U4)] MobileSystemMetrics index);

		[PreserveSig]
		int CeGetDesktopDeviceCaps(
			[In][MarshalAs(UnmanagedType.U4)] MobileDeviceCaps index);

		// STUB
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeFindAllDatabases(
			[In] int databaseType,
			[In] short Flags,
			[Out] out int fileCount,
			[Out] out FileFindData[] lpFileBuffer);

		[PreserveSig]
		void CeGetSystemInfo(
			[Out] out SystemInfo systemInfo);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeSHCreateShortcut(
			[In][MarshalAs(UnmanagedType.LPWStr)] string shortcutPath,
			[In][MarshalAs(UnmanagedType.LPWStr)] string targetPath);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeSHGetShortcutTarget(
			[In][MarshalAs(UnmanagedType.LPWStr)] string shortcutPath,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder targetPath,
			[In] int targetPathLength);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeCheckPassword(
			[In][MarshalAs(UnmanagedType.LPWStr)] string password);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeGetFileTime(
			[In] IntPtr hFile,
			[Out] out long creationTime,
			[Out] out long lastAccessTime,
			[Out] out long lastWriteTime);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeSetFileTime(
		[In] IntPtr hFile,
			[In] ref long creationTime,
			[In] ref long lastAccessTime,
			[In] ref long lastWriteTime);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeGetVersionEx(
			[In][Out] ref OSVersionInfo osVersonInfo);

		[PreserveSig]
		IntPtr CeGetWindow(
			[In] IntPtr hWindow,
			[In][MarshalAs(UnmanagedType.U4)] GetWindowCommand command);

		[PreserveSig]
		int CeGetWindowLong(
			[In] IntPtr hWindow,
			[In] int index);

		[PreserveSig]
		int CeGetWindowText(
			[In] IntPtr hWindow,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder text,
			[In] int textLength);

		[PreserveSig]
		int CeGetClassName(
			[In] IntPtr hWindow,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder text,
			[In] int textLength);

		[PreserveSig]
		void CeGlobalMemoryStatus(
			[Out] out MemoryStatus memoryStatus);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeGetSystemPowerStatusEx(
			[Out] out SystemPowerStatusEx status,
			[In] bool forceUpdate);

		[PreserveSig]
		int CeGetTempPath(
			[In] int pathLength,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder path);

		[PreserveSig]
		int CeGetSpecialFolderPath(
			[In][MarshalAs(UnmanagedType.U4)] MobileSpecialFolder folder,
			[In] int pathLength,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder path);

		// STUB
		[PreserveSig]
		int CeRapiInvoke(
			[In][MarshalAs(UnmanagedType.LPWStr)] string dllPath,
			[In][MarshalAs(UnmanagedType.LPWStr)] string functionName,
			[In]int inputSize,
			[In] byte[] lpInputData,
			[In] ref int outputSize,
			[Out] out byte[] outputData,
			[Out] out IStream rapiStream,
			[In] int reserved);

		// STUB
		[PreserveSig]
		IntPtr CeFindFirstDatabaseEx(
			[In] ref Guid guid,
			[In] int databaseType);

		// STUB
		[PreserveSig]
		int CeFindNextDatabaseEx(
			[In] IntPtr hSearch,
			[In] ref Guid guid);

		// STUB
		[PreserveSig]
		int CeCreateDatabaseEx(
			[In] ref Guid guid,
			[In] IntPtr lpInfo);

		// STUB
		[PreserveSig]
		int CeSetDatabaseInfoEx(
			[In] ref Guid guid,
			[In] int objectID,
			[In] IntPtr lpInfo);

		// STUB
		[PreserveSig]
		IntPtr CeOpenDatabaseEx(
			[In] ref Guid guid,
			[Out] out int objectID,
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] int propID,
			[In] int flags,
			[In] IntPtr lpRequest);

		// STUB
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeDeleteDatabaseEx(
			[In] ref Guid guid,
			[In] int objectID);

		// STUB
		[PreserveSig]
		int CeReadRecordPropsEx(
			[In] IntPtr hDatabase,
			[In] int flags,
			[In][Out] ref short propertyIDCount,
			[Out] int[] propertyIDs,
			[In][Out] ref IntPtr lplpBuffer,
			[In][Out] ref int bufferSize,
			[In] IntPtr hHeap);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeMountDBVol(
			[In] ref Guid guid,
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[In] int flags);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeUnmountDBVol(
			[In] ref Guid guid);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeFlushDBVol(
			[In] ref Guid guid);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeEnumDBVolumes(
			[In] ref Guid guid,
			[In][Out][MarshalAs(UnmanagedType.LPWStr)] StringBuilder buffer,
			[In]int bufferLength);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeOidGetInfoEx(
			[In] ref Guid guid,
			[In] int objectID,
			[In] IntPtr lpInfo);

		void CeSyncStart(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path);

		void CeSyncStop();

		// TODO
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeQueryInstructionSet(
			[In] int instructionSet,
			[Out] out int currentInstructionSet);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Bool)]
		bool CeGetDiskFreeSpaceEx(
			[In][MarshalAs(UnmanagedType.LPWStr)] string path,
			[Out] out long freeBytesAvailableToCaller,
			[Out] out long totalNumberOfBytes,
			[Out] out long totalNumberOfFreeBytes);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
