﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics.CodeAnalysis;
using System.Net;

namespace Nabu.Net
{
	public static class SocketUtil
	{
		[SuppressMessage("Microsoft.Design", "CA1031:DoNotCatchGeneralExceptionTypes")]
		public static IPAddress IPAddressFromHostName(string hostname)
		{
			try
			{
				if (
					(hostname == "localhost") ||
					(hostname == "local") ||
					(hostname == "."))
				{
					return IPAddress.Loopback;
				}
				else if (
					(hostname == "*") ||
					(hostname == "?"))
				{
					return IPAddress.Any;
				}
				else
				{
					IPHostEntry hostEntry = Dns.GetHostEntry(hostname);

					return hostEntry.AddressList[Environment.TickCount % hostEntry.AddressList.Length];
				}
			}
			catch
			{
				return IPAddress.None;
			}
		}
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
