﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics.CodeAnalysis;
using System.Net.Security;
using System.Security.Authentication;
using System.Security.Cryptography.X509Certificates;

namespace Nabu.Net
{
	public interface ITcpNodeCallback<TSession>
	{
		void OnOpenSession(
			TSession session);

		void OnCloseSession(
			TSession session);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "4#")]
		void OnSslAuthenticate(
			TSession session,
			out X509CertificateCollection certificates,
			out SslProtocols enabledSslProtocols,
			out bool mutualAuthenticationRequired,
			out bool checkCertificateRevocation);

		bool OnSslValidateCertificate(
			TSession session,
			X509Certificate certificate,
			X509Chain chain,
			SslPolicyErrors sslPolicyErrors);

		X509Certificate OnSslSelectCertificate(
			TSession session,
			string targetHost,
			X509CertificateCollection localCertificates,
			X509Certificate remoteCertificate,
			string[] acceptableIssuers);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
