﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Net;
using System.Security.Authentication;

namespace Nabu.Net
{
	public interface ITcpNodeSocket : IDisposable
	{
		#region Methods

		IAsyncResult BeginSend(
			byte[] buffer,
			int offset,
			int count,
			AsyncCallback callback,
			object state);

		void EndSend(IAsyncResult asyncResult);

		IAsyncResult BeginReceive(
			byte[] buffer,
			int offset,
			int count,
			AsyncCallback callback,
			object state);

		int EndReceive(IAsyncResult asyncResult);

		#endregion

		#region Properties

		bool IsConnected { get; }
		bool IsEncrypted { get; }
		bool IsSigned { get; }
		bool IsAuthenticated { get; }
		bool IsMutuallyAuthenticated { get; }
		SslProtocols SslProtocol { get; }
		EndPoint LocalEndPoint { get; }
		EndPoint RemoteEndPoint { get; }

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
