﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Security.Authentication;
using System.Security.Cryptography.X509Certificates;

namespace Nabu.Net
{
	public interface ITcpServerSocketListen : IDisposable
	{
		void Listen(
			string hostname,
			int port);

		ITcpServerSocketIO Accept(ITcpSecurityCallback securityCallback);
	}

	public interface ITcpServerSocketIO : ITcpNodeSocket
	{
		void AuthenticateAsServer(
			X509Certificate serverCertificate,
			bool clientCertificateRequired,
			SslProtocols enabledSslProtocols,
			bool checkCertificateRevocation);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
