﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics.CodeAnalysis;
using System.Net;

namespace Nabu.Net
{
	public interface IUdpServerSocket : IDisposable
	{
		void Bind(string hostname, int port);

		IAsyncResult BeginReceiveFrom(
			byte[] buffer,
			int offset,
			int size,
			AsyncCallback callback,
			object state);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		int EndReceiveFrom(
			out IPEndPoint address,
			IAsyncResult asyncResult);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
