﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Net
{
	public interface IPop3ClientCallback<TSocket> :
		ITcpNodeCallback<Pop3ClientSession<TSocket>>
		where TSocket : ITcpClientSocket, new()
	{
		void OnError(
			Pop3ClientSession<TSocket> session,
			Pop3ClientState state,
			string text);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void OnCredentials(
			Pop3ClientSession<TSocket> session,
			out string hostname,
			out string username,
			out string password);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void OnRequest(
			Pop3ClientSession<TSocket> session,
			out Pop3ClientRequest request);

		void OnStat(
			Pop3ClientSession<TSocket> session,
			int messageTotalCount,
			int messageTotalSize);

		void OnList(
			Pop3ClientSession<TSocket> session,
			IDictionary<int, int> messageSizes);

		void OnUidl(
			Pop3ClientSession<TSocket> session,
			IDictionary<int, string> messageUIDs);

		void OnTop(
			Pop3ClientSession<TSocket> session,
			ArraySegment<byte> segment);

		void OnRetrive(
			Pop3ClientSession<TSocket> session,
			ArraySegment<byte> segment);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
