﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;
namespace Nabu.Net
{
	public sealed class Pop3ClientRequest
	{
		#region Fields

		private Pop3ClientRequestType _type;
		private int _messageIndex;
		private int _lineIndex;

		#endregion

		#region Methods

		public Pop3ClientRequest(
			Pop3ClientRequestType type,
			int messageIndex,
			int lineIndex)
		{
			this._type = type;
			this._messageIndex = messageIndex;
			this._lineIndex = lineIndex;
		}

		public Pop3ClientRequest(
			Pop3ClientRequestType type,
			int messageIndex)
		{
			this._type = type;
			this._messageIndex = messageIndex;
		}

		public Pop3ClientRequest(
			Pop3ClientRequestType type)
		{
			this._type = type;
		}

		#endregion

		#region Properties

		public Pop3ClientRequestType Type
		{
			[DebuggerStepThrough]
			get { return this._type; }
		}

		public int MessageIndex
		{
			[DebuggerStepThrough]
			get { return this._messageIndex; }
		}

		public int LineIndex
		{
			[DebuggerStepThrough]
			get { return this._lineIndex; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
