﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Net
{
	public interface IPop3ServerCallback<TSocket> :
		ITcpNodeCallback<Pop3ServerSession<TSocket>>
		where TSocket : ITcpServerSocketIO
	{
		void OnError(
			Pop3ServerSession<TSocket> session,
			Pop3ServerState state,
			string text);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void OnCredentials(
			Pop3ServerSession<TSocket> session,
			out bool isValid);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		void OnStat(
			Pop3ServerSession<TSocket> session,
			out int totalCount,
			out int totalSize);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void OnList(
			Pop3ServerSession<TSocket> session,
			int index,
			out bool isFound,
			out int size);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void OnList(
			Pop3ServerSession<TSocket> session,
			out IDictionary<int, int> messages);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void OnUidl(
			Pop3ServerSession<TSocket> session,
			int index,
			out bool isFound,
			out string uid);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void OnUidl(
			Pop3ServerSession<TSocket> session,
			out IDictionary<int, string> messages);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void OnRetr(
			Pop3ServerSession<TSocket> session,
			int index,
			out bool isFound,
			out ArraySegment<byte> segment);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void OnTop(
			Pop3ServerSession<TSocket> session,
			int index,
			out bool isFound,
			out ArraySegment<byte> segment);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		void OnDele(
			Pop3ServerSession<TSocket> session,
			int index,
			out bool isFound);

		void OnRset(
			Pop3ServerSession<TSocket> session);

		void OnQuit(
			Pop3ServerSession<TSocket> session);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
