﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Net
{
	public interface ISmtpClientCallback<TSocket> :
		ITcpNodeCallback<SmtpClientSession<TSocket>>
		where TSocket : ITcpClientSocket, new()
	{
		void OnError(
			SmtpClientSession<TSocket> session,
			SmtpClientState state,
			string text,
			int code);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void OnCredentials(
			SmtpClientSession<TSocket> session,
			out string hostname,
			out string username,
			out string password);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void OnRequest(
			SmtpClientSession<TSocket> session,
			out SmtpClientRequest request);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		void OnMessage(
			SmtpClientSession<TSocket> session,
			out ArraySegment<byte> segment,
			out bool isLast);

		void OnVerify(
			SmtpClientSession<TSocket> session,
			bool isValid,
			bool isLocal);

		void OnExpand(
			SmtpClientSession<TSocket> session,
			IEnumerable<string> addresses);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
