﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.Diagnostics;

namespace Nabu.Net
{
	public sealed class SmtpClientRequest
	{
		#region Fields

		private SmtpClientRequestType _type;
		private string _sourceAddress;
		private IEnumerable<string> _destinationAddresses;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public SmtpClientRequest(
			SmtpClientRequestType type,
			string sourceAddress,
			IEnumerable<string> destinationAddresses)
		{
			this._type = type;
			this._sourceAddress = sourceAddress;
			this._destinationAddresses = destinationAddresses;
		}

		[DebuggerStepThrough]
		public SmtpClientRequest(
			SmtpClientRequestType type,
			string sourceAddress)
		{
			this._type = type;
			this._sourceAddress = sourceAddress;
		}

		[DebuggerStepThrough]
		public SmtpClientRequest(
			SmtpClientRequestType type)
		{
			this._type = type;
		}

		#endregion

		#region Properties

		public SmtpClientRequestType Type
		{
			[DebuggerStepThrough]
			get { return this._type; }
		}

		public string SourceAddress
		{
			[DebuggerStepThrough]
			get { return this._sourceAddress; }
		}

		public IEnumerable<string> DestinationAddresses
		{
			[DebuggerStepThrough]
			get { return this._destinationAddresses; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
