﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Net Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Nabu.Net
{
	public interface ISmtpServerCallback<TSocket> :
		ITcpNodeCallback<SmtpServerSession<TSocket>>
		where TSocket : ITcpServerSocketIO
	{
		void OnError(
			SmtpServerSession<TSocket> session,
			SmtpServerState state,
			string text);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void OnCredentials(
			SmtpServerSession<TSocket> session,
			out bool isValid);

		void OnSend(
			SmtpServerSession<TSocket> session,
			IEnumerable<string> senders,
			IEnumerable<string> recipients,
			ArraySegment<byte> data);

		void OnRset(
			SmtpServerSession<TSocket> session);

		void OnQuit(
			SmtpServerSession<TSocket> session);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
