﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Ole Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics.CodeAnalysis;

using Nabu;

namespace System.Runtime.InteropServices.ComTypes
{
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("00000100-0000-0000-C000-000000000046")]
	public interface IEnumUnknown
	{
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult Next(
			[In] int elementCount,
			[Out][MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.IUnknown, SizeParamIndex = 0)] object[] rgelt,
			[Out] out int elementCountFetched);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult Skip(
			[In] int elementCount);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult Reset();

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult Clone(
			[Out][MarshalAs(UnmanagedType.Interface)] out IEnumUnknown enumUnknown);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
