﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Ole Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics.CodeAnalysis;
using System.Drawing;

using Nabu;

namespace System.Runtime.InteropServices.ComTypes
{
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("00000112-0000-0000-C000-000000000046")]
	public interface IOleObject
	{
		void SetClientSite(
			[In][MarshalAs(UnmanagedType.Interface)] IOleClientSite oleClientSite);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		void GetClientSite(
			[Out][MarshalAs(UnmanagedType.Interface)] out IOleClientSite oleClientSite);

		void SetHostNames(
			[In][MarshalAs(UnmanagedType.LPWStr)] string containerApplication,
			[In][MarshalAs(UnmanagedType.LPWStr)] string containerObject);

		void Close(
			[In] int saveOption);

		void SetMoniker(
			[In] int whichMoniker,
			[In][MarshalAs(UnmanagedType.Interface)] IMoniker moniker);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "2#")]
		void GetMoniker(
			[In] int assign,
			[In] int whichMoniker,
			[Out][MarshalAs(UnmanagedType.Interface)] out IMoniker moniker);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult InitFromData(
			[In][MarshalAs(UnmanagedType.Interface)] IDataObject dataObject,
			[In] int creation,
			[In] int reserved);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void GetClipboardData(
			[In] int reserved,
			[Out][MarshalAs(UnmanagedType.Interface)] out IDataObject dataObject);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult DoVerb(
			[In] int verb,
			[In][MarshalAs(UnmanagedType.LPArray)] MSG[] message,
			[In][MarshalAs(UnmanagedType.Interface)] IOleClientSite oleActiveSite,
			[In] int index,
			[In] IntPtr hWndParent,
			[In][MarshalAs(UnmanagedType.LPArray)] Rectangle[] lprcPosRect);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult EnumVerbs(
			[MarshalAs(UnmanagedType.Interface)] out IEnumOLEVERB enumOleVerb);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult Update();

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult IsUpToDate();

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		void GetUserClassID(
			[Out] out Guid pClsid);

		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetUserType(
			[In] int formOfType,
			[In] IntPtr userType);

		void SetExtent(
			[In] int drawAspect,
			[In][MarshalAs(UnmanagedType.LPArray)] Size[] size);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void GetExtent(
			[In] int drawAspect,
			[Out][MarshalAs(UnmanagedType.LPArray)] Size[] size);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		void Advise(
			[In] IAdviseSink adviseSink,
			[Out] out int connection);

		void Unadvise(
			[In] int connection);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		void EnumAdvise(
			[Out][MarshalAs(UnmanagedType.Interface)] out IEnumSTATDATA ppenumAdvise);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "1#")]
		[PreserveSig]
		[return: MarshalAs(UnmanagedType.Error)]
		ComResult GetMiscStatus(
			[In] int aspect,
			[Out] out int status);

		void SetColorScheme(
			[In][MarshalAs(UnmanagedType.LPArray)] LOGPALETTE[] logPalette);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
