﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Ole Library                              */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics.CodeAnalysis;

namespace System.Runtime.InteropServices.ComTypes
{
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("0000000B-0000-0000-C000-000000000046")]
	public interface IStorage
	{
		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "4#")]
		void CreateStream(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In] int grfMode,
			[In] int reserved1,
			[In] int reserved2,
			[Out][MarshalAs(UnmanagedType.Interface)] out IStream stream);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "4#")]
		void OpenStream(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In] IntPtr reserved1,
			[In] int grfMode,
			[In] int reserved2,
			[Out][MarshalAs(UnmanagedType.Interface)] out IStream steam);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "4#")]
		void CreateStorage(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In] int grfMode,
			[In] int reserved1,
			[In] int reserved2,
			[Out][MarshalAs(UnmanagedType.Interface)] out IStorage storage);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "5#")]
		void OpenStorage(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In][MarshalAs(UnmanagedType.Interface)] IStorage storagePriority,
			[In] int grfMode,
			[In] IntPtr stringNameBlockExclude,
			[In] int reserved,
			[Out][MarshalAs(UnmanagedType.Interface)] out IStorage storage);

		void CopyTo(
			[In] int countIIDExclude,
			[In][MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 0)] Guid[] IIDExclude,
			[In] IntPtr stringNameBlockExclude,
			[In][MarshalAs(UnmanagedType.Interface)] IStorage storage);

		void MoveElementTo(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In][MarshalAs(UnmanagedType.Interface)] IStorage storage,
			[In][MarshalAs(UnmanagedType.LPWStr)] string nameNew,
			[In] int grfFlags);

		void Commit(
			[In] int grfCommitFlags);

		void Revert();

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "3#")]
		void EnumElements(
			[In] int reserved1,
			[In] IntPtr reserved2,
			[In] int reserved3,
			[Out][MarshalAs(UnmanagedType.Interface)] out IEnumSTATSTG enumSTATSTG);

		void DestroyElement(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name);

		void RenameElement(
			[In][MarshalAs(UnmanagedType.LPWStr)] string nameOld,
			[In][MarshalAs(UnmanagedType.LPWStr)] string nameNew);

		void SetElementTimes(
			[In][MarshalAs(UnmanagedType.LPWStr)] string name,
			[In][MarshalAs(UnmanagedType.LPArray)] FILETIME[] creationTime,
			[In][MarshalAs(UnmanagedType.LPArray)] FILETIME[] accessTime,
			[In][MarshalAs(UnmanagedType.LPArray)] FILETIME[] modificationTime);

		[SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "0#")]
		void SetClass(
			[In] ref Guid clsid);

		void SetStateBits(
			[In] int grfStateBits,
			[In] int grfMask);

		[SuppressMessage("Microsoft.Design", "CA1021:AvoidOutParameters", MessageId = "0#")]
		void Stat(
			[Out][MarshalAs(UnmanagedType.LPArray)] STATSTG[] statStg,
			[In] int grfStatFlag);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
