﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Reflection Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Reflection
{
	public interface IScriptExecutionEngine : IDisposable
	{
		IntPtr CreateInstance(
			string scopeName,
			string typeName);
		void DestroyInstance(
			IntPtr cookie);
		object InvokeMethod(
			string scopeName,
			string typeName,
			string methodName,
			params object[] arguments);
		object InvokeMethod(
			IntPtr cookie,
			string methodName,
			params object[] arguments);
		object GetProperty(
			string scopeName,
			string typeName,
			string propertyName);
		object GetProperty(
			IntPtr cookie,
			string propertyName);
		void SetProperty(
			string scopeName,
			string typeName,
			string propertyName,
			object propertyValue);
		void SetProperty(
			IntPtr cookie,
			string propertyName,
			object propertyValue);
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
