﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Reflection Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

using Nabu.Text;

namespace Nabu.Reflection
{
	public sealed class ScriptEngineCompilerMessage
	{
		#region Fields

		private TextPosition _codePosition;
		private TextPosition _textPosition;
		private string _messageID;
		private string _messageText;
		private bool _isWarning;
		private bool _isError;

		#endregion

		#region Methods

		public ScriptEngineCompilerMessage(
			TextPosition codePosition,
			TextPosition textPosition,
			string messageID,
			string messageText,
			bool isWarning,
			bool isError)
		{
			this._codePosition = codePosition;
			this._textPosition = textPosition;
			this._messageID = messageID;
			this._messageText = messageText;
			this._isWarning = isWarning;
			this._isError = isError;
		}

		#endregion

		#region Properties

		public TextPosition CodePosition
		{
			[DebuggerStepThrough]
			get { return this._codePosition; }
		}

		public TextPosition TextPosition
		{
			[DebuggerStepThrough]
			get { return this._textPosition; }
		}

		public string MessageID
		{
			[DebuggerStepThrough]
			get { return this._messageID; }
		}

		public string MessageText
		{
			[DebuggerStepThrough]
			get { return this._messageText; }
		}

		public bool IsWarning
		{
			[DebuggerStepThrough]
			get { return this._isWarning; }
		}

		public bool IsError
		{
			[DebuggerStepThrough]
			get { return this._isError; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
