﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Reflection Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;

namespace Nabu.Reflection
{
	public sealed class ManagedScriptUnsecureExecutionHost : ManagedScriptExecutionHostBase
	{
		#region ManagedScriptUnsecureExecutionHost

		#region Fields

		private string _applicationBase;

		#endregion

		#region Methods

		public ManagedScriptUnsecureExecutionHost()
		{
			this._applicationBase = AppDomain.CurrentDomain.SetupInformation.ApplicationBase;
		}

		public ManagedScriptUnsecureExecutionHost(string applicationBase)
		{
			this._applicationBase = applicationBase;
		}

		#endregion

		#endregion

		#region ManagedScriptExecutionHostBase

		protected override AppDomain CreateDomain()
		{
			AppDomainSetup setup = new AppDomainSetup();

			setup.ApplicationBase = this._applicationBase;

			return
				AppDomain.CreateDomain(
					this.GetType().Name,
					null,
					setup);
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
