﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Reflection Library                       */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Collections.Generic;
using System.Globalization;

using Nabu.Text;

namespace Nabu.Reflection
{
	public sealed class PaxScriptExecutionHost : IScriptExecutionHost
	{
		#region PaxScriptExecutionHost

		#region Methods

		public PaxScriptExecutionHost()
		{
		}

		#endregion

		#endregion

		#region IScriptExecutionHost

		public IScriptExecutionEngine CreateEngine(
			IEnumerable<ISourceCodeUnit> sourceCodeUnits,
			IDictionary<string, object> globalItems)
		{
			string language = null;

			foreach (ISourceCodeUnit sourceCodeUnit in sourceCodeUnits)
			{
				language = sourceCodeUnit.Language;
				break;
			}

			switch (language.ToUpper(CultureInfo.InvariantCulture))
			{
				case "C#":
				case "C#v2.0":
				case "C#v3.0":
				case "C#v3.5":
					return
						new PaxScriptExecutionEngine(
							this,
							sourceCodeUnits,
							globalItems);
				default:
					throw new NotImplementedException(language);
			}
		}

		#endregion

		#region IDisposable

		public void Dispose()
		{
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
