﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu.Text
{
	public sealed class CodeTextLineChangedEventArgs : EventArgs
	{
		#region Fields

		private int _offset;
		private int _count;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		internal CodeTextLineChangedEventArgs(
			int offset,
			int count)
		{
			this._offset = offset;
			this._count = count;
		}

		#endregion

		#region Properties

		public int Offset
		{
			[DebuggerStepThrough]
			get { return this._offset; }
		}

		public int Count
		{
			[DebuggerStepThrough]
			get { return this._count; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
