﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Text
{
	public sealed class CodeTextLineSegment<T>
	{
		#region Fields

		private T _format;
		private string _text;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public CodeTextLineSegment(
			T format,
			string text)
		{
			this._format = format;
			this._text = text;
		}

		#endregion

		#region Properties

		public T Format
		{
			[DebuggerStepThrough]
			get { return this._format; }
		}

		public string Text
		{
			[DebuggerStepThrough]
			get { return this._text; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
