﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Text
{
	[System.Diagnostics.DebuggerDisplay("Length: {_length}; Format: {_format}")]
	internal sealed class CodeTextLineSegmentInfo<T>
	{
		#region Fields

		private T _format;
		private int _length;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public CodeTextLineSegmentInfo(
			T format,
			int length)
		{
			this._format = format;
			this._length = length;
		}

		#endregion

		#region Properties

		public T Format
		{
			[DebuggerStepThrough]
			get { return this._format; }
		}

		public int Length
		{
			[DebuggerStepThrough]
			get { return this._length; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
