﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
namespace Nabu.Text
{
	public interface ISourceCodeGenerator
	{
		void BeginSource();
		void EndSource();
		void BeginImport();
		void EndImport();
		void BeginCode();
		void EndCode();
		void BeginContentCode();
		void EndContentCode();
		void BeginFeatureCode();
		void EndFeatureCode();
		void Import(string import);
		void Text(TextPosition startPosition, TextPosition endPosition, string value);
		void Code(TextPosition startPosition, TextPosition endPosition, string value);
		void Expression(TextPosition startPosition, TextPosition endPosition, string value);

		IGeneratedSourceCodeUnit SourceCode { get; }
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
