﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.IO;

namespace Nabu.Text
{
	public sealed class SingleTemplateAccessor : ITemplateAccessor
	{
		#region SingleTemplateAccessor

		#region Constants

		private const string TemplateExceptionMessage = "Template not found.";

		#endregion

		#region Fields

		private string _name;
		private string[] _content;

		#endregion

		#region Methods

		public SingleTemplateAccessor(string name, string[] content)
		{
			this._name = name;
			this._content = content;
		}

		#endregion

		#endregion

		#region ITemplateAccessor

		public string[] GetContent(string templateName)
		{
			if (templateName == this._name)
			{
				return this._content;
			}
			else
			{
#if COMPACT_FRAMEWORK
				throw new FileNotFoundException(templateName);
#else
				throw new FileNotFoundException(TemplateExceptionMessage, templateName);
#endif
			}
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
