﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;
namespace Nabu.Text
{
	public sealed class TemplateProperty
	{
		#region Fields

		private string _name;
		private string _type;
		private string _converter;
		private string _editor;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public TemplateProperty(
			string name,
			string type,
			string converter,
			string editor)
		{
			this._name = name;
			this._type = type;
			this._converter = converter;
			this._editor = editor;
		}

		#endregion

		#region Properties

		public string Name
		{
			[DebuggerStepThrough]
			get { return this._name; }
		}

		public string Type
		{
			[DebuggerStepThrough]
			get { return this._type; }
		}

		public string Converter
		{
			[DebuggerStepThrough]
			get { return this._converter; }
		}

		public string Editor
		{
			[DebuggerStepThrough]
			get { return this._editor; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
