﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu.Text
{
#if !COMPACT_FRAMEWORK
	[System.Diagnostics.DebuggerDisplay("{SourceStart}:{SourceEnd} -> {DestinationStart}:{DestinationEnd}")]
#endif
	public class TextPositionMap
	{
		#region Fields

		private TextPosition _sourceStart;
		private TextPosition _sourceEnd;
		private TextPosition _destinationStart;
		private TextPosition _destinationEnd;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public TextPositionMap(
			TextPosition sourceStart,
			TextPosition sourceEnd,
			TextPosition destinationStart,
			TextPosition destinationEnd)
		{
			this._sourceStart = sourceStart;
			this._sourceEnd = sourceEnd;
			this._destinationStart = destinationStart;
			this._destinationEnd = destinationEnd;
		}

		#endregion

		#region Properties

		public TextPosition SourceStart
		{
			[DebuggerStepThrough]
			get { return this._sourceStart; }
		}

		public TextPosition SourceEnd
		{
			[DebuggerStepThrough]
			get { return this._sourceEnd; }
		}

		public TextPosition DestinationStart
		{
			[DebuggerStepThrough]
			get { return this._destinationStart; }
		}

		public TextPosition DestinationEnd
		{
			[DebuggerStepThrough]
			get { return this._destinationEnd; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
