﻿using Nabu.Collections;

using NUnit.Framework;

namespace Nabu.UnitTest.nUnit.Nabu.Collections
{
	[TestFixture]
	public class ListExTest
	{
		[Test]
		public void Add()
		{
			ListEx<int> list = new ListEx<int>();

			for (int index = 1; index <= 100; index++)
			{
				list.Add(index);

				Assert.AreEqual(index, list.Count);
			}
		}

		[Test]
		public void Remove()
		{
			ListEx<int> list = new ListEx<int>();

			for (int index = 1; index <= 100; index++)
			{
				list.Add(index);
			}

			for (int index = 100; index > 0; --index)
			{
				Assert.AreEqual(index, list.Count);
				Assert.AreEqual(true, list.Remove(index));
			}
		}

		[Test]
		public void IndexOf()
		{
			ListEx<int> list = new ListEx<int>();

			for (int index = 1; index <= 100; index++)
			{
				list.Add(index);
			}

			for (int index = 1; index <= 100; index++)
			{
				Assert.AreEqual(index - 1, list.IndexOf(index));
			}

			Assert.AreEqual(-1, list.IndexOf(0));
			Assert.AreEqual(-1, list.IndexOf(101));
		}
	}
}
