﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu Library                                  */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Collections.Generic;
using System.Diagnostics;

namespace Nabu
{
	public sealed class CommandLineNamedArgument
	{
		#region Fields

		private readonly IList<object> _parameterValues = new List<object>();
		private readonly bool _action;

		#endregion

		#region Methods

		public CommandLineNamedArgument(bool action)
		{
			this._action = action;
		}

		#endregion

		#region Properties

		public IList<object> ParameterValues
		{
			[DebuggerStepThrough]
			get { return this._parameterValues; }
		}

		public bool Action
		{
			[DebuggerStepThrough]
			get { return this._action; }
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
