﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu Library                                  */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Diagnostics;

namespace Nabu
{
	public sealed class CommandLineParameterDescriptor
	{
		#region Fields

		private readonly string _name;
		private readonly Type _type;

		#endregion

		#region Methods

		public CommandLineParameterDescriptor(string name)
		{
			this._name = name;
			this._type = typeof(string);
		}

		public CommandLineParameterDescriptor(string name, Type type)
		{
			this._name = name;
			this._type = type;
		}

		#endregion

		#region Properties

		public string Name
		{
			[DebuggerStepThrough]
			get { return this._name; }
		}

		public Type Type
		{
			[DebuggerStepThrough]
			get { return this._type; }
		}

		#endregion
	};
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
