﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu Library                                  */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Runtime.InteropServices;

namespace Nabu
{
	public abstract class DynamicInterop
	{
		#region Fields

		private IntPtr _hModule;

		#endregion

		#region Methods

		protected DynamicInterop(IntPtr hModule)
		{
			this._hModule = hModule;
		}

#if COMPACT_FRAMEWORK
		protected IntPtr GetProcAddress(string name)
		{
			return NativeMethods.GetProcAddress(this._hModule, name);
		}
#else
		protected T GetProcAddress<T>(string name) where T : class
		{
			return
				Marshal.GetDelegateForFunctionPointer(
					NativeMethods.GetProcAddress(this._hModule, name),
					typeof(T)) as T;
		}
#endif

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
