﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu Library                                  */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System.Diagnostics;

namespace Nabu
{
	public sealed class Range<T>
	{
		#region Fields

		private readonly T _start;
		private readonly T _end;

		#endregion

		#region Methods

		[DebuggerStepThrough]
		public Range(T start, T end)
		{
			this._start = start;
			this._end = end;
		}

		#endregion

		#region Properties

		public T Start
		{
			[DebuggerStepThrough]
			get { return this._start; }
		}

		public T End
		{
			[DebuggerStepThrough]
			get { return this._end; }
		}

		public T Offset
		{
			[DebuggerStepThrough]
			get { return this._start; }
		}

		public int Count
		{
			[DebuggerStepThrough]
			get { return (int)(object)this._end - (int)(object)this._start; }
		}

		public long Count64
		{
			[DebuggerStepThrough]
			get { return (long)(object)this._end - (long)(object)this._start; }
		}

		#endregion
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
