﻿/******************************************************************************/
/*                                                                            */
/*    _                ___        _..-._                                      */
/*    \`.|\..----...-'`   `-._.-'' _.-..'                                     */
/*    /  ' `         ,       __.-''                                           */
/*    )/` _/     \   `-_,   /                                                 */
/*    `-'" `"\_  ,_.-;_.-\_ ',  NABU Project                                  */
/*        _.-'_./   {_.'   ; /  Nabu.Text Library                             */
/*       {_.-``-'         {_/   Copyright © 2005-2009, TrifleSoft             */
/*                                                                            */
/******************************************************************************/
using System;
using System.Globalization;

namespace Nabu.Text
{
	public static class WordCase
	{
		public static string ToLower(string value)
		{
			return ToLower(value, CultureInfo.CurrentCulture);
		}

		public static string ToLower(string value, CultureInfo cultureInfo)
		{
			if (cultureInfo == null)
			{
				throw new ArgumentNullException("cultureInfo");
			}

			return cultureInfo.TextInfo.ToLower(value);
		}

		public static string ToUpper(string value)
		{
			return ToUpper(value, CultureInfo.CurrentCulture);
		}

		public static string ToUpper(string value, CultureInfo cultureInfo)
		{
			if (cultureInfo == null)
			{
				throw new ArgumentNullException("cultureInfo");
			}

			return cultureInfo.TextInfo.ToUpper(value);
		}

		public static string ToTitle(string value)
		{
			return ToTitle(value, CultureInfo.CurrentCulture);
		}

		public static string ToTitle(string value, CultureInfo cultureInfo)
		{
			if (cultureInfo == null)
			{
				throw new ArgumentNullException("cultureInfo");
			}

			return cultureInfo.TextInfo.ToTitleCase(value);
		}
	}
}
/******************************************************************************/
/*                                END OF FILE                                 */
/******************************************************************************/
