﻿using System;
using System.IO;


namespace Nabu.DirectoryCleanUp
{
	public sealed class Program
	{
		public static void ProcessDirectory(
			string rootPath,
			string directoryNameVictim)
		{
			string[] directoryPaths = Directory.GetDirectories(rootPath);

			foreach (string directoryPath in directoryPaths)
			{
				string directoryName = Path.GetFileName(directoryPath).ToLower();

				if (directoryName == directoryNameVictim)
				{
					Console.WriteLine("Deleting '{0}'", directoryPath);
					Directory.Delete(directoryPath, true);
				}
				else
				{
					ProcessDirectory(directoryPath, directoryNameVictim);
				}
			}
		}

		public static void Main(string[] args)
		{
			CommandLine commandLine = new CommandLine(args);

			commandLine.AddNamed(
				"r",
				"Root directory path.",
				true,
				new CommandLineParameterDescriptor("root"));

			commandLine.AddNamed(
				"d",
				"Directory name to delete.",
				true,
				new CommandLineParameterDescriptor("victim"));

			if (commandLine.Parse())
			{
				ProcessDirectory(
					(string)commandLine.GetNamedValue("r").ParameterValues[0],
					((string)commandLine.GetNamedValue("d").ParameterValues[0]).ToLower());
			}
		}
	}
}
